/* password-dialog.c generated by valac 0.18.0, the Vala compiler
 * generated from password-dialog.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "geary-static.h"
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_PASSWORD_DIALOG (password_dialog_get_type ())
#define PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PASSWORD_DIALOG, PasswordDialog))
#define PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PASSWORD_DIALOG, PasswordDialogClass))
#define IS_PASSWORD_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PASSWORD_DIALOG))
#define IS_PASSWORD_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PASSWORD_DIALOG))
#define PASSWORD_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PASSWORD_DIALOG, PasswordDialogClass))

typedef struct _PasswordDialog PasswordDialog;
typedef struct _PasswordDialogClass PasswordDialogClass;
typedef struct _PasswordDialogPrivate PasswordDialogPrivate;

#define TYPE_PASSWORD_TYPE_FLAG (password_type_flag_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPasswordDialog ParamSpecPasswordDialog;

struct _PasswordDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PasswordDialogPrivate * priv;
};

struct _PasswordDialogClass {
	GTypeClass parent_class;
	void (*finalize) (PasswordDialog *self);
};

typedef enum  {
	PASSWORD_TYPE_FLAG_IMAP = 1 << 0,
	PASSWORD_TYPE_FLAG_SMTP = 1 << 1
} PasswordTypeFlag;

struct _PasswordDialogPrivate {
	GtkDialog* dialog;
	GtkEntry* entry_imap_password;
	GtkCheckButton* check_imap_remember_password;
	GtkEntry* entry_smtp_password;
	GtkCheckButton* check_smtp_remember_password;
	GtkButton* ok_button;
	GtkGrid* grid_imap;
	GtkGrid* grid_smtp;
	PasswordTypeFlag password_flags;
	gchar* _imap_password;
	gchar* _smtp_password;
	gboolean _imap_remember_password;
	gboolean _smtp_remember_password;
};

struct _ParamSpecPasswordDialog {
	GParamSpec parent_instance;
};


static gpointer password_dialog_parent_class = NULL;

gpointer password_dialog_ref (gpointer instance);
void password_dialog_unref (gpointer instance);
GParamSpec* param_spec_password_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_password_dialog (GValue* value, gpointer v_object);
void value_take_password_dialog (GValue* value, gpointer v_object);
gpointer value_get_password_dialog (const GValue* value);
GType password_dialog_get_type (void) G_GNUC_CONST;
GType password_type_flag_get_type (void) G_GNUC_CONST;
#define PASSWORD_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PASSWORD_DIALOG, PasswordDialogPrivate))
enum  {
	PASSWORD_DIALOG_DUMMY_PROPERTY
};
#define PASSWORD_DIALOG_PRIMARY_TEXT_MARKUP "<span weight=\"bold\" size=\"larger\">%s</span>"
#define PASSWORD_DIALOG_PRIMARY_TEXT_FIRST_TRY _ ("Please enter your email password")
#define PASSWORD_DIALOG_PRIMARY_TEXT_REPEATED_TRY _ ("Unable to login to email server")
PasswordDialog* password_dialog_new (GearyAccountInformation* account_information, gboolean first_try, PasswordTypeFlag password_flags);
PasswordDialog* password_dialog_construct (GType object_type, GearyAccountInformation* account_information, gboolean first_try, PasswordTypeFlag password_flags);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void);
GtkBuilder* geary_application_create_builder (GearyApplication* self, const gchar* ui_filename);
static gchar* password_dialog_get_primary_text_markup (PasswordDialog* self, gboolean first_try);
static void password_dialog_refresh_ok_button_sensitivity (PasswordDialog* self);
static void _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed (GtkEditable* _sender, gpointer self);
gboolean password_dialog_run (PasswordDialog* self);
gboolean password_type_flag_has_imap (PasswordTypeFlag self);
gboolean password_type_flag_has_smtp (PasswordTypeFlag self);
static void password_dialog_set_imap_password (PasswordDialog* self, const gchar* value);
static void password_dialog_set_imap_remember_password (PasswordDialog* self, gboolean value);
static void password_dialog_set_smtp_password (PasswordDialog* self, const gchar* value);
static void password_dialog_set_smtp_remember_password (PasswordDialog* self, gboolean value);
const gchar* password_dialog_get_imap_password (PasswordDialog* self);
const gchar* password_dialog_get_smtp_password (PasswordDialog* self);
gboolean password_dialog_get_imap_remember_password (PasswordDialog* self);
gboolean password_dialog_get_smtp_remember_password (PasswordDialog* self);
static void password_dialog_finalize (PasswordDialog* obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 128 "password-dialog.c"
}


static void _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	password_dialog_refresh_ok_button_sensitivity (self);
#line 135 "password-dialog.c"
}


PasswordDialog* password_dialog_construct (GType object_type, GearyAccountInformation* account_information, gboolean first_try, PasswordTypeFlag password_flags) {
	PasswordDialog* self = NULL;
	PasswordTypeFlag _tmp0_;
	GearyApplication* _tmp1_;
	GearyApplication* _tmp2_;
	GtkBuilder* _tmp3_ = NULL;
	GtkBuilder* builder;
	GtkBuilder* _tmp4_;
	GObject* _tmp5_ = NULL;
	GtkDialog* _tmp6_;
	GtkDialog* _tmp7_;
	GtkDialog* _tmp8_;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_ = NULL;
	GtkEntry* _tmp11_;
	GtkBuilder* _tmp12_;
	GObject* _tmp13_ = NULL;
	GtkCheckButton* _tmp14_;
	GtkBuilder* _tmp15_;
	GObject* _tmp16_ = NULL;
	GtkEntry* _tmp17_;
	GtkBuilder* _tmp18_;
	GObject* _tmp19_ = NULL;
	GtkCheckButton* _tmp20_;
	GtkBuilder* _tmp21_;
	GObject* _tmp22_ = NULL;
	GtkLabel* _tmp23_;
	GtkLabel* label_real_name;
	GtkBuilder* _tmp24_;
	GObject* _tmp25_ = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* label_service;
	GtkBuilder* _tmp27_;
	GObject* _tmp28_ = NULL;
	GtkGrid* _tmp29_;
	GtkBuilder* _tmp30_;
	GObject* _tmp31_ = NULL;
	GtkLabel* _tmp32_;
	GtkLabel* label_imap_username;
	GtkBuilder* _tmp33_;
	GObject* _tmp34_ = NULL;
	GtkLabel* _tmp35_;
	GtkLabel* label_imap_server;
	GtkBuilder* _tmp36_;
	GObject* _tmp37_ = NULL;
	GtkLabel* _tmp38_;
	GtkLabel* label_imap_port;
	GtkBuilder* _tmp39_;
	GObject* _tmp40_ = NULL;
	GtkLabel* _tmp41_;
	GtkLabel* label_imap_encryption;
	GtkBuilder* _tmp42_;
	GObject* _tmp43_ = NULL;
	GtkGrid* _tmp44_;
	GtkBuilder* _tmp45_;
	GObject* _tmp46_ = NULL;
	GtkLabel* _tmp47_;
	GtkLabel* label_smtp_username;
	GtkBuilder* _tmp48_;
	GObject* _tmp49_ = NULL;
	GtkLabel* _tmp50_;
	GtkLabel* label_smtp_server;
	GtkBuilder* _tmp51_;
	GObject* _tmp52_ = NULL;
	GtkLabel* _tmp53_;
	GtkLabel* label_smtp_port;
	GtkBuilder* _tmp54_;
	GObject* _tmp55_ = NULL;
	GtkLabel* _tmp56_;
	GtkLabel* label_smtp_encryption;
	GtkBuilder* _tmp57_;
	GObject* _tmp58_ = NULL;
	GtkLabel* _tmp59_;
	GtkLabel* primary_text_label;
	GtkLabel* _tmp60_;
	gboolean _tmp61_;
	gchar* _tmp62_ = NULL;
	gchar* _tmp63_;
	GearyEndpoint* imap_endpoint = NULL;
	GearyEndpoint* smtp_endpoint = NULL;
	GearyEndpoint* _tmp71_;
	const gchar* _tmp72_;
	const gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* imap_server_host;
	GearyEndpoint* _tmp75_;
	guint16 _tmp76_;
	guint16 _tmp77_;
	guint16 imap_server_port;
	GearyEndpoint* _tmp78_;
	GearyEndpointFlags _tmp79_;
	GearyEndpointFlags _tmp80_;
	gboolean imap_server_ssl;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* smtp_server_host;
	guint16 _tmp84_;
	guint16 _tmp85_;
	guint16 smtp_server_port;
	GearyEndpointFlags _tmp86_;
	GearyEndpointFlags _tmp87_;
	gboolean smtp_server_ssl;
	GearyAccountInformation* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	const gchar* _tmp93_;
	GtkLabel* _tmp95_;
	const gchar* _tmp96_;
	GearyAccountInformation* _tmp97_;
	GearyServiceProvider _tmp98_;
	GearyServiceProvider _tmp99_;
	gchar* _tmp100_ = NULL;
	gchar* _tmp101_;
	const gchar* _tmp102_;
	GtkLabel* _tmp104_;
	const gchar* _tmp105_;
	GearyAccountInformation* _tmp106_;
	GearyCredentials* _tmp107_;
	GearyCredentials* _tmp108_;
	const gchar* _tmp109_;
	const gchar* _tmp110_;
	gchar* _tmp111_;
	gchar* _tmp112_;
	const gchar* _tmp113_;
	GtkLabel* _tmp115_;
	const gchar* _tmp116_;
	GearyAccountInformation* _tmp117_;
	GearyCredentials* _tmp118_;
	GearyCredentials* _tmp119_;
	const gchar* _tmp120_;
	const gchar* _tmp121_;
	gchar* _tmp122_;
	gchar* _tmp123_;
	const gchar* _tmp124_;
	GtkEntry* _tmp126_;
	const gchar* _tmp127_;
	GtkCheckButton* _tmp128_;
	GearyAccountInformation* _tmp129_;
	gboolean _tmp130_;
	gboolean _tmp131_;
	GtkLabel* _tmp132_;
	const gchar* _tmp133_;
	GtkLabel* _tmp134_;
	guint16 _tmp135_;
	gchar* _tmp136_ = NULL;
	gchar* _tmp137_;
	const gchar* _tmp138_ = NULL;
	gboolean _tmp139_;
	GtkLabel* _tmp140_;
	const gchar* _tmp141_;
	GearyAccountInformation* _tmp142_;
	GearyCredentials* _tmp143_;
	GearyCredentials* _tmp144_;
	const gchar* _tmp145_;
	const gchar* _tmp146_;
	gchar* _tmp147_;
	gchar* _tmp148_;
	const gchar* _tmp149_;
	GtkLabel* _tmp151_;
	const gchar* _tmp152_;
	GearyAccountInformation* _tmp153_;
	GearyCredentials* _tmp154_;
	GearyCredentials* _tmp155_;
	const gchar* _tmp156_;
	const gchar* _tmp157_;
	gchar* _tmp158_;
	gchar* _tmp159_;
	const gchar* _tmp160_;
	GtkEntry* _tmp162_;
	const gchar* _tmp163_;
	GtkCheckButton* _tmp164_;
	GearyAccountInformation* _tmp165_;
	gboolean _tmp166_;
	gboolean _tmp167_;
	GtkLabel* _tmp168_;
	const gchar* _tmp169_;
	GtkLabel* _tmp170_;
	guint16 _tmp171_;
	gchar* _tmp172_ = NULL;
	gchar* _tmp173_;
	const gchar* _tmp174_ = NULL;
	gboolean _tmp175_;
	GtkLabel* _tmp176_;
	const gchar* _tmp177_;
	GtkButton* _tmp178_;
	GtkButton* cancel_button;
	GtkButton* _tmp179_;
	GtkButton* _tmp180_;
	GtkDialog* _tmp181_;
	GtkDialog* _tmp182_;
	GtkButton* _tmp183_;
	GtkDialog* _tmp184_;
	GtkEntry* _tmp185_;
	GtkEntry* _tmp186_;
	GError * _inner_error_ = NULL;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account_information), NULL);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self = (PasswordDialog*) g_type_create_instance (object_type);
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = password_flags;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->password_flags = _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = geary_application_get_instance ();
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp2_ = _tmp1_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp3_ = geary_application_create_builder (_tmp2_, "password-dialog.glade");
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	builder = _tmp3_;
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp4_ = builder;
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp5_ = gtk_builder_get_object (_tmp4_, "PasswordDialog");
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GTK_TYPE_DIALOG, GtkDialog));
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->dialog = _tmp6_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp7_ = self->priv->dialog;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_window_set_type_hint (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_WINDOW, GtkWindow), GDK_WINDOW_TYPE_HINT_DIALOG);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp8_ = self->priv->dialog;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_dialog_set_default_response (_tmp8_, (gint) GTK_RESPONSE_OK);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp9_ = builder;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp10_ = gtk_builder_get_object (_tmp9_, "entry: imap password");
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_ENTRY, GtkEntry));
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->entry_imap_password = _tmp11_;
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp12_ = builder;
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp13_ = gtk_builder_get_object (_tmp12_, "check: imap remember_password");
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_CHECK_BUTTON, GtkCheckButton));
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_imap_remember_password);
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->check_imap_remember_password = _tmp14_;
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp15_ = builder;
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp16_ = gtk_builder_get_object (_tmp15_, "entry: smtp password");
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GTK_TYPE_ENTRY, GtkEntry));
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->entry_smtp_password = _tmp17_;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp18_ = builder;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp19_ = gtk_builder_get_object (_tmp18_, "check: smtp remember_password");
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_CHECK_BUTTON, GtkCheckButton));
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_smtp_remember_password);
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->check_smtp_remember_password = _tmp20_;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp21_ = builder;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp22_ = gtk_builder_get_object (_tmp21_, "label: real_name");
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp23_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GTK_TYPE_LABEL, GtkLabel));
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_real_name = _tmp23_;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp24_ = builder;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp25_ = gtk_builder_get_object (_tmp24_, "label: service");
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GTK_TYPE_LABEL, GtkLabel));
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_service = _tmp26_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp27_ = builder;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp28_ = gtk_builder_get_object (_tmp27_, "grid: imap");
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GTK_TYPE_GRID, GtkGrid));
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->grid_imap);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->grid_imap = _tmp29_;
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp30_ = builder;
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp31_ = gtk_builder_get_object (_tmp30_, "label: imap username");
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp32_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GTK_TYPE_LABEL, GtkLabel));
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_imap_username = _tmp32_;
#line 56 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp33_ = builder;
#line 56 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp34_ = gtk_builder_get_object (_tmp33_, "label: imap server");
#line 56 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GTK_TYPE_LABEL, GtkLabel));
#line 56 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_imap_server = _tmp35_;
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp36_ = builder;
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp37_ = gtk_builder_get_object (_tmp36_, "label: imap port");
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp38_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GTK_TYPE_LABEL, GtkLabel));
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_imap_port = _tmp38_;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp39_ = builder;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp40_ = gtk_builder_get_object (_tmp39_, "label: imap encryption");
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GTK_TYPE_LABEL, GtkLabel));
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_imap_encryption = _tmp41_;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp42_ = builder;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp43_ = gtk_builder_get_object (_tmp42_, "grid: smtp");
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp44_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GTK_TYPE_GRID, GtkGrid));
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->grid_smtp);
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->grid_smtp = _tmp44_;
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp45_ = builder;
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp46_ = gtk_builder_get_object (_tmp45_, "label: smtp username");
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp47_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GTK_TYPE_LABEL, GtkLabel));
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_smtp_username = _tmp47_;
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp48_ = builder;
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp49_ = gtk_builder_get_object (_tmp48_, "label: smtp server");
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp50_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GTK_TYPE_LABEL, GtkLabel));
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_smtp_server = _tmp50_;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp51_ = builder;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp52_ = gtk_builder_get_object (_tmp51_, "label: smtp port");
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GTK_TYPE_LABEL, GtkLabel));
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_smtp_port = _tmp53_;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp54_ = builder;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp55_ = gtk_builder_get_object (_tmp54_, "label: smtp encryption");
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp56_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GTK_TYPE_LABEL, GtkLabel));
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	label_smtp_encryption = _tmp56_;
#line 67 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp57_ = builder;
#line 67 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp58_ = gtk_builder_get_object (_tmp57_, "primary_text_label");
#line 67 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp59_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GTK_TYPE_LABEL, GtkLabel));
#line 67 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	primary_text_label = _tmp59_;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp60_ = primary_text_label;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp61_ = first_try;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp62_ = password_dialog_get_primary_text_markup (self, _tmp61_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp63_ = _tmp62_;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_markup (_tmp60_, _tmp63_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp63_);
#line 531 "password-dialog.c"
	{
		GearyAccountInformation* _tmp64_;
		GearyEndpoint* _tmp65_ = NULL;
		GearyEndpoint* _tmp66_;
		GearyAccountInformation* _tmp67_;
		GearyEndpoint* _tmp68_ = NULL;
		GearyEndpoint* _tmp69_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp64_ = account_information;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp65_ = geary_account_information_get_imap_endpoint (_tmp64_, &_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp66_ = _tmp65_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		if (_inner_error_ != NULL) {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			if (_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 549 "password-dialog.c"
				goto __catch38_geary_engine_error;
			}
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (smtp_endpoint);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (imap_endpoint);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (primary_text_label);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_encryption);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_port);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_server);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_username);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_encryption);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_port);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_server);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_username);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_service);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_real_name);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (builder);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			return NULL;
#line 586 "password-dialog.c"
		}
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (imap_endpoint);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		imap_endpoint = _tmp66_;
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp67_ = account_information;
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp68_ = geary_account_information_get_smtp_endpoint (_tmp67_, &_inner_error_);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp69_ = _tmp68_;
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		if (_inner_error_ != NULL) {
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			if (_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 602 "password-dialog.c"
				goto __catch38_geary_engine_error;
			}
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (smtp_endpoint);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (imap_endpoint);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (primary_text_label);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_encryption);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_port);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_server);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_smtp_username);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_encryption);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_port);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_server);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_imap_username);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_service);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (label_real_name);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			_g_object_unref0 (builder);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			g_clear_error (&_inner_error_);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			return NULL;
#line 639 "password-dialog.c"
		}
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (smtp_endpoint);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		smtp_endpoint = _tmp69_;
#line 645 "password-dialog.c"
	}
	goto __finally38;
	__catch38_geary_engine_error:
	{
		GError* err = NULL;
		const gchar* _tmp70_;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		err = _inner_error_;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp70_ = err->message;
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_error ("password-dialog.vala:77: Error getting endpoints: %s", _tmp70_);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_error_free0 (err);
#line 662 "password-dialog.c"
	}
	__finally38:
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_inner_error_ != NULL) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (smtp_endpoint);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (imap_endpoint);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (primary_text_label);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_smtp_encryption);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_smtp_port);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_smtp_server);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_smtp_username);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_imap_encryption);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_imap_port);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_imap_server);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_imap_username);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_service);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (label_real_name);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_object_unref0 (builder);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_clear_error (&_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		return NULL;
#line 701 "password-dialog.c"
	}
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp71_ = imap_endpoint;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp72_ = geary_endpoint_get_host_specifier (_tmp71_);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp73_ = _tmp72_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp74_ = g_strdup (_tmp73_);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	imap_server_host = _tmp74_;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp75_ = imap_endpoint;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp76_ = geary_endpoint_get_default_port (_tmp75_);
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp77_ = _tmp76_;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	imap_server_port = _tmp77_;
#line 82 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp78_ = imap_endpoint;
#line 82 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp79_ = geary_endpoint_get_flags (_tmp78_);
#line 82 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp80_ = _tmp79_;
#line 82 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	imap_server_ssl = (_tmp80_ & GEARY_ENDPOINT_FLAGS_SSL) != 0;
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp81_ = geary_endpoint_get_host_specifier (smtp_endpoint);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp82_ = _tmp81_;
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp83_ = g_strdup (_tmp82_);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	smtp_server_host = _tmp83_;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp84_ = geary_endpoint_get_default_port (smtp_endpoint);
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp85_ = _tmp84_;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	smtp_server_port = _tmp85_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp86_ = geary_endpoint_get_flags (smtp_endpoint);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp87_ = _tmp86_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	smtp_server_ssl = (_tmp87_ & GEARY_ENDPOINT_FLAGS_SSL) != 0;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp88_ = account_information;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp89_ = geary_account_information_get_real_name (_tmp88_);
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp90_ = _tmp89_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp91_ = g_strdup (_tmp90_);
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp92_ = _tmp91_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp93_ = _tmp92_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp93_ == NULL) {
#line 763 "password-dialog.c"
		gchar* _tmp94_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp94_ = g_strdup ("");
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp92_);
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp92_ = _tmp94_;
#line 771 "password-dialog.c"
	}
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp95_ = label_real_name;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp96_ = _tmp92_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp95_, _tmp96_);
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp97_ = account_information;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp98_ = geary_account_information_get_service_provider (_tmp97_);
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp99_ = _tmp98_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp100_ = geary_service_provider_display_name (_tmp99_);
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp101_ = _tmp100_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp102_ = _tmp101_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp102_ == NULL) {
#line 793 "password-dialog.c"
		gchar* _tmp103_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp103_ = g_strdup ("");
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp101_);
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp101_ = _tmp103_;
#line 801 "password-dialog.c"
	}
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp104_ = label_service;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp105_ = _tmp101_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp104_, _tmp105_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp106_ = account_information;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp107_ = geary_account_information_get_imap_credentials (_tmp106_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp108_ = _tmp107_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp109_ = geary_credentials_get_user (_tmp108_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp110_ = _tmp109_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp111_ = g_strdup (_tmp110_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp112_ = _tmp111_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp113_ = _tmp112_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp113_ == NULL) {
#line 827 "password-dialog.c"
		gchar* _tmp114_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp114_ = g_strdup ("");
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp112_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp112_ = _tmp114_;
#line 835 "password-dialog.c"
	}
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp115_ = label_imap_username;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp116_ = _tmp112_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp115_, _tmp116_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp117_ = account_information;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp118_ = geary_account_information_get_imap_credentials (_tmp117_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp119_ = _tmp118_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp120_ = geary_credentials_get_pass (_tmp119_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp121_ = _tmp120_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp122_ = g_strdup (_tmp121_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp123_ = _tmp122_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp124_ = _tmp123_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp124_ == NULL) {
#line 861 "password-dialog.c"
		gchar* _tmp125_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp125_ = g_strdup ("");
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp123_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp123_ = _tmp125_;
#line 869 "password-dialog.c"
	}
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp126_ = self->priv->entry_imap_password;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp127_ = _tmp123_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_entry_set_text (_tmp126_, _tmp127_);
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp128_ = self->priv->check_imap_remember_password;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp129_ = account_information;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp130_ = geary_account_information_get_imap_remember_password (_tmp129_);
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp131_ = _tmp130_;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp128_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), _tmp131_);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp132_ = label_imap_server;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp133_ = imap_server_host;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp132_, _tmp133_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp134_ = label_imap_port;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp135_ = imap_server_port;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp136_ = g_strdup_printf ("%hu", _tmp135_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp137_ = _tmp136_;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp134_, _tmp137_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp137_);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp139_ = imap_server_ssl;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp139_) {
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp138_ = "on";
#line 911 "password-dialog.c"
	} else {
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp138_ = "off";
#line 915 "password-dialog.c"
	}
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp140_ = label_imap_encryption;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp141_ = _tmp138_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp140_, _tmp141_);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp142_ = account_information;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp143_ = geary_account_information_get_smtp_credentials (_tmp142_);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp144_ = _tmp143_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp145_ = geary_credentials_get_user (_tmp144_);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp146_ = _tmp145_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp147_ = g_strdup (_tmp146_);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp148_ = _tmp147_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp149_ = _tmp148_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp149_ == NULL) {
#line 941 "password-dialog.c"
		gchar* _tmp150_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp150_ = g_strdup ("");
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp148_);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp148_ = _tmp150_;
#line 949 "password-dialog.c"
	}
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp151_ = label_smtp_username;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp152_ = _tmp148_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp151_, _tmp152_);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp153_ = account_information;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp154_ = geary_account_information_get_smtp_credentials (_tmp153_);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp155_ = _tmp154_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp156_ = geary_credentials_get_pass (_tmp155_);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp157_ = _tmp156_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp158_ = g_strdup (_tmp157_);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp159_ = _tmp158_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp160_ = _tmp159_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp160_ == NULL) {
#line 975 "password-dialog.c"
		gchar* _tmp161_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp161_ = g_strdup ("");
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_g_free0 (_tmp159_);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp159_ = _tmp161_;
#line 983 "password-dialog.c"
	}
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp162_ = self->priv->entry_smtp_password;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp163_ = _tmp159_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_entry_set_text (_tmp162_, _tmp163_);
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp164_ = self->priv->check_smtp_remember_password;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp165_ = account_information;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp166_ = geary_account_information_get_smtp_remember_password (_tmp165_);
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp167_ = _tmp166_;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp164_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), _tmp167_);
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp168_ = label_smtp_server;
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp169_ = smtp_server_host;
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp168_, _tmp169_);
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp170_ = label_smtp_port;
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp171_ = smtp_server_port;
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp172_ = g_strdup_printf ("%hu", _tmp171_);
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp173_ = _tmp172_;
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp170_, _tmp173_);
#line 103 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp173_);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp175_ = smtp_server_ssl;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp175_) {
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp174_ = "on";
#line 1025 "password-dialog.c"
	} else {
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp174_ = "off";
#line 1029 "password-dialog.c"
	}
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp176_ = label_smtp_encryption;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp177_ = _tmp174_;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_label_set_text (_tmp176_, _tmp177_);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp178_ = (GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CANCEL);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_object_ref_sink (_tmp178_);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	cancel_button = _tmp178_;
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp179_ = (GtkButton*) gtk_button_new_from_stock (GTK_STOCK_OK);
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_object_ref_sink (_tmp179_);
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->ok_button = _tmp179_;
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp180_ = self->priv->ok_button;
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_widget_set_can_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp180_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp181_ = self->priv->dialog;
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_dialog_add_action_widget (_tmp181_, G_TYPE_CHECK_INSTANCE_CAST (cancel_button, GTK_TYPE_WIDGET, GtkWidget), (gint) GTK_RESPONSE_CANCEL);
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp182_ = self->priv->dialog;
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp183_ = self->priv->ok_button;
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_dialog_add_action_widget (_tmp182_, G_TYPE_CHECK_INSTANCE_CAST (_tmp183_, GTK_TYPE_WIDGET, GtkWidget), (gint) GTK_RESPONSE_OK);
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp184_ = self->priv->dialog;
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_dialog_set_default_response (_tmp184_, (gint) GTK_RESPONSE_OK);
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	password_dialog_refresh_ok_button_sensitivity (self);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp185_ = self->priv->entry_imap_password;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp185_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed, self);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp186_ = self->priv->entry_smtp_password;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp186_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _password_dialog_refresh_ok_button_sensitivity_gtk_editable_changed, self);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (cancel_button);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp159_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp148_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp123_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp112_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp101_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (_tmp92_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (smtp_server_host);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (imap_server_host);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (smtp_endpoint);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (imap_endpoint);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (primary_text_label);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_smtp_encryption);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_smtp_port);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_smtp_server);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_smtp_username);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_imap_encryption);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_imap_port);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_imap_server);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_imap_username);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_service);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (label_real_name);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (builder);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return self;
#line 1127 "password-dialog.c"
}


PasswordDialog* password_dialog_new (GearyAccountInformation* account_information, gboolean first_try, PasswordTypeFlag password_flags) {
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return password_dialog_construct (TYPE_PASSWORD_DIALOG, account_information, first_try, password_flags);
#line 1134 "password-dialog.c"
}


static gchar* password_dialog_get_primary_text_markup (PasswordDialog* self, gboolean first_try) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), NULL);
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = first_try;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp1_) {
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp0_ = PASSWORD_DIALOG_PRIMARY_TEXT_FIRST_TRY;
#line 1152 "password-dialog.c"
	} else {
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp0_ = PASSWORD_DIALOG_PRIMARY_TEXT_REPEATED_TRY;
#line 1156 "password-dialog.c"
	}
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp2_ = _tmp0_;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp3_ = g_strdup_printf (PASSWORD_DIALOG_PRIMARY_TEXT_MARKUP, _tmp2_);
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp3_;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1166 "password-dialog.c"
}


static void password_dialog_refresh_ok_button_sensitivity (PasswordDialog* self) {
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GtkButton* _tmp7_;
	gboolean _tmp8_;
#line 124 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = self->priv->entry_imap_password;
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp3_ = geary_string_is_empty_or_whitespace (_tmp2_);
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (!_tmp3_) {
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp0_ = TRUE;
#line 1189 "password-dialog.c"
	} else {
		GtkEntry* _tmp4_;
		const gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp4_ = self->priv->entry_smtp_password;
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp6_ = geary_string_is_empty_or_whitespace (_tmp5_);
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp0_ = !_tmp6_;
#line 1202 "password-dialog.c"
	}
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp7_ = self->priv->ok_button;
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp8_ = _tmp0_;
#line 125 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_WIDGET, GtkWidget), _tmp8_);
#line 1210 "password-dialog.c"
}


gboolean password_dialog_run (PasswordDialog* self) {
	gboolean result = FALSE;
	GtkDialog* _tmp0_;
	GtkDialog* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	PasswordTypeFlag _tmp3_;
	gboolean _tmp4_ = FALSE;
	PasswordTypeFlag _tmp6_;
	gboolean _tmp7_ = FALSE;
	GtkDialog* _tmp9_;
	gint _tmp10_ = 0;
	GtkResponseType response;
	GtkResponseType _tmp11_;
	GtkDialog* _tmp22_;
	GtkResponseType _tmp23_;
#line 129 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), FALSE);
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->dialog;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget));
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = self->priv->dialog;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp2_ = gtk_dialog_get_action_area (_tmp1_);
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_widget_show_all (_tmp2_);
#line 133 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp3_ = self->priv->password_flags;
#line 133 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp4_ = password_type_flag_has_imap (_tmp3_);
#line 133 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (!_tmp4_) {
#line 1247 "password-dialog.c"
		GtkGrid* _tmp5_;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp5_ = self->priv->grid_imap;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GTK_TYPE_WIDGET, GtkWidget));
#line 1253 "password-dialog.c"
	}
#line 136 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp6_ = self->priv->password_flags;
#line 136 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp7_ = password_type_flag_has_smtp (_tmp6_);
#line 136 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (!_tmp7_) {
#line 1261 "password-dialog.c"
		GtkGrid* _tmp8_;
#line 137 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp8_ = self->priv->grid_smtp;
#line 137 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GTK_TYPE_WIDGET, GtkWidget));
#line 1267 "password-dialog.c"
	}
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp9_ = self->priv->dialog;
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp10_ = gtk_dialog_run (_tmp9_);
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	response = (GtkResponseType) _tmp10_;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp11_ = response;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (_tmp11_ == GTK_RESPONSE_OK) {
#line 1279 "password-dialog.c"
		GtkEntry* _tmp12_;
		const gchar* _tmp13_ = NULL;
		GtkCheckButton* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkEntry* _tmp17_;
		const gchar* _tmp18_ = NULL;
		GtkCheckButton* _tmp19_;
		gboolean _tmp20_;
		gboolean _tmp21_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp12_ = self->priv->entry_imap_password;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp13_ = gtk_entry_get_text (_tmp12_);
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_set_imap_password (self, _tmp13_);
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp14_ = self->priv->check_imap_remember_password;
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp15_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton));
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp16_ = _tmp15_;
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_set_imap_remember_password (self, _tmp16_);
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp17_ = self->priv->entry_smtp_password;
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp18_ = gtk_entry_get_text (_tmp17_);
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_set_smtp_password (self, _tmp18_);
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp19_ = self->priv->check_smtp_remember_password;
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp20_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton));
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		_tmp21_ = _tmp20_;
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_set_smtp_remember_password (self, _tmp21_);
#line 1318 "password-dialog.c"
	}
#line 147 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp22_ = self->priv->dialog;
#line 147 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GTK_TYPE_WIDGET, GtkWidget));
#line 149 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp23_ = response;
#line 149 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp23_ == GTK_RESPONSE_OK;
#line 149 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1330 "password-dialog.c"
}


const gchar* password_dialog_get_imap_password (PasswordDialog* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), NULL);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->_imap_password;
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp0_;
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1345 "password-dialog.c"
}


static void password_dialog_set_imap_password (PasswordDialog* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = value;
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_imap_password);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_imap_password = _tmp1_;
#line 1362 "password-dialog.c"
}


const gchar* password_dialog_get_smtp_password (PasswordDialog* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), NULL);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->_smtp_password;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1377 "password-dialog.c"
}


static void password_dialog_set_smtp_password (PasswordDialog* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_smtp_password);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_smtp_password = _tmp1_;
#line 1394 "password-dialog.c"
}


gboolean password_dialog_get_imap_remember_password (PasswordDialog* self) {
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), FALSE);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->_imap_remember_password;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1409 "password-dialog.c"
}


static void password_dialog_set_imap_remember_password (PasswordDialog* self, gboolean value) {
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_imap_remember_password = _tmp0_;
#line 1421 "password-dialog.c"
}


gboolean password_dialog_get_smtp_remember_password (PasswordDialog* self) {
	gboolean result;
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (IS_PASSWORD_DIALOG (self), FALSE);
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = self->priv->_smtp_remember_password;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return result;
#line 1436 "password-dialog.c"
}


static void password_dialog_set_smtp_remember_password (PasswordDialog* self, gboolean value) {
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (IS_PASSWORD_DIALOG (self));
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_smtp_remember_password = _tmp0_;
#line 1448 "password-dialog.c"
}


static void value_password_dialog_init (GValue* value) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	value->data[0].v_pointer = NULL;
#line 1455 "password-dialog.c"
}


static void value_password_dialog_free_value (GValue* value) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (value->data[0].v_pointer) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_unref (value->data[0].v_pointer);
#line 1464 "password-dialog.c"
	}
}


static void value_password_dialog_copy_value (const GValue* src_value, GValue* dest_value) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (src_value->data[0].v_pointer) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		dest_value->data[0].v_pointer = password_dialog_ref (src_value->data[0].v_pointer);
#line 1474 "password-dialog.c"
	} else {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1478 "password-dialog.c"
	}
}


static gpointer value_password_dialog_peek_pointer (const GValue* value) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return value->data[0].v_pointer;
#line 1486 "password-dialog.c"
}


static gchar* value_password_dialog_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (collect_values[0].v_pointer) {
#line 1493 "password-dialog.c"
		PasswordDialog* object;
		object = collect_values[0].v_pointer;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		if (object->parent_instance.g_class == NULL) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1500 "password-dialog.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1504 "password-dialog.c"
		}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = password_dialog_ref (object);
#line 1508 "password-dialog.c"
	} else {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 1512 "password-dialog.c"
	}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return NULL;
#line 1516 "password-dialog.c"
}


static gchar* value_password_dialog_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PasswordDialog** object_p;
	object_p = collect_values[0].v_pointer;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (!object_p) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1527 "password-dialog.c"
	}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (!value->data[0].v_pointer) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		*object_p = NULL;
#line 1533 "password-dialog.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		*object_p = value->data[0].v_pointer;
#line 1537 "password-dialog.c"
	} else {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		*object_p = password_dialog_ref (value->data[0].v_pointer);
#line 1541 "password-dialog.c"
	}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return NULL;
#line 1545 "password-dialog.c"
}


GParamSpec* param_spec_password_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPasswordDialog* spec;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PASSWORD_DIALOG), NULL);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return G_PARAM_SPEC (spec);
#line 1559 "password-dialog.c"
}


gpointer value_get_password_dialog (const GValue* value) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG), NULL);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return value->data[0].v_pointer;
#line 1568 "password-dialog.c"
}


void value_set_password_dialog (GValue* value, gpointer v_object) {
	PasswordDialog* old;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	old = value->data[0].v_pointer;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (v_object) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PASSWORD_DIALOG));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_ref (value->data[0].v_pointer);
#line 1588 "password-dialog.c"
	} else {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 1592 "password-dialog.c"
	}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (old) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_unref (old);
#line 1598 "password-dialog.c"
	}
}


void value_take_password_dialog (GValue* value, gpointer v_object) {
	PasswordDialog* old;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PASSWORD_DIALOG));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	old = value->data[0].v_pointer;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (v_object) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PASSWORD_DIALOG));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 1617 "password-dialog.c"
	} else {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 1621 "password-dialog.c"
	}
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (old) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		password_dialog_unref (old);
#line 1627 "password-dialog.c"
	}
}


static void password_dialog_class_init (PasswordDialogClass * klass) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	password_dialog_parent_class = g_type_class_peek_parent (klass);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	PASSWORD_DIALOG_CLASS (klass)->finalize = password_dialog_finalize;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_type_class_add_private (klass, sizeof (PasswordDialogPrivate));
#line 1639 "password-dialog.c"
}


static void password_dialog_instance_init (PasswordDialog * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv = PASSWORD_DIALOG_GET_PRIVATE (self);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp0_ = g_strdup ("");
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_imap_password = _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_tmp1_ = g_strdup ("");
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->priv->_smtp_password = _tmp1_;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self->ref_count = 1;
#line 1658 "password-dialog.c"
}


static void password_dialog_finalize (PasswordDialog* obj) {
	PasswordDialog * self;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PASSWORD_DIALOG, PasswordDialog);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_imap_remember_password);
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 23 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->check_smtp_remember_password);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->grid_imap);
#line 26 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_object_unref0 (self->priv->grid_smtp);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_imap_password);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	_g_free0 (self->priv->_smtp_password);
#line 1686 "password-dialog.c"
}


/**
 * Displays a dialog for collecting the user's password, without allowing them to change their
 * other data.
 */
GType password_dialog_get_type (void) {
	static volatile gsize password_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&password_dialog_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_password_dialog_init, value_password_dialog_free_value, value_password_dialog_copy_value, value_password_dialog_peek_pointer, "p", value_password_dialog_collect_value, "p", value_password_dialog_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PasswordDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) password_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasswordDialog), 0, (GInstanceInitFunc) password_dialog_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType password_dialog_type_id;
		password_dialog_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PasswordDialog", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&password_dialog_type_id__volatile, password_dialog_type_id);
	}
	return password_dialog_type_id__volatile;
}


gpointer password_dialog_ref (gpointer instance) {
	PasswordDialog* self;
	self = instance;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	g_atomic_int_inc (&self->ref_count);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	return instance;
#line 1715 "password-dialog.c"
}


void password_dialog_unref (gpointer instance) {
	PasswordDialog* self;
	self = instance;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		PASSWORD_DIALOG_GET_CLASS (self)->finalize (self);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/password-dialog.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1728 "password-dialog.c"
	}
}



