/* new-messages-monitor.c generated by valac 0.18.0, the Vala compiler
 * generated from new-messages-monitor.vala, do not modify */

/* Copyright 2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* NewMessagesMonitor is a central data store for new message information that the various*/
/* notification methods (libnotify, libindicate, libunity, etc.) can monitor to do their thing.*/
/* Subclasses should trap the "notify::count" signal and use that to perform whatever magic*/
/* they need for their implementation, or trap "new-messages" to receive notifications of the emails*/
/* themselves as they're added.  In the latter case, subscribers should add required Email.Field*/
/* flags to the object with add_required_fields().*/

#include <glib.h>
#include <glib-object.h>
#include "geary-static.h"
#include <gio/gio.h>
#include <gee.h>


#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
typedef struct _NewMessagesMonitorPrivate NewMessagesMonitorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NewMessagesMonitorDoProcessNewEmailData NewMessagesMonitorDoProcessNewEmailData;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NewMessagesMonitor {
	GObject parent_instance;
	NewMessagesMonitorPrivate * priv;
};

struct _NewMessagesMonitorClass {
	GObjectClass parent_class;
};

typedef gboolean (*NewMessagesMonitorShouldNotifyNewMessages) (void* user_data);
struct _NewMessagesMonitorPrivate {
	GearyFolder* _folder;
	gint _count;
	GearyEmail* _last_new_message;
	GearyEmailField _required_fields;
	NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages;
	gpointer should_notify_new_messages_target;
	GCancellable* cancellable;
	GeeHashSet* new_ids;
};

struct _NewMessagesMonitorDoProcessNewEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	NewMessagesMonitor* self;
	GeeCollection* email_ids;
	gboolean _tmp0_;
	NewMessagesMonitorShouldNotifyNewMessages _tmp1_;
	void* _tmp1__target;
	NewMessagesMonitorShouldNotifyNewMessages _tmp2_;
	void* _tmp2__target;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GearyFolder* _tmp5_;
	GeeCollection* _tmp6_;
	GearyEmailField _tmp7_;
	GCancellable* _tmp8_;
	GeeList* _tmp9_;
	GeeList* list;
	gboolean _tmp10_;
	GeeList* _tmp11_;
	GeeList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gboolean _tmp15_;
	GeeCollection* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GeeList* _tmp19_;
	GeeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GError* err;
	GError* _tmp24_;
	const gchar* _tmp25_;
	GError * _inner_error_;
};


static gpointer new_messages_monitor_parent_class = NULL;

GType new_messages_monitor_get_type (void) G_GNUC_CONST;
#define NEW_MESSAGES_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorPrivate))
enum  {
	NEW_MESSAGES_MONITOR_DUMMY_PROPERTY,
	NEW_MESSAGES_MONITOR_FOLDER,
	NEW_MESSAGES_MONITOR_COUNT,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE,
	NEW_MESSAGES_MONITOR_REQUIRED_FIELDS
};
GearyFolder* new_messages_monitor_get_folder (NewMessagesMonitor* self);
static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self, GeeCollection* email_ids);
static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender, GeeCollection* ids, gpointer self);
static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self, GeeMap* ids);
static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender, GeeMap* map, gpointer self);
static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self, GeeCollection* ids);
static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender, GeeCollection* ids, gpointer self);
static guint _geary_hashable_hash_func_ghash_func (gconstpointer key);
static gboolean _geary_equalable_equal_func_gequal_func (gconstpointer a, gconstpointer b);
NewMessagesMonitor* new_messages_monitor_new (GearyFolder* folder, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target, GCancellable* cancellable);
NewMessagesMonitor* new_messages_monitor_construct (GType object_type, GearyFolder* folder, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target, GCancellable* cancellable);
static void new_messages_monitor_set_folder (NewMessagesMonitor* self, GearyFolder* value);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self, GearyEmailField fields);
GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self);
static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self, GearyEmailField value);
gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self, GeeCollection* ids);
static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self, GeeCollection* email_ids, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self, GAsyncResult* _res_);
static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self, GeeCollection* email_ids);
static void new_messages_monitor_do_process_new_email_data_free (gpointer _data);
static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_);
static void new_messages_monitor_do_process_new_email_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void new_messages_monitor_new_messages (NewMessagesMonitor* self, GeeCollection* emails);
gint new_messages_monitor_get_count (NewMessagesMonitor* self);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self, GearyEmail* value);
static void new_messages_monitor_update_count (NewMessagesMonitor* self, gboolean arrived);
void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self);
static void new_messages_monitor_set_count (NewMessagesMonitor* self, gint value);
static void new_messages_monitor_finalize (GObject* obj);
static void _vala_new_messages_monitor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_new_messages_monitor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender, GeeCollection* ids, gpointer self) {
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_locally_appended (self, ids);
#line 149 "new-messages-monitor.c"
}


static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender, GeeMap* map, gpointer self) {
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_flags_changed (self, map);
#line 156 "new-messages-monitor.c"
}


static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender, GeeCollection* ids, gpointer self) {
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_removed (self, ids);
#line 163 "new-messages-monitor.c"
}


static guint _geary_hashable_hash_func_ghash_func (gconstpointer key) {
	guint result;
	result = geary_hashable_hash_func (key);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 172 "new-messages-monitor.c"
}


static gboolean _geary_equalable_equal_func_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = geary_equalable_equal_func (a, b);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 181 "new-messages-monitor.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "new-messages-monitor.c"
}


NewMessagesMonitor* new_messages_monitor_construct (GType object_type, GearyFolder* folder, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target, GCancellable* cancellable) {
	NewMessagesMonitor * self = NULL;
	GearyFolder* _tmp0_;
	NewMessagesMonitorShouldNotifyNewMessages _tmp1_;
	void* _tmp1__target;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GearyFolder* _tmp4_;
	GearyFolder* _tmp5_;
	GearyFolder* _tmp6_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEARY_IS_FOLDER (folder), NULL);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitor*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = folder;
#line 33 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_folder (self, _tmp0_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = should_notify_new_messages;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1__target = should_notify_new_messages_target;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->should_notify_new_messages = _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->should_notify_new_messages_target = _tmp1__target;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = cancellable;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->cancellable = _tmp3_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = folder;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp4_, "email-locally-appended", (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self, 0);
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = folder;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp5_, "email-flags-changed", (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self, 0);
#line 39 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = folder;
#line 39 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (_tmp6_, "email-removed", (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self, 0);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return self;
#line 242 "new-messages-monitor.c"
}


NewMessagesMonitor* new_messages_monitor_new (GearyFolder* folder, NewMessagesMonitorShouldNotifyNewMessages should_notify_new_messages, void* should_notify_new_messages_target, GCancellable* cancellable) {
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_construct (TYPE_NEW_MESSAGES_MONITOR, folder, should_notify_new_messages, should_notify_new_messages_target, cancellable);
#line 249 "new-messages-monitor.c"
}


void new_messages_monitor_add_required_fields (NewMessagesMonitor* self, GearyEmailField fields) {
	GearyEmailField _tmp0_;
	GearyEmailField _tmp1_;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = fields;
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_required_fields (self, _tmp0_ | _tmp1_);
#line 264 "new-messages-monitor.c"
}


gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self, GeeCollection* ids) {
	gboolean result = FALSE;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (ids), FALSE);
#line 274 "new-messages-monitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _id_it;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = ids;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_id_it = _tmp1_;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 287 "new-messages-monitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GearyEmailIdentifier* id;
			GeeHashSet* _tmp6_;
			GearyEmailIdentifier* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _id_it;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (!_tmp3_) {
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				break;
#line 304 "new-messages-monitor.c"
			}
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _id_it;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			id = (GearyEmailIdentifier*) _tmp5_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = self->priv->new_ids;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = id;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp7_);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp8_) {
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				result = TRUE;
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (id);
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (_id_it);
#line 55 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				return result;
#line 328 "new-messages-monitor.c"
			}
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (id);
#line 332 "new-messages-monitor.c"
		}
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_id_it);
#line 336 "new-messages-monitor.c"
	}
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	result = FALSE;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 342 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self, GeeCollection* email_ids) {
	GeeCollection* _tmp0_;
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = email_ids;
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email (self, _tmp0_, NULL, NULL);
#line 356 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self, GeeMap* ids) {
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
#line 65 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 65 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_MAP (ids));
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = ids;
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 381 "new-messages-monitor.c"
}


static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self, GeeCollection* ids) {
	GeeCollection* _tmp0_;
#line 69 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 69 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (ids));
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = ids;
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, _tmp0_);
#line 395 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_data_free (gpointer _data) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_slice_free (NewMessagesMonitorDoProcessNewEmailData, _data_);
#line 408 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self, GeeCollection* email_ids, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	NewMessagesMonitor* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_ = g_slice_new0 (NewMessagesMonitorDoProcessNewEmailData);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, new_messages_monitor_do_process_new_email);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, new_messages_monitor_do_process_new_email_data_free);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = email_ids;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->email_ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 437 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self, GAsyncResult* _res_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 445 "new-messages-monitor.c"
}


static void new_messages_monitor_do_process_new_email_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_ = _user_data_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_source_object_ = source_object;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_res_ = _res_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 459 "new-messages-monitor.c"
}


static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	switch (_data_->_state_) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case 0:
#line 468 "new-messages-monitor.c"
		goto _state_0;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case 1:
#line 472 "new-messages-monitor.c"
		goto _state_1;
		default:
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_assert_not_reached ();
#line 477 "new-messages-monitor.c"
	}
	_state_0:
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp1_ = _data_->self->priv->should_notify_new_messages;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp1__target = _data_->self->priv->should_notify_new_messages_target;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_data_->_tmp1_ != NULL) {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp2_ = _data_->self->priv->should_notify_new_messages;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp2__target = _data_->self->priv->should_notify_new_messages_target;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp3_ = FALSE;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp3_ = _data_->_tmp2_ (_data_->_tmp2__target);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp0_ = !_data_->_tmp3_;
#line 496 "new-messages-monitor.c"
	} else {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp0_ = FALSE;
#line 500 "new-messages-monitor.c"
	}
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_data_->_tmp4_ = _data_->_tmp0_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_data_->_tmp4_) {
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		if (_data_->_state_ == 0) {
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 510 "new-messages-monitor.c"
		} else {
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 514 "new-messages-monitor.c"
		}
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_object_unref (_data_->_async_result);
#line 75 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 520 "new-messages-monitor.c"
	}
	{
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp5_ = _data_->self->priv->_folder;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp6_ = _data_->email_ids;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp7_ = _data_->self->priv->_required_fields;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp8_ = _data_->self->priv->cancellable;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_state_ = 1;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		geary_folder_list_email_by_sparse_id_async (_data_->_tmp5_, _data_->_tmp6_, _data_->_tmp7_, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->_tmp8_, new_messages_monitor_do_process_new_email_ready, _data_);
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 537 "new-messages-monitor.c"
		_state_1:
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp9_ = NULL;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp9_ = geary_folder_list_email_by_sparse_id_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error_);
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->list = _data_->_tmp9_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 547 "new-messages-monitor.c"
			goto __catch42_g_error;
		}
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp11_ = _data_->list;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp11_ == NULL) {
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp10_ = TRUE;
#line 556 "new-messages-monitor.c"
		} else {
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp12_ = _data_->list;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp10_ = _data_->_tmp14_ == 0;
#line 566 "new-messages-monitor.c"
		}
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp15_ = _data_->_tmp10_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp15_) {
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp16_ = _data_->email_ids;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp17_ = gee_collection_get_size (_data_->_tmp16_);
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			g_debug ("new-messages-monitor.vala:81: Warning: %d new emails, but none could b" \
"e listed", _data_->_tmp18_);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->list);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_data_->_state_ == 0) {
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 586 "new-messages-monitor.c"
			} else {
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 590 "new-messages-monitor.c"
			}
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			g_object_unref (_data_->_async_result);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			return FALSE;
#line 596 "new-messages-monitor.c"
		}
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp19_ = _data_->list;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_new_messages (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, GEE_TYPE_COLLECTION, GeeCollection));
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp20_ = _data_->list;
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp21_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp23_ = _data_->self->priv->_count;
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:88: do_process_new_email: %d messages listed" \
", %d unread", _data_->_tmp22_, _data_->_tmp23_);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->list);
#line 614 "new-messages-monitor.c"
	}
	goto __finally42;
	__catch42_g_error:
	{
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->err = _data_->_inner_error_;
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp24_ = _data_->err;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:90: Unable to notify of new email: %s", _data_->_tmp25_);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_g_error_free0 (_data_->err);
#line 631 "new-messages-monitor.c"
	}
	__finally42:
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_data_->_inner_error_ != NULL) {
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_clear_error (&_data_->_inner_error_);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 642 "new-messages-monitor.c"
	}
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_data_->_state_ == 0) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 648 "new-messages-monitor.c"
	} else {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 652 "new-messages-monitor.c"
	}
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_unref (_data_->_async_result);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return FALSE;
#line 658 "new-messages-monitor.c"
}


static void new_messages_monitor_new_messages (NewMessagesMonitor* self, GeeCollection* emails) {
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (emails));
#line 667 "new-messages-monitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _email_it;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = emails;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_email_it = _tmp1_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 680 "new-messages-monitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GearyEmail* email;
			GearyEmail* _tmp6_;
			GearyEmailField _tmp7_;
			GearyEmailField _tmp8_;
			GearyEmailField _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeHashSet* _tmp20_;
			GearyEmail* _tmp21_;
			GearyEmailIdentifier* _tmp22_;
			GearyEmailIdentifier* _tmp23_;
			gboolean _tmp24_ = FALSE;
			GearyEmail* _tmp25_;
			GearyEmailFlags* _tmp26_;
			GearyEmailFlags* _tmp27_;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_ = FALSE;
			GearyEmail* _tmp30_;
			gboolean _tmp37_;
			GeeHashSet* _tmp39_;
			GearyEmail* _tmp40_;
			GearyEmailIdentifier* _tmp41_;
			GearyEmailIdentifier* _tmp42_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _email_it;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (!_tmp3_) {
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				break;
#line 715 "new-messages-monitor.c"
			}
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _email_it;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			email = (GearyEmail*) _tmp5_;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp6_ = email;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = geary_email_get_fields (_tmp6_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _tmp7_;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp9_ = self->priv->_required_fields;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp10_ = geary_email_field_fulfills (_tmp8_, _tmp9_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (!_tmp10_) {
#line 735 "new-messages-monitor.c"
				GearyEmail* _tmp11_;
				GearyEmailIdentifier* _tmp12_;
				GearyEmailIdentifier* _tmp13_;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_;
				GearyEmail* _tmp16_;
				GearyEmailField _tmp17_;
				GearyEmailField _tmp18_;
				GearyEmailField _tmp19_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = email;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp12_ = geary_email_get_id (_tmp11_);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp13_ = _tmp12_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp14_ = geary_email_identifier_to_string (_tmp13_);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp15_ = _tmp14_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp16_ = email;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp17_ = geary_email_get_fields (_tmp16_);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp18_ = _tmp17_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp19_ = self->priv->_required_fields;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				g_debug ("new-messages-monitor.vala:97: Warning: new message %s (%Xh) does not f" \
"ulfill NewMessagesMonitor required fields of %Xh", _tmp15_, (guint) _tmp18_, (guint) _tmp19_);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_g_free0 (_tmp15_);
#line 767 "new-messages-monitor.c"
			}
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp20_ = self->priv->new_ids;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp21_ = email;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp22_ = geary_email_get_id (_tmp21_);
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp23_ = _tmp22_;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp24_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp24_) {
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				continue;
#line 785 "new-messages-monitor.c"
			}
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp25_ = email;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp26_ = geary_email_get_email_flags (_tmp25_);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp27_ = _tmp26_;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp28_ = geary_email_flags_is_unread (_tmp27_);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (!_tmp28_) {
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				continue;
#line 801 "new-messages-monitor.c"
			}
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp30_ = self->priv->_last_new_message;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp30_ == NULL) {
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp29_ = TRUE;
#line 809 "new-messages-monitor.c"
			} else {
				GearyEmail* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				GearyEmail* _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp31_ = self->priv->_last_new_message;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp32_ = geary_email_get_position (_tmp31_);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp33_ = _tmp32_;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp34_ = email;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp35_ = geary_email_get_position (_tmp34_);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp36_ = _tmp35_;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp29_ = _tmp33_ < _tmp36_;
#line 831 "new-messages-monitor.c"
			}
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp37_ = _tmp29_;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp37_) {
#line 837 "new-messages-monitor.c"
				GearyEmail* _tmp38_;
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp38_ = email;
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message (self, _tmp38_);
#line 843 "new-messages-monitor.c"
			}
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp39_ = self->priv->new_ids;
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp40_ = email;
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp41_ = geary_email_get_id (_tmp40_);
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp42_ = _tmp41_;
#line 110 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp42_);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email);
#line 857 "new-messages-monitor.c"
		}
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_it);
#line 861 "new-messages-monitor.c"
	}
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, TRUE);
#line 865 "new-messages-monitor.c"
}


static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self, GeeCollection* email_ids) {
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (email_ids));
#line 874 "new-messages-monitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _email_id_it;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp0_ = email_ids;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_email_id_it = _tmp1_;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 887 "new-messages-monitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GearyEmailIdentifier* email_id;
			gboolean _tmp6_ = FALSE;
			GearyEmail* _tmp7_;
			gboolean _tmp13_;
			GeeHashSet* _tmp14_;
			GearyEmailIdentifier* _tmp15_;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _email_id_it;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (!_tmp3_) {
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				break;
#line 906 "new-messages-monitor.c"
			}
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _email_id_it;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			email_id = (GearyEmailIdentifier*) _tmp5_;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp7_ = self->priv->_last_new_message;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp7_ != NULL) {
#line 918 "new-messages-monitor.c"
				GearyEmail* _tmp8_;
				GearyEmailIdentifier* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				GearyEmailIdentifier* _tmp11_;
				gboolean _tmp12_ = FALSE;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp8_ = self->priv->_last_new_message;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp9_ = geary_email_get_id (_tmp8_);
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp10_ = _tmp9_;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp11_ = email_id;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp12_ = geary_email_identifier_equals (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_TYPE_EQUALABLE, GearyEqualable));
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp6_ = _tmp12_;
#line 936 "new-messages-monitor.c"
			} else {
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				_tmp6_ = FALSE;
#line 940 "new-messages-monitor.c"
			}
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp13_ = _tmp6_;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			if (_tmp13_) {
#line 119 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message (self, NULL);
#line 948 "new-messages-monitor.c"
			}
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp14_ = self->priv->new_ids;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_tmp15_ = email_id;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email_id);
#line 958 "new-messages-monitor.c"
		}
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_id_it);
#line 962 "new-messages-monitor.c"
	}
#line 124 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, FALSE);
#line 966 "new-messages-monitor.c"
}


void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self) {
	GeeHashSet* _tmp0_;
#line 127 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 128 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->new_ids;
#line 128 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 129 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message (self, NULL);
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, FALSE);
#line 982 "new-messages-monitor.c"
}


static void new_messages_monitor_update_count (NewMessagesMonitor* self, gboolean arrived) {
	gint _tmp0_;
	GeeHashSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GeeHashSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_count;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->new_ids;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_tmp0_ == _tmp3_) {
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		return;
#line 1009 "new-messages-monitor.c"
	}
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = self->priv->new_ids;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp5_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp6_ = _tmp5_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_count (self, _tmp6_);
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp7_ = arrived;
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	if (_tmp7_) {
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_signal_emit_by_name (self, "new-messages-arrived");
#line 1025 "new-messages-monitor.c"
	} else {
#line 145 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_signal_emit_by_name (self, "new-messages-retired");
#line 1029 "new-messages-monitor.c"
	}
}


GearyFolder* new_messages_monitor_get_folder (NewMessagesMonitor* self) {
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_folder;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1045 "new-messages-monitor.c"
}


static void new_messages_monitor_set_folder (NewMessagesMonitor* self, GearyFolder* value) {
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_folder);
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_folder = _tmp1_;
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "folder");
#line 1064 "new-messages-monitor.c"
}


gint new_messages_monitor_get_count (NewMessagesMonitor* self) {
	gint result;
	gint _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_count;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1079 "new-messages-monitor.c"
}


static void new_messages_monitor_set_count (NewMessagesMonitor* self, gint value) {
	gint _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_count = _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "count");
#line 1093 "new-messages-monitor.c"
}


GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self) {
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1108 "new-messages-monitor.c"
}


static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self, GearyEmail* value) {
	GearyEmail* _tmp0_;
	GearyEmail* _tmp1_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = _tmp1_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "last-new-message");
#line 1127 "new-messages-monitor.c"
}


GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self) {
	GearyEmailField result;
	GearyEmailField _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	return result;
#line 1142 "new-messages-monitor.c"
}


static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self, GearyEmailField value) {
	GearyEmailField _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = value;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_notify ((GObject *) self, "required-fields");
#line 1156 "new-messages-monitor.c"
}


static void new_messages_monitor_class_init (NewMessagesMonitorClass * klass) {
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_type_class_add_private (klass, sizeof (NewMessagesMonitorPrivate));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_new_messages_monitor_get_property;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_new_messages_monitor_set_property;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_finalize;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_FOLDER, g_param_spec_object ("folder", "folder", "folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_COUNT, g_param_spec_int ("count", "count", "count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE, g_param_spec_object ("last-new-message", "last-new-message", "last-new-message", GEARY_TYPE_EMAIL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_REQUIRED_FIELDS, g_param_spec_enum ("required-fields", "required-fields", "required-fields", GEARY_EMAIL_TYPE_FIELD, GEARY_EMAIL_FIELD_FLAGS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("new_messages_arrived", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_new ("new_messages_retired", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1183 "new-messages-monitor.c"
}


static void new_messages_monitor_instance_init (NewMessagesMonitor * self) {
	GeeHashSet* _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv = NEW_MESSAGES_MONITOR_GET_PRIVATE (self);
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_count = 0;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = NULL;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = GEARY_EMAIL_FIELD_FLAGS;
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, _geary_hashable_hash_func_ghash_func, _geary_equalable_equal_func_gequal_func);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self->priv->new_ids = _tmp0_;
#line 1201 "new-messages-monitor.c"
}


static void new_messages_monitor_finalize (GObject* obj) {
	NewMessagesMonitor * self;
	GearyFolder* _tmp0_;
	guint _tmp1_ = 0U;
	GearyFolder* _tmp2_;
	guint _tmp3_ = 0U;
	GearyFolder* _tmp4_;
	guint _tmp5_ = 0U;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_folder;
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-locally-appended", GEARY_TYPE_FOLDER, &_tmp1_, NULL, FALSE);
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self);
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp2_ = self->priv->_folder;
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-flags-changed", GEARY_TYPE_FOLDER, &_tmp3_, NULL, FALSE);
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_tmp4_ = self->priv->_folder;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-removed", GEARY_TYPE_FOLDER, &_tmp5_, NULL, FALSE);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self);
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_folder);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 23 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->new_ids);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_parent_class)->finalize (obj);
#line 1243 "new-messages-monitor.c"
}


GType new_messages_monitor_get_type (void) {
	static volatile gsize new_messages_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitor), 0, (GInstanceInitFunc) new_messages_monitor_instance_init, NULL };
		GType new_messages_monitor_type_id;
		new_messages_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "NewMessagesMonitor", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_type_id__volatile, new_messages_monitor_type_id);
	}
	return new_messages_monitor_type_id__volatile;
}


static void _vala_new_messages_monitor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_FOLDER:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_folder (self));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_COUNT:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_value_set_int (value, new_messages_monitor_get_count (self));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message (self));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		g_value_set_enum (value, new_messages_monitor_get_required_fields (self));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 1288 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 1294 "new-messages-monitor.c"
	}
}


static void _vala_new_messages_monitor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_FOLDER:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_folder (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_COUNT:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_count (self, g_value_get_int (value));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message (self, g_value_get_object (value));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_required_fields (self, g_value_get_enum (value));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 1328 "new-messages-monitor.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/notification/new-messages-monitor.vala"
		break;
#line 1334 "new-messages-monitor.c"
	}
}



