/* icon-factory.c generated by valac 0.18.0, the Vala compiler
 * generated from icon-factory.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* Singleton class to hold icons.*/

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "geary-static.h"
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ICON_FACTORY (icon_factory_get_type ())
#define ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_FACTORY, IconFactory))
#define ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_FACTORY, IconFactoryClass))
#define IS_ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_FACTORY))
#define IS_ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_FACTORY))
#define ICON_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_FACTORY, IconFactoryClass))

typedef struct _IconFactory IconFactory;
typedef struct _IconFactoryClass IconFactoryClass;
typedef struct _IconFactoryPrivate IconFactoryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _icon_factory_unref0(var) ((var == NULL) ? NULL : (var = (icon_factory_unref (var), NULL)))
typedef struct _ParamSpecIconFactory ParamSpecIconFactory;

struct _IconFactory {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IconFactoryPrivate * priv;
};

struct _IconFactoryClass {
	GTypeClass parent_class;
	void (*finalize) (IconFactory *self);
};

struct _IconFactoryPrivate {
	GdkPixbuf* _application_icon;
	GdkPixbuf* _unread;
	GdkPixbuf* _starred;
	GdkPixbuf* _unstarred;
	GtkIconTheme* _icon_theme;
	GFile* icons_dir;
};

struct _ParamSpecIconFactory {
	GParamSpec parent_instance;
};


static gpointer icon_factory_parent_class = NULL;
static IconFactory* icon_factory__instance;
static IconFactory* icon_factory__instance = NULL;

gpointer icon_factory_ref (gpointer instance);
void icon_factory_unref (gpointer instance);
GParamSpec* param_spec_icon_factory (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_icon_factory (GValue* value, gpointer v_object);
void value_take_icon_factory (GValue* value, gpointer v_object);
gpointer value_get_icon_factory (const GValue* value);
GType icon_factory_get_type (void) G_GNUC_CONST;
#define ICON_FACTORY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ICON_FACTORY, IconFactoryPrivate))
enum  {
	ICON_FACTORY_DUMMY_PROPERTY
};
#define ICON_FACTORY_ICON_TOOLBAR GTK_ICON_SIZE_LARGE_TOOLBAR
#define ICON_FACTORY_ICON_SIDEBAR GTK_ICON_SIZE_MENU
#define ICON_FACTORY_APPLICATION_ICON_SIZE 128
#define ICON_FACTORY_UNREAD_ICON_SIZE 16
#define ICON_FACTORY_STAR_ICON_SIZE 16
static IconFactory* icon_factory_new (void);
static IconFactory* icon_factory_construct (GType object_type);
static void icon_factory_set_icon_theme (IconFactory* self, GtkIconTheme* value);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void);
GFile* geary_application_get_resource_directory (GearyApplication* self);
static void icon_factory_append_icons_search_path (IconFactory* self, const gchar* name);
static GdkPixbuf* icon_factory_load (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags);
static void icon_factory_set_application_icon (IconFactory* self, GdkPixbuf* value);
static void icon_factory_set_unread (IconFactory* self, GdkPixbuf* value);
static void icon_factory_set_starred (IconFactory* self, GdkPixbuf* value);
static void icon_factory_set_unstarred (IconFactory* self, GdkPixbuf* value);
void icon_factory_init (IconFactory* self);
static gint icon_factory_icon_size_to_pixels (IconFactory* self, GtkIconSize icon_size);
GIcon* icon_factory_get_theme_icon (IconFactory* self, const gchar* name);
GIcon* icon_factory_get_custom_icon (IconFactory* self, const gchar* name, GtkIconSize size);
static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self);
GtkIconInfo* icon_factory_lookup_icon (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags);
IconFactory* icon_factory_get_instance (void);
static void icon_factory_set_instance (IconFactory* value);
GdkPixbuf* icon_factory_get_application_icon (IconFactory* self);
GdkPixbuf* icon_factory_get_unread (IconFactory* self);
GdkPixbuf* icon_factory_get_starred (IconFactory* self);
GdkPixbuf* icon_factory_get_unstarred (IconFactory* self);
static void icon_factory_finalize (IconFactory* obj);


static IconFactory* icon_factory_construct (GType object_type) {
	IconFactory* self = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GearyApplication* _tmp1_;
	GearyApplication* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_ = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_ = NULL;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_ = NULL;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_ = NULL;
	GdkPixbuf* _tmp13_;
#line 39 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self = (IconFactory*) g_type_create_instance (object_type);
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_set_icon_theme (self, _tmp0_);
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = geary_application_get_instance ();
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp2_ = _tmp1_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp3_ = geary_application_get_resource_directory (_tmp2_);
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp4_ = _tmp3_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp5_ = g_file_get_child (_tmp4_, "icons");
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->icons_dir = _tmp5_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp4_);
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_append_icons_search_path (self, NULL);
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_append_icons_search_path (self, "128x128");
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_append_icons_search_path (self, "48x48");
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_append_icons_search_path (self, "24x24");
#line 47 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_append_icons_search_path (self, "16x16");
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp6_ = icon_factory_load (self, "geary", ICON_FACTORY_APPLICATION_ICON_SIZE, 0);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp7_ = _tmp6_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_set_application_icon (self, _tmp7_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp7_);
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp8_ = icon_factory_load (self, "mail-unread", ICON_FACTORY_UNREAD_ICON_SIZE, 0);
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_set_unread (self, _tmp9_);
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp9_);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp10_ = icon_factory_load (self, "starred", ICON_FACTORY_STAR_ICON_SIZE, 0);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp11_ = _tmp10_;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_set_starred (self, _tmp11_);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp11_);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp12_ = icon_factory_load (self, "non-starred-grey", ICON_FACTORY_STAR_ICON_SIZE, 0);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp13_ = _tmp12_;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_set_unstarred (self, _tmp13_);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp13_);
#line 39 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return self;
#line 204 "icon-factory.c"
}


static IconFactory* icon_factory_new (void) {
#line 39 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return icon_factory_construct (TYPE_ICON_FACTORY);
#line 211 "icon-factory.c"
}


void icon_factory_init (IconFactory* self) {
#line 56 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 218 "icon-factory.c"
}


static gint icon_factory_icon_size_to_pixels (IconFactory* self, GtkIconSize icon_size) {
	gint result = 0;
	GtkIconSize _tmp0_;
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), 0);
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = icon_size;
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	switch (_tmp0_) {
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		case ICON_FACTORY_ICON_SIDEBAR:
#line 233 "icon-factory.c"
		{
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			result = 16;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return result;
#line 239 "icon-factory.c"
		}
		default:
#line 62 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		case ICON_FACTORY_ICON_TOOLBAR:
#line 244 "icon-factory.c"
		{
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			result = 24;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return result;
#line 250 "icon-factory.c"
		}
	}
}


GIcon* icon_factory_get_theme_icon (IconFactory* self, const gchar* name) {
	GIcon* result = NULL;
	const gchar* _tmp0_;
	GThemedIcon* _tmp1_;
#line 72 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 72 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = name;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_ICON, GIcon);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 272 "icon-factory.c"
}


GIcon* icon_factory_get_custom_icon (IconFactory* self, const gchar* name, GtkIconSize size) {
	GIcon* result = NULL;
	GtkIconSize _tmp0_;
	gint _tmp1_ = 0;
	gint pixels;
	GFile* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	GFile* _tmp10_ = NULL;
	GFile* _tmp11_;
	GFileIcon* _tmp12_;
	GIcon* _tmp13_;
#line 76 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 76 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = size;
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = icon_factory_icon_size_to_pixels (self, _tmp0_);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	pixels = _tmp1_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp2_ = self->priv->icons_dir;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp3_ = g_strdup_printf ("%dx%d", pixels, pixels);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp4_ = _tmp3_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp5_ = g_file_get_child (_tmp2_, _tmp4_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp6_ = _tmp5_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp7_ = name;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp8_ = g_strdup_printf ("%s.svg", _tmp7_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp10_ = g_file_get_child (_tmp6_, _tmp9_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp11_ = _tmp10_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp12_ = (GFileIcon*) g_file_icon_new (_tmp11_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_ICON, GIcon);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp11_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_free0 (_tmp9_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (_tmp6_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_free0 (_tmp4_);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp13_;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 339 "icon-factory.c"
}


static void icon_factory_append_icons_search_path (IconFactory* self, const gchar* name) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 82 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = name;
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = geary_string_is_empty (_tmp0_);
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (_tmp1_) {
#line 354 "icon-factory.c"
		GtkIconTheme* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp2_ = self->priv->_icon_theme;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp3_ = self->priv->icons_dir;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp5_ = _tmp4_;
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		gtk_icon_theme_append_search_path (_tmp2_, _tmp5_);
#line 84 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_g_free0 (_tmp5_);
#line 371 "icon-factory.c"
	} else {
		GtkIconTheme* _tmp6_;
		GFile* _tmp7_;
		const gchar* _tmp8_;
		GFile* _tmp9_ = NULL;
		GFile* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp6_ = self->priv->_icon_theme;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp7_ = self->priv->icons_dir;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp8_ = name;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp9_ = g_file_get_child (_tmp7_, _tmp8_);
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp10_ = _tmp9_;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp12_ = _tmp11_;
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		gtk_icon_theme_append_search_path (_tmp6_, _tmp12_);
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_g_free0 (_tmp12_);
#line 86 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_g_object_unref0 (_tmp10_);
#line 400 "icon-factory.c"
	}
}


static GdkPixbuf* icon_factory_load (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags) {
	GdkPixbuf* result = NULL;
	GtkIconTheme* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GtkIconLookupFlags _tmp3_;
	GtkIconInfo* _tmp4_ = NULL;
	GtkIconInfo* icon_info;
	GtkIconInfo* _tmp5_;
	GError * _inner_error_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = icon_name;
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp2_ = size;
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp3_ = flags;
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp4_ = gtk_icon_theme_lookup_icon (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_info = _tmp4_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp5_ = icon_info;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (_tmp5_ != NULL) {
#line 435 "icon-factory.c"
		{
			GtkIconInfo* _tmp6_;
			GdkPixbuf* _tmp7_ = NULL;
			GdkPixbuf* _tmp8_;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp6_ = icon_info;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp7_ = gtk_icon_info_load_icon (_tmp6_, &_inner_error_);
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp8_ = _tmp7_;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			if (_inner_error_ != NULL) {
#line 448 "icon-factory.c"
				goto __catch47_g_error;
			}
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			result = _tmp8_;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return result;
#line 457 "icon-factory.c"
		}
		goto __finally47;
		__catch47_g_error:
		{
			GError* err = NULL;
			const gchar* _tmp9_;
			GtkIconInfo* _tmp10_;
			const gchar* _tmp11_ = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			err = _inner_error_;
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_inner_error_ = NULL;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp9_ = icon_name;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp10_ = icon_info;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp11_ = gtk_icon_info_get_filename (_tmp10_);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp12_ = err;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_tmp13_ = _tmp12_->message;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			g_warning ("icon-factory.vala:96: Couldn't load icon %s at %s, falling back to ima" \
"ge-missing: %s", _tmp9_, _tmp11_, _tmp13_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_g_error_free0 (err);
#line 486 "icon-factory.c"
		}
		__finally47:
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		if (_inner_error_ != NULL) {
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return NULL;
#line 499 "icon-factory.c"
		}
	} else {
		const gchar* _tmp14_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp14_ = icon_name;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_debug ("icon-factory.vala:100: Unable to lookup icon %s, falling back to image" \
"-missing...", _tmp14_);
#line 507 "icon-factory.c"
	}
	{
		GtkIconTheme* _tmp15_;
		gint _tmp16_;
		GtkIconLookupFlags _tmp17_;
		GdkPixbuf* _tmp18_ = NULL;
		GdkPixbuf* _tmp19_;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp15_ = self->priv->_icon_theme;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp16_ = size;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp17_ = flags;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp18_ = gtk_icon_theme_load_icon (_tmp15_, "image-missing", _tmp16_, _tmp17_, &_inner_error_);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp19_ = _tmp18_;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		if (_inner_error_ != NULL) {
#line 527 "icon-factory.c"
			goto __catch48_g_error;
		}
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		result = _tmp19_;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_gtk_icon_info_free0 (icon_info);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		return result;
#line 536 "icon-factory.c"
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* err = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		err = _inner_error_;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_inner_error_ = NULL;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp20_ = err;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp21_ = _tmp20_->message;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_warning ("icon-factory.vala:107: Couldn't load image-missing icon: %s", _tmp21_);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_g_error_free0 (err);
#line 556 "icon-factory.c"
	}
	__finally48:
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (_inner_error_ != NULL) {
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_gtk_icon_info_free0 (icon_info);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_clear_error (&_inner_error_);
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		return NULL;
#line 569 "icon-factory.c"
	}
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = NULL;
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 111 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 577 "icon-factory.c"
}


GtkIconInfo* icon_factory_lookup_icon (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags) {
	GtkIconInfo* result = NULL;
	GtkIconTheme* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GtkIconLookupFlags _tmp3_;
	GtkIconInfo* _tmp4_ = NULL;
	GtkIconInfo* icon_info;
	GtkIconInfo* _tmp5_ = NULL;
	GtkIconInfo* _tmp6_;
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = icon_name;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp2_ = size;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp3_ = flags;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp4_ = gtk_icon_theme_lookup_icon (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_info = _tmp4_;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp6_ = icon_info;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (_tmp6_ != NULL) {
#line 611 "icon-factory.c"
		GtkIconInfo* _tmp7_;
		GtkIconInfo* _tmp8_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp7_ = icon_info;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp8_ = gtk_icon_info_copy (_tmp7_);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp5_);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp5_ = _tmp8_;
#line 622 "icon-factory.c"
	} else {
		GtkIconTheme* _tmp9_;
		gint _tmp10_;
		GtkIconLookupFlags _tmp11_;
		GtkIconInfo* _tmp12_ = NULL;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp9_ = self->priv->_icon_theme;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp10_ = size;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp11_ = flags;
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp12_ = gtk_icon_theme_lookup_icon (_tmp9_, "image-missing", _tmp10_, _tmp11_);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp5_);
#line 117 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp5_ = _tmp12_;
#line 640 "icon-factory.c"
	}
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp5_;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 648 "icon-factory.c"
}


IconFactory* icon_factory_get_instance (void) {
	IconFactory* result;
	IconFactory* _tmp0_;
	IconFactory* _tmp2_;
#line 15 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = icon_factory__instance;
#line 15 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (_tmp0_ == NULL) {
#line 660 "icon-factory.c"
		IconFactory* _tmp1_;
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_tmp1_ = icon_factory_new ();
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		_icon_factory_unref0 (icon_factory__instance);
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		icon_factory__instance = _tmp1_;
#line 668 "icon-factory.c"
	}
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp2_ = icon_factory__instance;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp2_;
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 676 "icon-factory.c"
}


static gpointer _icon_factory_ref0 (gpointer self) {
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return self ? icon_factory_ref (self) : NULL;
#line 683 "icon-factory.c"
}


static void icon_factory_set_instance (IconFactory* value) {
	IconFactory* _tmp0_;
	IconFactory* _tmp1_;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _icon_factory_ref0 (_tmp0_);
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_icon_factory_unref0 (icon_factory__instance);
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory__instance = _tmp1_;
#line 698 "icon-factory.c"
}


GdkPixbuf* icon_factory_get_application_icon (IconFactory* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_application_icon;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 713 "icon-factory.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return self ? g_object_ref (self) : NULL;
#line 720 "icon-factory.c"
}


static void icon_factory_set_application_icon (IconFactory* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_application_icon);
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->_application_icon = _tmp1_;
#line 737 "icon-factory.c"
}


GdkPixbuf* icon_factory_get_unread (IconFactory* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_unread;
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 752 "icon-factory.c"
}


static void icon_factory_set_unread (IconFactory* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_unread);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->_unread = _tmp1_;
#line 769 "icon-factory.c"
}


GdkPixbuf* icon_factory_get_starred (IconFactory* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_starred;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 784 "icon-factory.c"
}


static void icon_factory_set_starred (IconFactory* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_starred);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->_starred = _tmp1_;
#line 801 "icon-factory.c"
}


GdkPixbuf* icon_factory_get_unstarred (IconFactory* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_unstarred;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 816 "icon-factory.c"
}


static void icon_factory_set_unstarred (IconFactory* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_unstarred);
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->_unstarred = _tmp1_;
#line 833 "icon-factory.c"
}


static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self) {
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return result;
#line 848 "icon-factory.c"
}


static void icon_factory_set_icon_theme (IconFactory* self, GtkIconTheme* value) {
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv->_icon_theme = _tmp1_;
#line 865 "icon-factory.c"
}


static void value_icon_factory_init (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	value->data[0].v_pointer = NULL;
#line 872 "icon-factory.c"
}


static void value_icon_factory_free_value (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		icon_factory_unref (value->data[0].v_pointer);
#line 881 "icon-factory.c"
	}
}


static void value_icon_factory_copy_value (const GValue* src_value, GValue* dest_value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		dest_value->data[0].v_pointer = icon_factory_ref (src_value->data[0].v_pointer);
#line 891 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		dest_value->data[0].v_pointer = NULL;
#line 895 "icon-factory.c"
	}
}


static gpointer value_icon_factory_peek_pointer (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return value->data[0].v_pointer;
#line 903 "icon-factory.c"
}


static gchar* value_icon_factory_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (collect_values[0].v_pointer) {
#line 910 "icon-factory.c"
		IconFactory* object;
		object = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 917 "icon-factory.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 921 "icon-factory.c"
		}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = icon_factory_ref (object);
#line 925 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 929 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return NULL;
#line 933 "icon-factory.c"
}


static gchar* value_icon_factory_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	IconFactory** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (!object_p) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 944 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (!value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		*object_p = NULL;
#line 950 "icon-factory.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		*object_p = value->data[0].v_pointer;
#line 954 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		*object_p = icon_factory_ref (value->data[0].v_pointer);
#line 958 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return NULL;
#line 962 "icon-factory.c"
}


GParamSpec* param_spec_icon_factory (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecIconFactory* spec;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return G_PARAM_SPEC (spec);
#line 976 "icon-factory.c"
}


gpointer value_get_icon_factory (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return value->data[0].v_pointer;
#line 985 "icon-factory.c"
}


void value_set_icon_factory (GValue* value, gpointer v_object) {
	IconFactory* old;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		icon_factory_ref (value->data[0].v_pointer);
#line 1005 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1009 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		icon_factory_unref (old);
#line 1015 "icon-factory.c"
	}
}


void value_take_icon_factory (GValue* value, gpointer v_object) {
	IconFactory* old;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 1034 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1038 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		icon_factory_unref (old);
#line 1044 "icon-factory.c"
	}
}


static void icon_factory_class_init (IconFactoryClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	icon_factory_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	ICON_FACTORY_CLASS (klass)->finalize = icon_factory_finalize;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_type_class_add_private (klass, sizeof (IconFactoryPrivate));
#line 1056 "icon-factory.c"
}


static void icon_factory_instance_init (IconFactory * self) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->priv = ICON_FACTORY_GET_PRIVATE (self);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self->ref_count = 1;
#line 1065 "icon-factory.c"
}


static void icon_factory_finalize (IconFactory* obj) {
	IconFactory * self;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_FACTORY, IconFactory);
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_application_icon);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_unread);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_starred);
#line 32 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_unstarred);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 1085 "icon-factory.c"
}


GType icon_factory_get_type (void) {
	static volatile gsize icon_factory_type_id__volatile = 0;
	if (g_once_init_enter (&icon_factory_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_icon_factory_init, value_icon_factory_free_value, value_icon_factory_copy_value, value_icon_factory_peek_pointer, "p", value_icon_factory_collect_value, "p", value_icon_factory_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (IconFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconFactory), 0, (GInstanceInitFunc) icon_factory_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType icon_factory_type_id;
		icon_factory_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IconFactory", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&icon_factory_type_id__volatile, icon_factory_type_id);
	}
	return icon_factory_type_id__volatile;
}


gpointer icon_factory_ref (gpointer instance) {
	IconFactory* self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	return instance;
#line 1110 "icon-factory.c"
}


void icon_factory_unref (gpointer instance) {
	IconFactory* self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		ICON_FACTORY_GET_CLASS (self)->finalize (self);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/ui/icon-factory.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1123 "icon-factory.c"
	}
}



