/* util-keyring.c generated by valac 0.18.0, the Vala compiler
 * generated from util-keyring.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "geary-static.h"
#include <gnome-keyring.h>


#define TYPE_PASSWORD_TYPE (password_type_get_type ())

#define TYPE_PASSWORD_TYPE_FLAG (password_type_flag_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	PASSWORD_TYPE_IMAP,
	PASSWORD_TYPE_SMTP
} PasswordType;

typedef enum  {
	PASSWORD_TYPE_FLAG_IMAP = 1 << 0,
	PASSWORD_TYPE_FLAG_SMTP = 1 << 1
} PasswordTypeFlag;



#define OLD_GEARY_USERNAME_PREFIX "org.yorba.geary username:"
GType password_type_get_type (void) G_GNUC_CONST;
gchar* password_type_get_prefix (PasswordType self);
GType password_type_flag_get_type (void) G_GNUC_CONST;
gboolean password_type_flag_has_imap (PasswordTypeFlag self);
gboolean password_type_flag_has_smtp (PasswordTypeFlag self);
gchar* keyring_get_key (PasswordType password_type, const gchar* username);
gboolean keyring_save_password (GearyCredentials* credentials, PasswordType password_type);
const gchar* gnome_keyring_result_to_string (GnomeKeyringResult self);
static const char* _gnome_keyring_result_to_string (GnomeKeyringResult value);
gboolean keyring_clear_password (const gchar* username, PasswordType password_type);
void keyring_delete_password (const gchar* username, PasswordType password_type);
gchar* keyring_get_password (const gchar* username, PasswordType password_type);


gchar* password_type_get_prefix (PasswordType self) {
	gchar* result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	switch (self) {
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case PASSWORD_TYPE_IMAP:
#line 57 "util-keyring.c"
		{
			gchar* _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			_tmp0_ = g_strdup ("org.yorba.geary imap_username:");
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			result = _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			return result;
#line 66 "util-keyring.c"
		}
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case PASSWORD_TYPE_SMTP:
#line 70 "util-keyring.c"
		{
			gchar* _tmp1_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			_tmp1_ = g_strdup ("org.yorba.geary smtp_username:");
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			result = _tmp1_;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			return result;
#line 79 "util-keyring.c"
		}
		default:
		{
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
			g_assert_not_reached ();
#line 85 "util-keyring.c"
		}
	}
}


GType password_type_get_type (void) {
	static volatile gsize password_type_type_id__volatile = 0;
	if (g_once_init_enter (&password_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PASSWORD_TYPE_IMAP, "PASSWORD_TYPE_IMAP", "imap"}, {PASSWORD_TYPE_SMTP, "PASSWORD_TYPE_SMTP", "smtp"}, {0, NULL, NULL}};
		GType password_type_type_id;
		password_type_type_id = g_enum_register_static ("PasswordType", values);
		g_once_init_leave (&password_type_type_id__volatile, password_type_type_id);
	}
	return password_type_type_id__volatile;
}


gboolean password_type_flag_has_imap (PasswordTypeFlag self) {
	gboolean result = FALSE;
#line 33 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = (self & PASSWORD_TYPE_FLAG_IMAP) == PASSWORD_TYPE_FLAG_IMAP;
#line 33 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 109 "util-keyring.c"
}


gboolean password_type_flag_has_smtp (PasswordTypeFlag self) {
	gboolean result = FALSE;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = (self & PASSWORD_TYPE_FLAG_SMTP) == PASSWORD_TYPE_FLAG_SMTP;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 119 "util-keyring.c"
}


GType password_type_flag_get_type (void) {
	static volatile gsize password_type_flag_type_id__volatile = 0;
	if (g_once_init_enter (&password_type_flag_type_id__volatile)) {
		static const GFlagsValue values[] = {{PASSWORD_TYPE_FLAG_IMAP, "PASSWORD_TYPE_FLAG_IMAP", "imap"}, {PASSWORD_TYPE_FLAG_SMTP, "PASSWORD_TYPE_FLAG_SMTP", "smtp"}, {0, NULL, NULL}};
		GType password_type_flag_type_id;
		password_type_flag_type_id = g_flags_register_static ("PasswordTypeFlag", values);
		g_once_init_leave (&password_type_flag_type_id__volatile, password_type_flag_type_id);
	}
	return password_type_flag_type_id__volatile;
}


gchar* keyring_get_key (PasswordType password_type, const gchar* username) {
	gchar* result = NULL;
	PasswordType _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp0_ = password_type;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp1_ = password_type_get_prefix (_tmp0_);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp2_ = _tmp1_;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp3_ = username;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp5_ = _tmp4_;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (_tmp2_);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = _tmp5_;
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 163 "util-keyring.c"
}


static const char* _gnome_keyring_result_to_string (GnomeKeyringResult value) {
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	switch (value) {
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_OK:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_OK";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_DENIED:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_DENIED";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_NO_KEYRING_DAEMON:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_NO_KEYRING_DAEMON";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_ALREADY_UNLOCKED:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_ALREADY_UNLOCKED";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_NO_SUCH_KEYRING:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_NO_SUCH_KEYRING";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_BAD_ARGUMENTS:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_BAD_ARGUMENTS";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_IO_ERROR:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_IO_ERROR";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_CANCELLED:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_CANCELLED";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_KEYRING_ALREADY_EXISTS:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_KEYRING_ALREADY_EXISTS";
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		case GNOME_KEYRING_RESULT_NO_MATCH:
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		return "GNOME_KEYRING_RESULT_NO_MATCH";
#line 210 "util-keyring.c"
	}
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return NULL;
#line 214 "util-keyring.c"
}


gboolean keyring_save_password (GearyCredentials* credentials, PasswordType password_type) {
	gboolean result = FALSE;
	PasswordType _tmp0_;
	GearyCredentials* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* key;
	GnomeKeyringPasswordSchema* _tmp5_;
	const gchar* _tmp6_;
	GearyCredentials* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GnomeKeyringResult _tmp11_ = 0;
	GnomeKeyringResult _result_;
	GnomeKeyringResult _tmp12_;
	GnomeKeyringResult _tmp15_;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (credentials), FALSE);
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp0_ = password_type;
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp1_ = credentials;
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp2_ = geary_credentials_get_user (_tmp1_);
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp3_ = _tmp2_;
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp4_ = keyring_get_key (_tmp0_, _tmp3_);
#line 46 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	key = _tmp4_;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp5_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp6_ = key;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp7_ = credentials;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp8_ = geary_credentials_get_pass (_tmp7_);
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp9_ = _tmp8_;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp10_ = key;
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp11_ = gnome_keyring_store_password_sync (_tmp5_, NULL, _tmp6_, _tmp9_, "user", _tmp10_, NULL);
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_result_ = _tmp11_;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp12_ = _result_;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	if (_tmp12_ != GNOME_KEYRING_RESULT_OK) {
#line 270 "util-keyring.c"
		GnomeKeyringResult _tmp13_;
		const gchar* _tmp14_ = NULL;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp13_ = _result_;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp14_ = _gnome_keyring_result_to_string (_tmp13_);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		g_debug ("util-keyring.vala:52: Unable to store password in GNOME keyring: %s", _tmp14_);
#line 279 "util-keyring.c"
	}
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp15_ = _result_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = _tmp15_ == GNOME_KEYRING_RESULT_OK;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (key);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 289 "util-keyring.c"
}


gboolean keyring_clear_password (const gchar* username, PasswordType password_type) {
	gboolean result = FALSE;
	PasswordType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* key;
	GnomeKeyringPasswordSchema* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GnomeKeyringResult _tmp6_ = 0;
	GnomeKeyringResult _result_;
	GnomeKeyringResult _tmp7_;
	GnomeKeyringResult _tmp10_;
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp0_ = password_type;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp1_ = username;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp2_ = keyring_get_key (_tmp0_, _tmp1_);
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	key = _tmp2_;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp3_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp4_ = key;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp5_ = key;
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp6_ = gnome_keyring_store_password_sync (_tmp3_, NULL, _tmp4_, "", "user", _tmp5_, NULL);
#line 60 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_result_ = _tmp6_;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp7_ = _result_;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	if (_tmp7_ != GNOME_KEYRING_RESULT_OK) {
#line 330 "util-keyring.c"
		GnomeKeyringResult _tmp8_;
		const gchar* _tmp9_ = NULL;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp8_ = _result_;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp9_ = _gnome_keyring_result_to_string (_tmp8_);
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		g_debug ("util-keyring.vala:64: Unable to clear password in GNOME keyring: %s", _tmp9_);
#line 339 "util-keyring.c"
	}
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp10_ = _result_;
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = _tmp10_ == GNOME_KEYRING_RESULT_OK;
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (key);
#line 66 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 349 "util-keyring.c"
}


void keyring_delete_password (const gchar* username, PasswordType password_type) {
	GnomeKeyringPasswordSchema* _tmp0_;
	PasswordType _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GnomeKeyringPasswordSchema* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 69 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	g_return_if_fail (username != NULL);
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp0_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp1_ = password_type;
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp2_ = username;
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp3_ = keyring_get_key (_tmp1_, _tmp2_);
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp4_ = _tmp3_;
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	gnome_keyring_delete_password_sync (_tmp0_, "user", _tmp4_, NULL);
#line 71 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (_tmp4_);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp5_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp6_ = username;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp7_ = g_strconcat (OLD_GEARY_USERNAME_PREFIX, _tmp6_, NULL);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp8_ = _tmp7_;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	gnome_keyring_delete_password_sync (_tmp5_, "user", _tmp8_, NULL);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (_tmp8_);
#line 391 "util-keyring.c"
}


gchar* keyring_get_password (const gchar* username, PasswordType password_type) {
	gchar* result = NULL;
	gchar* password = NULL;
	GnomeKeyringPasswordSchema* _tmp0_;
	PasswordType _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GnomeKeyringResult _tmp6_ = 0;
	gchar* _tmp7_;
	GnomeKeyringResult _tmp8_;
	GnomeKeyringResult _result_;
	GnomeKeyringResult _tmp9_;
	GnomeKeyringResult _tmp17_;
	const gchar* _tmp20_ = NULL;
	GnomeKeyringResult _tmp21_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp0_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp1_ = password_type;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp2_ = username;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp3_ = keyring_get_key (_tmp1_, _tmp2_);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp4_ = _tmp3_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp6_ = gnome_keyring_find_password_sync (_tmp0_, &_tmp5_, "user", _tmp4_, NULL);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (password);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp7_ = g_strdup (_tmp5_);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	password = _tmp7_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp8_ = _tmp6_;
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (_tmp4_);
#line 80 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_result_ = _tmp8_;
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp9_ = _result_;
#line 83 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	if (_tmp9_ != GNOME_KEYRING_RESULT_OK) {
#line 444 "util-keyring.c"
		GnomeKeyringPasswordSchema* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_ = NULL;
		GnomeKeyringResult _tmp15_ = 0;
		gchar* _tmp16_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp10_ = GNOME_KEYRING_NETWORK_PASSWORD;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp11_ = username;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp12_ = g_strconcat (OLD_GEARY_USERNAME_PREFIX, _tmp11_, NULL);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp13_ = _tmp12_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp15_ = gnome_keyring_find_password_sync (_tmp10_, &_tmp14_, "user", _tmp13_, NULL);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_g_free0 (password);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp16_ = g_strdup (_tmp14_);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		password = _tmp16_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_result_ = _tmp15_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_g_free0 (_tmp13_);
#line 472 "util-keyring.c"
	}
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp17_ = _result_;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	if (_tmp17_ != GNOME_KEYRING_RESULT_OK) {
#line 478 "util-keyring.c"
		GnomeKeyringResult _tmp18_;
		const gchar* _tmp19_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp18_ = _result_;
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp19_ = _gnome_keyring_result_to_string (_tmp18_);
#line 90 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		g_debug ("util-keyring.vala:90: Unable to fetch password in GNOME keyring: %s", _tmp19_);
#line 487 "util-keyring.c"
	}
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp21_ = _result_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	if (_tmp21_ == GNOME_KEYRING_RESULT_OK) {
#line 493 "util-keyring.c"
		const gchar* _tmp22_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp22_ = password;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp20_ = _tmp22_;
#line 499 "util-keyring.c"
	} else {
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
		_tmp20_ = NULL;
#line 503 "util-keyring.c"
	}
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp23_ = _tmp20_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	result = _tmp24_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	_g_free0 (password);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/util/util-keyring.vala"
	return result;
#line 515 "util-keyring.c"
}



