/* geary-attachment.c generated by valac 0.18.0, the Vala compiler
 * generated from geary-attachment.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define GEARY_TYPE_ATTACHMENT (geary_attachment_get_type ())
#define GEARY_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ATTACHMENT, GearyAttachment))
#define GEARY_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ATTACHMENT, GearyAttachmentClass))
#define GEARY_IS_ATTACHMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ATTACHMENT))
#define GEARY_IS_ATTACHMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ATTACHMENT))
#define GEARY_ATTACHMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ATTACHMENT, GearyAttachmentClass))

typedef struct _GearyAttachment GearyAttachment;
typedef struct _GearyAttachmentClass GearyAttachmentClass;
typedef struct _GearyAttachmentPrivate GearyAttachmentPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GEARY_EMAIL_TYPE_FIELD (geary_email_field_get_type ())
typedef struct _GearyParamSpecAttachment GearyParamSpecAttachment;

struct _GearyAttachment {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyAttachmentPrivate * priv;
};

struct _GearyAttachmentClass {
	GTypeClass parent_class;
	void (*finalize) (GearyAttachment *self);
};

struct _GearyAttachmentPrivate {
	gchar* _filename;
	gchar* _filepath;
	gchar* _mime_type;
	gint64 _filesize;
	gint64 _id;
};

typedef enum  {
	GEARY_EMAIL_FIELD_NONE = 0,
	GEARY_EMAIL_FIELD_DATE = 1 << 0,
	GEARY_EMAIL_FIELD_ORIGINATORS = 1 << 1,
	GEARY_EMAIL_FIELD_RECEIVERS = 1 << 2,
	GEARY_EMAIL_FIELD_REFERENCES = 1 << 3,
	GEARY_EMAIL_FIELD_SUBJECT = 1 << 4,
	GEARY_EMAIL_FIELD_HEADER = 1 << 5,
	GEARY_EMAIL_FIELD_BODY = 1 << 6,
	GEARY_EMAIL_FIELD_PROPERTIES = 1 << 7,
	GEARY_EMAIL_FIELD_PREVIEW = 1 << 8,
	GEARY_EMAIL_FIELD_FLAGS = 1 << 9,
	GEARY_EMAIL_FIELD_ENVELOPE = (((GEARY_EMAIL_FIELD_DATE | GEARY_EMAIL_FIELD_ORIGINATORS) | GEARY_EMAIL_FIELD_RECEIVERS) | GEARY_EMAIL_FIELD_REFERENCES) | GEARY_EMAIL_FIELD_SUBJECT,
	GEARY_EMAIL_FIELD_ALL = 0xFFFFFFFFLL
} GearyEmailField;

struct _GearyParamSpecAttachment {
	GParamSpec parent_instance;
};


static gpointer geary_attachment_parent_class = NULL;

gpointer geary_attachment_ref (gpointer instance);
void geary_attachment_unref (gpointer instance);
GParamSpec* geary_param_spec_attachment (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_value_set_attachment (GValue* value, gpointer v_object);
void geary_value_take_attachment (GValue* value, gpointer v_object);
gpointer geary_value_get_attachment (const GValue* value);
GType geary_attachment_get_type (void) G_GNUC_CONST;
#define GEARY_ATTACHMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_TYPE_ATTACHMENT, GearyAttachmentPrivate))
enum  {
	GEARY_ATTACHMENT_DUMMY_PROPERTY
};
GType geary_email_field_get_type (void) G_GNUC_CONST;
#define GEARY_ATTACHMENT_REQUIRED_FIELDS (GEARY_EMAIL_FIELD_HEADER | GEARY_EMAIL_FIELD_BODY)
GearyAttachment* geary_attachment_new (GFile* data_dir, const gchar* filename, const gchar* mime_type, gint64 filesize, gint64 message_id, gint64 attachment_id);
GearyAttachment* geary_attachment_construct (GType object_type, GFile* data_dir, const gchar* filename, const gchar* mime_type, gint64 filesize, gint64 message_id, gint64 attachment_id);
static void geary_attachment_set_filename (GearyAttachment* self, const gchar* value);
static void geary_attachment_set_mime_type (GearyAttachment* self, const gchar* value);
static void geary_attachment_set_filesize (GearyAttachment* self, gint64 value);
gchar* geary_attachment_get_path (GFile* data_dir, gint64 message_id, gint64 attachment_id, const gchar* filename);
static void geary_attachment_set_filepath (GearyAttachment* self, const gchar* value);
static void geary_attachment_set_id (GearyAttachment* self, gint64 value);
const gchar* geary_attachment_get_filename (GearyAttachment* self);
const gchar* geary_attachment_get_filepath (GearyAttachment* self);
const gchar* geary_attachment_get_mime_type (GearyAttachment* self);
gint64 geary_attachment_get_filesize (GearyAttachment* self);
gint64 geary_attachment_get_id (GearyAttachment* self);
static void geary_attachment_finalize (GearyAttachment* obj);


GearyAttachment* geary_attachment_construct (GType object_type, GFile* data_dir, const gchar* filename, const gchar* mime_type, gint64 filesize, gint64 message_id, gint64 attachment_id) {
	GearyAttachment* self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint64 _tmp2_;
	GFile* _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gint64 _tmp9_;
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (G_IS_FILE (data_dir), NULL);
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self = (GearyAttachment*) g_type_create_instance (object_type);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = filename;
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_set_filename (self, _tmp0_);
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp1_ = mime_type;
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_set_mime_type (self, _tmp1_);
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp2_ = filesize;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_set_filesize (self, _tmp2_);
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp3_ = data_dir;
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp4_ = message_id;
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp5_ = attachment_id;
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp6_ = filename;
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp7_ = geary_attachment_get_path (_tmp3_, _tmp4_, _tmp5_, _tmp6_);
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp8_ = _tmp7_;
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_set_filepath (self, _tmp8_);
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (_tmp8_);
#line 23 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp9_ = attachment_id;
#line 23 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_set_id (self, _tmp9_);
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return self;
#line 157 "geary-attachment.c"
}


GearyAttachment* geary_attachment_new (GFile* data_dir, const gchar* filename, const gchar* mime_type, gint64 filesize, gint64 message_id, gint64 attachment_id) {
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return geary_attachment_construct (GEARY_TYPE_ATTACHMENT, data_dir, filename, mime_type, filesize, message_id, attachment_id);
#line 164 "geary-attachment.c"
}


gchar* geary_attachment_get_path (GFile* data_dir, gint64 message_id, gint64 attachment_id, const gchar* filename) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gint64 _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gint64 _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
#line 26 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (G_IS_FILE (data_dir), NULL);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = filename;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp2_ = _tmp1_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp3_ = _tmp2_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (_tmp3_ == NULL) {
#line 198 "geary-attachment.c"
		gchar* _tmp4_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		_tmp4_ = g_strdup ("none");
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		_g_free0 (_tmp2_);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		_tmp2_ = _tmp4_;
#line 206 "geary-attachment.c"
	}
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp5_ = data_dir;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp7_ = _tmp6_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp8_ = message_id;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp8_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp10_ = _tmp9_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp11_ = attachment_id;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp13_ = _tmp12_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp14_ = _tmp2_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp15_ = g_strdup_printf ("%s/attachments/%s/%s/%s", _tmp7_, _tmp10_, _tmp13_, _tmp14_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp16_ = _tmp15_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (_tmp13_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (_tmp10_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (_tmp7_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp16_;
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (_tmp2_);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 244 "geary-attachment.c"
}


const gchar* geary_attachment_get_filename (GearyAttachment* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (GEARY_IS_ATTACHMENT (self), NULL);
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = self->priv->_filename;
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 259 "geary-attachment.c"
}


static void geary_attachment_set_filename (GearyAttachment* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (self));
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = value;
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_filename);
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv->_filename = _tmp1_;
#line 276 "geary-attachment.c"
}


const gchar* geary_attachment_get_filepath (GearyAttachment* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (GEARY_IS_ATTACHMENT (self), NULL);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = self->priv->_filepath;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp0_;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 291 "geary-attachment.c"
}


static void geary_attachment_set_filepath (GearyAttachment* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (self));
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = value;
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_filepath);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv->_filepath = _tmp1_;
#line 308 "geary-attachment.c"
}


const gchar* geary_attachment_get_mime_type (GearyAttachment* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (GEARY_IS_ATTACHMENT (self), NULL);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = self->priv->_mime_type;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 323 "geary-attachment.c"
}


static void geary_attachment_set_mime_type (GearyAttachment* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = value;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_mime_type);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv->_mime_type = _tmp1_;
#line 340 "geary-attachment.c"
}


gint64 geary_attachment_get_filesize (GearyAttachment* self) {
	gint64 result;
	gint64 _tmp0_;
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (GEARY_IS_ATTACHMENT (self), 0LL);
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = self->priv->_filesize;
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp0_;
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 355 "geary-attachment.c"
}


static void geary_attachment_set_filesize (GearyAttachment* self, gint64 value) {
	gint64 _tmp0_;
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (self));
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = value;
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv->_filesize = _tmp0_;
#line 367 "geary-attachment.c"
}


gint64 geary_attachment_get_id (GearyAttachment* self) {
	gint64 result;
	gint64 _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (GEARY_IS_ATTACHMENT (self), 0LL);
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = self->priv->_id;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	result = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return result;
#line 382 "geary-attachment.c"
}


static void geary_attachment_set_id (GearyAttachment* self, gint64 value) {
	gint64 _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (GEARY_IS_ATTACHMENT (self));
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_tmp0_ = value;
#line 14 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv->_id = _tmp0_;
#line 394 "geary-attachment.c"
}


static void geary_value_attachment_init (GValue* value) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	value->data[0].v_pointer = NULL;
#line 401 "geary-attachment.c"
}


static void geary_value_attachment_free_value (GValue* value) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		geary_attachment_unref (value->data[0].v_pointer);
#line 410 "geary-attachment.c"
	}
}


static void geary_value_attachment_copy_value (const GValue* src_value, GValue* dest_value) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (src_value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		dest_value->data[0].v_pointer = geary_attachment_ref (src_value->data[0].v_pointer);
#line 420 "geary-attachment.c"
	} else {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		dest_value->data[0].v_pointer = NULL;
#line 424 "geary-attachment.c"
	}
}


static gpointer geary_value_attachment_peek_pointer (const GValue* value) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return value->data[0].v_pointer;
#line 432 "geary-attachment.c"
}


static gchar* geary_value_attachment_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (collect_values[0].v_pointer) {
#line 439 "geary-attachment.c"
		GearyAttachment* object;
		object = collect_values[0].v_pointer;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		if (object->parent_instance.g_class == NULL) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 446 "geary-attachment.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 450 "geary-attachment.c"
		}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = geary_attachment_ref (object);
#line 454 "geary-attachment.c"
	} else {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = NULL;
#line 458 "geary-attachment.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return NULL;
#line 462 "geary-attachment.c"
}


static gchar* geary_value_attachment_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GearyAttachment** object_p;
	object_p = collect_values[0].v_pointer;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (!object_p) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 473 "geary-attachment.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (!value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		*object_p = NULL;
#line 479 "geary-attachment.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		*object_p = value->data[0].v_pointer;
#line 483 "geary-attachment.c"
	} else {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		*object_p = geary_attachment_ref (value->data[0].v_pointer);
#line 487 "geary-attachment.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return NULL;
#line 491 "geary-attachment.c"
}


GParamSpec* geary_param_spec_attachment (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GearyParamSpecAttachment* spec;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_TYPE_ATTACHMENT), NULL);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return G_PARAM_SPEC (spec);
#line 505 "geary-attachment.c"
}


gpointer geary_value_get_attachment (const GValue* value) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_TYPE_ATTACHMENT), NULL);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return value->data[0].v_pointer;
#line 514 "geary-attachment.c"
}


void geary_value_set_attachment (GValue* value, gpointer v_object) {
	GearyAttachment* old;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_TYPE_ATTACHMENT));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	old = value->data[0].v_pointer;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (v_object) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_TYPE_ATTACHMENT));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = v_object;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		geary_attachment_ref (value->data[0].v_pointer);
#line 534 "geary-attachment.c"
	} else {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = NULL;
#line 538 "geary-attachment.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (old) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		geary_attachment_unref (old);
#line 544 "geary-attachment.c"
	}
}


void geary_value_take_attachment (GValue* value, gpointer v_object) {
	GearyAttachment* old;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_TYPE_ATTACHMENT));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	old = value->data[0].v_pointer;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (v_object) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_TYPE_ATTACHMENT));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = v_object;
#line 563 "geary-attachment.c"
	} else {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		value->data[0].v_pointer = NULL;
#line 567 "geary-attachment.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (old) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		geary_attachment_unref (old);
#line 573 "geary-attachment.c"
	}
}


static void geary_attachment_class_init (GearyAttachmentClass * klass) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	geary_attachment_parent_class = g_type_class_peek_parent (klass);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	GEARY_ATTACHMENT_CLASS (klass)->finalize = geary_attachment_finalize;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_type_class_add_private (klass, sizeof (GearyAttachmentPrivate));
#line 585 "geary-attachment.c"
}


static void geary_attachment_instance_init (GearyAttachment * self) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->priv = GEARY_ATTACHMENT_GET_PRIVATE (self);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self->ref_count = 1;
#line 594 "geary-attachment.c"
}


static void geary_attachment_finalize (GearyAttachment* obj) {
	GearyAttachment * self;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ATTACHMENT, GearyAttachment);
#line 10 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_filename);
#line 11 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_filepath);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	_g_free0 (self->priv->_mime_type);
#line 608 "geary-attachment.c"
}


GType geary_attachment_get_type (void) {
	static volatile gsize geary_attachment_type_id__volatile = 0;
	if (g_once_init_enter (&geary_attachment_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_value_attachment_init, geary_value_attachment_free_value, geary_value_attachment_copy_value, geary_value_attachment_peek_pointer, "p", geary_value_attachment_collect_value, "p", geary_value_attachment_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyAttachmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_attachment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyAttachment), 0, (GInstanceInitFunc) geary_attachment_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_attachment_type_id;
		geary_attachment_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyAttachment", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&geary_attachment_type_id__volatile, geary_attachment_type_id);
	}
	return geary_attachment_type_id__volatile;
}


gpointer geary_attachment_ref (gpointer instance) {
	GearyAttachment* self;
	self = instance;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	g_atomic_int_inc (&self->ref_count);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	return instance;
#line 633 "geary-attachment.c"
}


void geary_attachment_unref (gpointer instance) {
	GearyAttachment* self;
	self = instance;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		GEARY_ATTACHMENT_GET_CLASS (self)->finalize (self);
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-attachment.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 646 "geary-attachment.c"
	}
}



