/* geary-endpoint.c generated by valac 0.18.0, the Vala compiler
 * generated from geary-endpoint.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define GEARY_TYPE_ENDPOINT (geary_endpoint_get_type ())
#define GEARY_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ENDPOINT, GearyEndpoint))
#define GEARY_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ENDPOINT, GearyEndpointClass))
#define GEARY_IS_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ENDPOINT))
#define GEARY_IS_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ENDPOINT))
#define GEARY_ENDPOINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ENDPOINT, GearyEndpointClass))

typedef struct _GearyEndpoint GearyEndpoint;
typedef struct _GearyEndpointClass GearyEndpointClass;
typedef struct _GearyEndpointPrivate GearyEndpointPrivate;

#define GEARY_ENDPOINT_TYPE_FLAGS (geary_endpoint_flags_get_type ())

#define GEARY_ENDPOINT_TYPE_ATTEMPT_STARTTLS (geary_endpoint_attempt_starttls_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyEndpointConnectAsyncData GearyEndpointConnectAsyncData;

struct _GearyEndpoint {
	GObject parent_instance;
	GearyEndpointPrivate * priv;
};

struct _GearyEndpointClass {
	GObjectClass parent_class;
};

typedef enum  {
	GEARY_ENDPOINT_FLAGS_NONE = 0,
	GEARY_ENDPOINT_FLAGS_SSL = 1 << 0,
	GEARY_ENDPOINT_FLAGS_STARTTLS = 1 << 1,
	GEARY_ENDPOINT_FLAGS_GRACEFUL_DISCONNECT = 1 << 2
} GearyEndpointFlags;

struct _GearyEndpointPrivate {
	gchar* _host_specifier;
	guint16 _default_port;
	GearyEndpointFlags _flags;
	guint _timeout_sec;
	GSocketClient* socket_client;
};

typedef enum  {
	GEARY_ENDPOINT_ATTEMPT_STARTTLS_YES,
	GEARY_ENDPOINT_ATTEMPT_STARTTLS_NO,
	GEARY_ENDPOINT_ATTEMPT_STARTTLS_HALT
} GearyEndpointAttemptStarttls;

struct _GearyEndpointConnectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearyEndpoint* self;
	GCancellable* cancellable;
	GSocketConnection* result;
	GSocketClient* _tmp0_;
	GSocketClient* _tmp1_;
	const gchar* _tmp2_;
	guint16 _tmp3_;
	GCancellable* _tmp4_;
	GSocketConnection* _tmp5_;
	GSocketConnection* _tmp6_;
	GSocketConnection* cx;
	GTcpConnection* _tmp7_;
	GTcpConnection* tcp;
	GTcpConnection* _tmp8_;
	GTcpConnection* _tmp9_;
	GearyEndpointFlags _tmp10_;
	gboolean _tmp11_;
	GError * _inner_error_;
};


static gpointer geary_endpoint_parent_class = NULL;

GType geary_endpoint_get_type (void) G_GNUC_CONST;
GType geary_endpoint_flags_get_type (void) G_GNUC_CONST;
#define GEARY_ENDPOINT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_TYPE_ENDPOINT, GearyEndpointPrivate))
enum  {
	GEARY_ENDPOINT_DUMMY_PROPERTY,
	GEARY_ENDPOINT_HOST_SPECIFIER,
	GEARY_ENDPOINT_FLAGS,
	GEARY_ENDPOINT_TIMEOUT_SEC,
	GEARY_ENDPOINT_IS_SSL,
	GEARY_ENDPOINT_USE_STARTTLS
};
gboolean geary_endpoint_flags_is_all_set (GearyEndpointFlags self, GearyEndpointFlags flags);
gboolean geary_endpoint_flags_is_any_set (GearyEndpointFlags self, GearyEndpointFlags flags);
GType geary_endpoint_attempt_starttls_get_type (void) G_GNUC_CONST;
GearyEndpoint* geary_endpoint_new (const gchar* host_specifier, guint16 default_port, GearyEndpointFlags flags, guint timeout_sec);
GearyEndpoint* geary_endpoint_construct (GType object_type, const gchar* host_specifier, guint16 default_port, GearyEndpointFlags flags, guint timeout_sec);
static void geary_endpoint_set_host_specifier (GearyEndpoint* self, const gchar* value);
static void geary_endpoint_set_default_port (GearyEndpoint* self, guint16 value);
static void geary_endpoint_set_flags (GearyEndpoint* self, GearyEndpointFlags value);
static void geary_endpoint_set_timeout_sec (GearyEndpoint* self, guint value);
GSocketClient* geary_endpoint_get_socket_client (GearyEndpoint* self);
GearyEndpointFlags geary_endpoint_get_flags (GearyEndpoint* self);
guint geary_endpoint_get_timeout_sec (GearyEndpoint* self);
static void geary_endpoint_connect_async_data_free (gpointer _data);
void geary_endpoint_connect_async (GearyEndpoint* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GSocketConnection* geary_endpoint_connect_finish (GearyEndpoint* self, GAsyncResult* _res_, GError** error);
static gboolean geary_endpoint_connect_async_co (GearyEndpointConnectAsyncData* _data_);
const gchar* geary_endpoint_get_host_specifier (GearyEndpoint* self);
guint16 geary_endpoint_get_default_port (GearyEndpoint* self);
static void geary_endpoint_connect_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GearyEndpointAttemptStarttls geary_endpoint_attempt_starttls (GearyEndpoint* self, gboolean starttls_available);
gboolean geary_endpoint_get_is_ssl (GearyEndpoint* self);
gboolean geary_endpoint_get_use_starttls (GearyEndpoint* self);
gchar* geary_endpoint_to_string (GearyEndpoint* self);
static void geary_endpoint_finalize (GObject* obj);
static void _vala_geary_endpoint_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_geary_endpoint_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


inline gboolean geary_endpoint_flags_is_all_set (GearyEndpointFlags self, GearyEndpointFlags flags) {
	gboolean result = FALSE;
	GearyEndpointFlags _tmp0_;
	GearyEndpointFlags _tmp1_;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = flags;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = flags;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = (self & _tmp0_) == _tmp1_;
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 145 "geary-endpoint.c"
}


inline gboolean geary_endpoint_flags_is_any_set (GearyEndpointFlags self, GearyEndpointFlags flags) {
	gboolean result = FALSE;
	GearyEndpointFlags _tmp0_;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = flags;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = (self & _tmp0_) != 0;
#line 25 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 158 "geary-endpoint.c"
}


GType geary_endpoint_flags_get_type (void) {
	static volatile gsize geary_endpoint_flags_type_id__volatile = 0;
	if (g_once_init_enter (&geary_endpoint_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{GEARY_ENDPOINT_FLAGS_NONE, "GEARY_ENDPOINT_FLAGS_NONE", "none"}, {GEARY_ENDPOINT_FLAGS_SSL, "GEARY_ENDPOINT_FLAGS_SSL", "ssl"}, {GEARY_ENDPOINT_FLAGS_STARTTLS, "GEARY_ENDPOINT_FLAGS_STARTTLS", "starttls"}, {GEARY_ENDPOINT_FLAGS_GRACEFUL_DISCONNECT, "GEARY_ENDPOINT_FLAGS_GRACEFUL_DISCONNECT", "graceful-disconnect"}, {0, NULL, NULL}};
		GType geary_endpoint_flags_type_id;
		geary_endpoint_flags_type_id = g_flags_register_static ("GearyEndpointFlags", values);
		g_once_init_leave (&geary_endpoint_flags_type_id__volatile, geary_endpoint_flags_type_id);
	}
	return geary_endpoint_flags_type_id__volatile;
}


GType geary_endpoint_attempt_starttls_get_type (void) {
	static volatile gsize geary_endpoint_attempt_starttls_type_id__volatile = 0;
	if (g_once_init_enter (&geary_endpoint_attempt_starttls_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_ENDPOINT_ATTEMPT_STARTTLS_YES, "GEARY_ENDPOINT_ATTEMPT_STARTTLS_YES", "yes"}, {GEARY_ENDPOINT_ATTEMPT_STARTTLS_NO, "GEARY_ENDPOINT_ATTEMPT_STARTTLS_NO", "no"}, {GEARY_ENDPOINT_ATTEMPT_STARTTLS_HALT, "GEARY_ENDPOINT_ATTEMPT_STARTTLS_HALT", "halt"}, {0, NULL, NULL}};
		GType geary_endpoint_attempt_starttls_type_id;
		geary_endpoint_attempt_starttls_type_id = g_enum_register_static ("GearyEndpointAttemptStarttls", values);
		g_once_init_leave (&geary_endpoint_attempt_starttls_type_id__volatile, geary_endpoint_attempt_starttls_type_id);
	}
	return geary_endpoint_attempt_starttls_type_id__volatile;
}


GearyEndpoint* geary_endpoint_construct (GType object_type, const gchar* host_specifier, guint16 default_port, GearyEndpointFlags flags, guint timeout_sec) {
	GearyEndpoint * self = NULL;
	const gchar* _tmp0_;
	guint16 _tmp1_;
	GearyEndpointFlags _tmp2_;
	guint _tmp3_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (host_specifier != NULL, NULL);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self = (GearyEndpoint*) g_object_new (object_type, NULL);
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = host_specifier;
#line 51 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_host_specifier (self, _tmp0_);
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = default_port;
#line 52 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_default_port (self, _tmp1_);
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp2_ = flags;
#line 53 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_flags (self, _tmp2_);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp3_ = timeout_sec;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_set_timeout_sec (self, _tmp3_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return self;
#line 214 "geary-endpoint.c"
}


GearyEndpoint* geary_endpoint_new (const gchar* host_specifier, guint16 default_port, GearyEndpointFlags flags, guint timeout_sec) {
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return geary_endpoint_construct (GEARY_TYPE_ENDPOINT, host_specifier, default_port, flags, timeout_sec);
#line 221 "geary-endpoint.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 59 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "geary-endpoint.c"
}


GSocketClient* geary_endpoint_get_socket_client (GearyEndpoint* self) {
	GSocketClient* result = NULL;
	GSocketClient* _tmp0_;
	GSocketClient* _tmp3_;
	GearyEndpointFlags _tmp4_;
	gboolean _tmp5_ = FALSE;
	GSocketClient* _tmp8_;
	guint _tmp9_;
	GSocketClient* _tmp10_;
	GSocketClient* _tmp11_;
#line 57 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->socket_client;
#line 58 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_tmp0_ != NULL) {
#line 248 "geary-endpoint.c"
		GSocketClient* _tmp1_;
		GSocketClient* _tmp2_;
#line 59 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp1_ = self->priv->socket_client;
#line 59 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 59 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		result = _tmp2_;
#line 59 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		return result;
#line 259 "geary-endpoint.c"
	}
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp3_ = g_socket_client_new ();
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->socket_client);
#line 61 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->socket_client = _tmp3_;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp4_ = self->priv->_flags;
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp5_ = geary_endpoint_flags_is_all_set (_tmp4_, GEARY_ENDPOINT_FLAGS_SSL);
#line 63 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_tmp5_) {
#line 273 "geary-endpoint.c"
		GSocketClient* _tmp6_;
		GSocketClient* _tmp7_;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp6_ = self->priv->socket_client;
#line 64 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_socket_client_set_tls (_tmp6_, TRUE);
#line 65 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp7_ = self->priv->socket_client;
#line 65 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_socket_client_set_tls_validation_flags (_tmp7_, G_TLS_CERTIFICATE_UNKNOWN_CA);
#line 284 "geary-endpoint.c"
	}
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp8_ = self->priv->socket_client;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp9_ = self->priv->_timeout_sec;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_socket_client_set_timeout (_tmp8_, _tmp9_);
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp10_ = self->priv->socket_client;
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp11_;
#line 70 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 300 "geary-endpoint.c"
}


static void geary_endpoint_connect_async_data_free (gpointer _data) {
	GearyEndpointConnectAsyncData* _data_;
	_data_ = _data;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->result);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->self);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_slice_free (GearyEndpointConnectAsyncData, _data_);
#line 315 "geary-endpoint.c"
}


void geary_endpoint_connect_async (GearyEndpoint* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearyEndpointConnectAsyncData* _data_;
	GearyEndpoint* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_ = g_slice_new0 (GearyEndpointConnectAsyncData);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_endpoint_connect_async);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_endpoint_connect_async_data_free);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->self = _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = cancellable;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cancellable);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->cancellable = _tmp2_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_connect_async_co (_data_);
#line 344 "geary-endpoint.c"
}


GSocketConnection* geary_endpoint_connect_finish (GearyEndpoint* self, GAsyncResult* _res_, GError** error) {
	GSocketConnection* result;
	GearyEndpointConnectAsyncData* _data_;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		return NULL;
#line 355 "geary-endpoint.c"
	}
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _data_->result;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->result = NULL;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 365 "geary-endpoint.c"
}


static void geary_endpoint_connect_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearyEndpointConnectAsyncData* _data_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_ = _user_data_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_source_object_ = source_object;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_res_ = _res_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_connect_async_co (_data_);
#line 379 "geary-endpoint.c"
}


static gboolean geary_endpoint_connect_async_co (GearyEndpointConnectAsyncData* _data_) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	switch (_data_->_state_) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case 0:
#line 388 "geary-endpoint.c"
		goto _state_0;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case 1:
#line 392 "geary-endpoint.c"
		goto _state_1;
		default:
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_assert_not_reached ();
#line 397 "geary-endpoint.c"
	}
	_state_0:
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp0_ = NULL;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp0_ = geary_endpoint_get_socket_client (_data_->self);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp2_ = _data_->self->priv->_host_specifier;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp3_ = _data_->self->priv->_default_port;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp4_ = _data_->cancellable;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_state_ = 1;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_socket_client_connect_to_host_async (_data_->_tmp1_, _data_->_tmp2_, _data_->_tmp3_, _data_->_tmp4_, geary_endpoint_connect_async_ready, _data_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 418 "geary-endpoint.c"
	_state_1:
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp5_ = NULL;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp5_ = g_socket_client_connect_to_host_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->cx = _data_->_tmp6_;
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_data_->_inner_error_ != NULL) {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_error_free (_data_->_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		if (_data_->_state_ == 0) {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 440 "geary-endpoint.c"
		} else {
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 444 "geary-endpoint.c"
		}
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_object_unref (_data_->_async_result);
#line 74 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		return FALSE;
#line 450 "geary-endpoint.c"
	}
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->cx, g_tcp_connection_get_type ()) ? ((GTcpConnection*) _data_->cx) : NULL);
#line 77 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->tcp = _data_->_tmp7_;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->_tmp8_ = _data_->tcp;
#line 78 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_data_->_tmp8_ != NULL) {
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_data_->_tmp9_ = _data_->tcp;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_data_->_tmp10_ = _data_->self->priv->_flags;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_data_->_tmp11_ = FALSE;
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_data_->_tmp11_ = geary_endpoint_flags_is_all_set (_data_->_tmp10_, GEARY_ENDPOINT_FLAGS_GRACEFUL_DISCONNECT);
#line 79 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_tcp_connection_set_graceful_disconnect (_data_->_tmp9_, _data_->_tmp11_);
#line 470 "geary-endpoint.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_data_->result = _data_->cx;
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->tcp);
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_data_->_state_ == 0) {
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 480 "geary-endpoint.c"
	} else {
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 484 "geary-endpoint.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_unref (_data_->_async_result);
#line 81 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->tcp);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (_data_->cx);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_data_->_state_ == 0) {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 498 "geary-endpoint.c"
	} else {
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 502 "geary-endpoint.c"
	}
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_unref (_data_->_async_result);
#line 73 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return FALSE;
#line 508 "geary-endpoint.c"
}


/**
     * Returns true if a STARTTLS command should be attempted on the connection:
     * (a) STARTTLS is reported available (a parameter specified by the caller to this method),
     * (b) not using SSL (so TLS is not required), and (c) STARTTLS is specified as a flag on
     * the Endpoint.
     *
     * If AttemptStarttls.HALT is returned, the caller should not proceed to pass any
     * authentication information down the connection; this situation indicates the connection is
     * insecure and the Endpoint is configured otherwise.
     */
GearyEndpointAttemptStarttls geary_endpoint_attempt_starttls (GearyEndpoint* self, gboolean starttls_available) {
	GearyEndpointAttemptStarttls result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 94 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = geary_endpoint_get_is_ssl (self);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp2_ = _tmp1_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_tmp2_) {
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp0_ = TRUE;
#line 539 "geary-endpoint.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp3_ = geary_endpoint_get_use_starttls (self);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp4_ = _tmp3_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		_tmp0_ = !_tmp4_;
#line 549 "geary-endpoint.c"
	}
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp5_ = _tmp0_;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (_tmp5_) {
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		result = GEARY_ENDPOINT_ATTEMPT_STARTTLS_NO;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		return result;
#line 559 "geary-endpoint.c"
	}
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp6_ = starttls_available;
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	if (!_tmp6_) {
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		result = GEARY_ENDPOINT_ATTEMPT_STARTTLS_HALT;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		return result;
#line 569 "geary-endpoint.c"
	}
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = GEARY_ENDPOINT_ATTEMPT_STARTTLS_YES;
#line 101 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 575 "geary-endpoint.c"
}


gchar* geary_endpoint_to_string (GearyEndpoint* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	guint16 _tmp1_;
	gchar* _tmp2_ = NULL;
#line 104 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_host_specifier;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = self->priv->_default_port;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp2_ = g_strdup_printf ("%s/default:%u", _tmp0_, (guint) _tmp1_);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp2_;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 596 "geary-endpoint.c"
}


const gchar* geary_endpoint_get_host_specifier (GearyEndpoint* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), NULL);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_host_specifier;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 611 "geary-endpoint.c"
}


static void geary_endpoint_set_host_specifier (GearyEndpoint* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = value;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_free0 (self->priv->_host_specifier);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->_host_specifier = _tmp1_;
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_notify ((GObject *) self, "host-specifier");
#line 630 "geary-endpoint.c"
}


guint16 geary_endpoint_get_default_port (GearyEndpoint* self) {
	guint16 result;
	guint16 _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0U);
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_default_port;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 645 "geary-endpoint.c"
}


static void geary_endpoint_set_default_port (GearyEndpoint* self, guint16 value) {
	guint16 _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->_default_port = _tmp0_;
#line 657 "geary-endpoint.c"
}


GearyEndpointFlags geary_endpoint_get_flags (GearyEndpoint* self) {
	GearyEndpointFlags result;
	GearyEndpointFlags _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0);
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_flags;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 672 "geary-endpoint.c"
}


static void geary_endpoint_set_flags (GearyEndpoint* self, GearyEndpointFlags value) {
	GearyEndpointFlags _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->_flags = _tmp0_;
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_notify ((GObject *) self, "flags");
#line 686 "geary-endpoint.c"
}


guint geary_endpoint_get_timeout_sec (GearyEndpoint* self) {
	guint result;
	guint _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), 0U);
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_timeout_sec;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 701 "geary-endpoint.c"
}


static void geary_endpoint_set_timeout_sec (GearyEndpoint* self, guint value) {
	guint _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_if_fail (GEARY_IS_ENDPOINT (self));
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->_timeout_sec = _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_notify ((GObject *) self, "timeout-sec");
#line 715 "geary-endpoint.c"
}


gboolean geary_endpoint_get_is_ssl (GearyEndpoint* self) {
	gboolean result;
	GearyEndpointFlags _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), FALSE);
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_flags;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = geary_endpoint_flags_is_all_set (_tmp0_, GEARY_ENDPOINT_FLAGS_SSL);
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp1_;
#line 41 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 733 "geary-endpoint.c"
}


gboolean geary_endpoint_get_use_starttls (GearyEndpoint* self) {
	gboolean result;
	GearyEndpointFlags _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 44 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (self), FALSE);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp0_ = self->priv->_flags;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_tmp1_ = geary_endpoint_flags_is_all_set (_tmp0_, GEARY_ENDPOINT_FLAGS_STARTTLS);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	result = _tmp1_;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	return result;
#line 751 "geary-endpoint.c"
}


static void geary_endpoint_class_init (GearyEndpointClass * klass) {
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	geary_endpoint_parent_class = g_type_class_peek_parent (klass);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_type_class_add_private (klass, sizeof (GearyEndpointPrivate));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_endpoint_get_property;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_endpoint_set_property;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_endpoint_finalize;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_HOST_SPECIFIER, g_param_spec_string ("host-specifier", "host-specifier", "host-specifier", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_FLAGS, g_param_spec_flags ("flags", "flags", "flags", GEARY_ENDPOINT_TYPE_FLAGS, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_TIMEOUT_SEC, g_param_spec_uint ("timeout-sec", "timeout-sec", "timeout-sec", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_IS_SSL, g_param_spec_boolean ("is-ssl", "is-ssl", "is-ssl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_ENDPOINT_USE_STARTTLS, g_param_spec_boolean ("use-starttls", "use-starttls", "use-starttls", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 776 "geary-endpoint.c"
}


static void geary_endpoint_instance_init (GearyEndpoint * self) {
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv = GEARY_ENDPOINT_GET_PRIVATE (self);
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self->priv->socket_client = NULL;
#line 785 "geary-endpoint.c"
}


static void geary_endpoint_finalize (GObject* obj) {
	GearyEndpoint * self;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_free0 (self->priv->_host_specifier);
#line 48 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	_g_object_unref0 (self->priv->socket_client);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	G_OBJECT_CLASS (geary_endpoint_parent_class)->finalize (obj);
#line 799 "geary-endpoint.c"
}


/**
 * An Endpoint represents the location of an Internet TCP connection as represented by a host,
 * a port, and flags and other parameters that specify the nature of the connection itself.
 */
GType geary_endpoint_get_type (void) {
	static volatile gsize geary_endpoint_type_id__volatile = 0;
	if (g_once_init_enter (&geary_endpoint_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyEndpointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_endpoint_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyEndpoint), 0, (GInstanceInitFunc) geary_endpoint_instance_init, NULL };
		GType geary_endpoint_type_id;
		geary_endpoint_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyEndpoint", &g_define_type_info, 0);
		g_once_init_leave (&geary_endpoint_type_id__volatile, geary_endpoint_type_id);
	}
	return geary_endpoint_type_id__volatile;
}


static void _vala_geary_endpoint_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GearyEndpoint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	switch (property_id) {
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_HOST_SPECIFIER:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_value_set_string (value, geary_endpoint_get_host_specifier (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_FLAGS:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_value_set_flags (value, geary_endpoint_get_flags (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TIMEOUT_SEC:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_value_set_uint (value, geary_endpoint_get_timeout_sec (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_IS_SSL:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_value_set_boolean (value, geary_endpoint_get_is_ssl (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_USE_STARTTLS:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		g_value_set_boolean (value, geary_endpoint_get_use_starttls (self));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 854 "geary-endpoint.c"
		default:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 860 "geary-endpoint.c"
	}
}


static void _vala_geary_endpoint_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GearyEndpoint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_ENDPOINT, GearyEndpoint);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
	switch (property_id) {
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_HOST_SPECIFIER:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_host_specifier (self, g_value_get_string (value));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_FLAGS:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_flags (self, g_value_get_flags (value));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		case GEARY_ENDPOINT_TIMEOUT_SEC:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		geary_endpoint_set_timeout_sec (self, g_value_get_uint (value));
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 888 "geary-endpoint.c"
		default:
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/builddir/build/BUILD/geary-0.2.2/src/engine/api/geary-endpoint.vala"
		break;
#line 894 "geary-endpoint.c"
	}
}



