/* smtp-authenticator.c generated by valac 0.18.0, the Vala compiler
 * generated from smtp-authenticator.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_SMTP_TYPE_AUTHENTICATOR (geary_smtp_authenticator_get_type ())
#define GEARY_SMTP_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticator))
#define GEARY_SMTP_IS_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_AUTHENTICATOR))
#define GEARY_SMTP_AUTHENTICATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_SMTP_TYPE_AUTHENTICATOR, GearySmtpAuthenticatorIface))

typedef struct _GearySmtpAuthenticator GearySmtpAuthenticator;
typedef struct _GearySmtpAuthenticatorIface GearySmtpAuthenticatorIface;

#define GEARY_SMTP_TYPE_REQUEST (geary_smtp_request_get_type ())
#define GEARY_SMTP_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_REQUEST, GearySmtpRequest))
#define GEARY_SMTP_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_REQUEST, GearySmtpRequestClass))
#define GEARY_SMTP_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_REQUEST))
#define GEARY_SMTP_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_REQUEST))
#define GEARY_SMTP_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_REQUEST, GearySmtpRequestClass))

typedef struct _GearySmtpRequest GearySmtpRequest;
typedef struct _GearySmtpRequestClass GearySmtpRequestClass;

#define GEARY_SMTP_TYPE_RESPONSE (geary_smtp_response_get_type ())
#define GEARY_SMTP_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponse))
#define GEARY_SMTP_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))
#define GEARY_SMTP_IS_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_IS_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_RESPONSE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))

typedef struct _GearySmtpResponse GearySmtpResponse;
typedef struct _GearySmtpResponseClass GearySmtpResponseClass;

typedef enum  {
	GEARY_SMTP_ERROR_PARSE_ERROR,
	GEARY_SMTP_ERROR_STARTTLS_FAILED,
	GEARY_SMTP_ERROR_AUTHENTICATION_FAILED,
	GEARY_SMTP_ERROR_SERVER_ERROR,
	GEARY_SMTP_ERROR_ALREADY_CONNECTED,
	GEARY_SMTP_ERROR_NOT_CONNECTED,
	GEARY_SMTP_ERROR_REQUIRED_FIELD,
	GEARY_SMTP_ERROR_NOT_SUPPORTED
} GearySmtpError;
#define GEARY_SMTP_ERROR geary_smtp_error_quark ()
struct _GearySmtpAuthenticatorIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (GearySmtpAuthenticator* self);
	GearySmtpRequest* (*initiate) (GearySmtpAuthenticator* self);
	guint8* (*challenge) (GearySmtpAuthenticator* self, gint step, GearySmtpResponse* response, int* result_length1, GError** error);
	gchar* (*to_string) (GearySmtpAuthenticator* self);
};



gpointer geary_smtp_request_ref (gpointer instance);
void geary_smtp_request_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_request (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_smtp_value_set_request (GValue* value, gpointer v_object);
void geary_smtp_value_take_request (GValue* value, gpointer v_object);
gpointer geary_smtp_value_get_request (const GValue* value);
GType geary_smtp_request_get_type (void) G_GNUC_CONST;
gpointer geary_smtp_response_ref (gpointer instance);
void geary_smtp_response_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_response (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_smtp_value_set_response (GValue* value, gpointer v_object);
void geary_smtp_value_take_response (GValue* value, gpointer v_object);
gpointer geary_smtp_value_get_response (const GValue* value);
GType geary_smtp_response_get_type (void) G_GNUC_CONST;
GQuark geary_smtp_error_quark (void);
GType geary_smtp_authenticator_get_type (void) G_GNUC_CONST;
gchar* geary_smtp_authenticator_get_name (GearySmtpAuthenticator* self);
GearySmtpRequest* geary_smtp_authenticator_initiate (GearySmtpAuthenticator* self);
guint8* geary_smtp_authenticator_challenge (GearySmtpAuthenticator* self, gint step, GearySmtpResponse* response, int* result_length1, GError** error);
gchar* geary_smtp_authenticator_to_string (GearySmtpAuthenticator* self);
static gchar* geary_smtp_authenticator_real_to_string (GearySmtpAuthenticator* self);


gchar* geary_smtp_authenticator_get_name (GearySmtpAuthenticator* self) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	return GEARY_SMTP_AUTHENTICATOR_GET_INTERFACE (self)->get_name (self);
#line 94 "smtp-authenticator.c"
}


/**
     * Returns a Request that is used to initiate the challenge-response.
     */
GearySmtpRequest* geary_smtp_authenticator_initiate (GearySmtpAuthenticator* self) {
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 13 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	return GEARY_SMTP_AUTHENTICATOR_GET_INTERFACE (self)->initiate (self);
#line 106 "smtp-authenticator.c"
}


/**
     * Returns a block of data that will be sent for that stage of the authentication challenge.
     * No line terminators should be present.  Various authentication schemes may also have their
     * own requirements.
     *
     * step is the zero-based step number of the challenge-response.  Response is the *last*
     * SMTP response from the server from the prior step (or from the initiate() request).
     * 
     * Returns null if the Authenticator chooses to end the process in an orderly fashion.
     * 
     * If an error is thrown, the entire process is aborted without any further I/O with the
     * server.  Generally this leaves the connection in a bad state and should be closed.
     */
guint8* geary_smtp_authenticator_challenge (GearySmtpAuthenticator* self, gint step, GearySmtpResponse* response, int* result_length1, GError** error) {
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	return GEARY_SMTP_AUTHENTICATOR_GET_INTERFACE (self)->challenge (self, step, response, result_length1, error);
#line 128 "smtp-authenticator.c"
}


static gchar* geary_smtp_authenticator_real_to_string (GearySmtpAuthenticator* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	_tmp0_ = geary_smtp_authenticator_get_name (self);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	return result;
#line 141 "smtp-authenticator.c"
}


gchar* geary_smtp_authenticator_to_string (GearySmtpAuthenticator* self) {
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_AUTHENTICATOR (self), NULL);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	return GEARY_SMTP_AUTHENTICATOR_GET_INTERFACE (self)->to_string (self);
#line 150 "smtp-authenticator.c"
}


static void geary_smtp_authenticator_base_init (GearySmtpAuthenticatorIface * iface) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	static gboolean initialized = FALSE;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
	if (!initialized) {
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
		initialized = TRUE;
#line 7 "/builddir/build/BUILD/geary-0.2.2/src/engine/smtp/smtp-authenticator.vala"
		iface->to_string = geary_smtp_authenticator_real_to_string;
#line 163 "smtp-authenticator.c"
	}
}


GType geary_smtp_authenticator_get_type (void) {
	static volatile gsize geary_smtp_authenticator_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_authenticator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearySmtpAuthenticatorIface), (GBaseInitFunc) geary_smtp_authenticator_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType geary_smtp_authenticator_type_id;
		geary_smtp_authenticator_type_id = g_type_register_static (G_TYPE_INTERFACE, "GearySmtpAuthenticator", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (geary_smtp_authenticator_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&geary_smtp_authenticator_type_id__volatile, geary_smtp_authenticator_type_id);
	}
	return geary_smtp_authenticator_type_id__volatile;
}



