/* login-dialog.c generated by valac 0.18.0, the Vala compiler
 * generated from login-dialog.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* Displays a dialog for collecting the user's login data.*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "geary-static.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_LOGIN_DIALOG (login_dialog_get_type ())
#define LOGIN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_DIALOG, LoginDialog))
#define LOGIN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_DIALOG, LoginDialogClass))
#define IS_LOGIN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_DIALOG))
#define IS_LOGIN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_DIALOG))
#define LOGIN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_DIALOG, LoginDialogClass))

typedef struct _LoginDialog LoginDialog;
typedef struct _LoginDialogClass LoginDialogClass;
typedef struct _LoginDialogPrivate LoginDialogPrivate;

#define LOGIN_DIALOG_TYPE_ENCRYPTION (login_dialog_encryption_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _geary_credentials_unref0(var) ((var == NULL) ? NULL : (var = (geary_credentials_unref (var), NULL)))
typedef struct _ParamSpecLoginDialog ParamSpecLoginDialog;

struct _LoginDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LoginDialogPrivate * priv;
};

struct _LoginDialogClass {
	GTypeClass parent_class;
	void (*finalize) (LoginDialog *self);
};

struct _LoginDialogPrivate {
	GtkDialog* dialog;
	GtkEntry* entry_email;
	GtkLabel* label_password;
	GtkEntry* entry_password;
	GtkEntry* entry_real_name;
	GtkComboBoxText* combo_service;
	GtkCheckButton* check_remember_password;
	GtkAlignment* other_info;
	GtkEntry* entry_imap_host;
	GtkEntry* entry_imap_port;
	GtkEntry* entry_imap_username;
	GtkEntry* entry_imap_password;
	GtkComboBox* combo_imap_encryption;
	GtkEntry* entry_smtp_host;
	GtkEntry* entry_smtp_port;
	GtkEntry* entry_smtp_username;
	GtkEntry* entry_smtp_password;
	GtkComboBox* combo_smtp_encryption;
	GtkButton* ok_button;
	gboolean edited_imap_port;
	gboolean edited_smtp_port;
	GearyAccountInformation* _account_information;
};

typedef enum  {
	LOGIN_DIALOG_ENCRYPTION_NONE = 0,
	LOGIN_DIALOG_ENCRYPTION_SSL = 1,
	LOGIN_DIALOG_ENCRYPTION_STARTTLS = 2
} LoginDialogEncryption;

struct _ParamSpecLoginDialog {
	GParamSpec parent_instance;
};


static gpointer login_dialog_parent_class = NULL;

gpointer login_dialog_ref (gpointer instance);
void login_dialog_unref (gpointer instance);
GParamSpec* param_spec_login_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_login_dialog (GValue* value, gpointer v_object);
void value_take_login_dialog (GValue* value, gpointer v_object);
gpointer value_get_login_dialog (const GValue* value);
GType login_dialog_get_type (void) G_GNUC_CONST;
#define LOGIN_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LOGIN_DIALOG, LoginDialogPrivate))
enum  {
	LOGIN_DIALOG_DUMMY_PROPERTY
};
static GType login_dialog_encryption_get_type (void) G_GNUC_UNUSED;
LoginDialog* login_dialog_new_from_account_information (GearyAccountInformation* initial_account_information);
LoginDialog* login_dialog_construct_from_account_information (GType object_type, GearyAccountInformation* initial_account_information);
LoginDialog* login_dialog_new (const gchar* initial_real_name, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls);
LoginDialog* login_dialog_construct (GType object_type, const gchar* initial_real_name, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void);
GtkBuilder* geary_application_create_builder (GearyApplication* self, const gchar* ui_filename);
static void login_dialog_on_service_changed (LoginDialog* self);
static void _login_dialog_on_service_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void login_dialog_on_changed (LoginDialog* self);
static void _login_dialog_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void _login_dialog_on_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void _login_dialog_on_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void login_dialog_on_email_changed (LoginDialog* self);
static void _login_dialog_on_email_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void login_dialog_on_password_changed (LoginDialog* self);
static void _login_dialog_on_password_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void login_dialog_on_imap_encryption_changed (LoginDialog* self);
static void _login_dialog_on_imap_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void login_dialog_on_smtp_encryption_changed (LoginDialog* self);
static void _login_dialog_on_smtp_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void login_dialog_on_port_insert_text (LoginDialog* self, GtkEditable* e, const gchar* text, gint length, gint* position);
static void _login_dialog_on_port_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self);
static gboolean login_dialog_is_complete (LoginDialog* self);
gboolean login_dialog_show (LoginDialog* self);
static GearyServiceProvider login_dialog_get_service_provider (LoginDialog* self);
static void login_dialog_set_account_information (LoginDialog* self, GearyAccountInformation* value);
GearyAccountInformation* login_dialog_get_account_information (LoginDialog* self);
static guint16 login_dialog_get_default_imap_port (LoginDialog* self);
static guint16 login_dialog_get_default_smtp_port (LoginDialog* self);
static gboolean login_dialog_is_valid_port (LoginDialog* self, const gchar* text);
static void login_dialog_finalize (LoginDialog* obj);


static GType login_dialog_encryption_get_type (void) {
	static volatile gsize login_dialog_encryption_type_id__volatile = 0;
	if (g_once_init_enter (&login_dialog_encryption_type_id__volatile)) {
		static const GEnumValue values[] = {{LOGIN_DIALOG_ENCRYPTION_NONE, "LOGIN_DIALOG_ENCRYPTION_NONE", "none"}, {LOGIN_DIALOG_ENCRYPTION_SSL, "LOGIN_DIALOG_ENCRYPTION_SSL", "ssl"}, {LOGIN_DIALOG_ENCRYPTION_STARTTLS, "LOGIN_DIALOG_ENCRYPTION_STARTTLS", "starttls"}, {0, NULL, NULL}};
		GType login_dialog_encryption_type_id;
		login_dialog_encryption_type_id = g_enum_register_static ("LoginDialogEncryption", values);
		g_once_init_leave (&login_dialog_encryption_type_id__volatile, login_dialog_encryption_type_id);
	}
	return login_dialog_encryption_type_id__volatile;
}


LoginDialog* login_dialog_construct_from_account_information (GType object_type, GearyAccountInformation* initial_account_information) {
	LoginDialog* self = NULL;
	gboolean _tmp0_ = FALSE;
	GearyAccountInformation* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GearyAccountInformation* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GearyAccountInformation* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GearyAccountInformation* _tmp13_;
	GearyCredentials* _tmp14_;
	GearyCredentials* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GearyAccountInformation* _tmp18_;
	GearyCredentials* _tmp19_;
	GearyCredentials* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gboolean _tmp23_;
	GearyAccountInformation* _tmp24_;
	GearyCredentials* _tmp25_;
	GearyCredentials* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GearyAccountInformation* _tmp29_;
	GearyCredentials* _tmp30_;
	GearyCredentials* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	GearyAccountInformation* _tmp34_;
	GearyServiceProvider _tmp35_;
	GearyServiceProvider _tmp36_;
	GearyAccountInformation* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GearyAccountInformation* _tmp40_;
	guint16 _tmp41_;
	guint16 _tmp42_;
	GearyAccountInformation* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	GearyAccountInformation* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	GearyAccountInformation* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	GearyAccountInformation* _tmp52_;
	guint16 _tmp53_;
	guint16 _tmp54_;
	GearyAccountInformation* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	GearyAccountInformation* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (initial_account_information), NULL);
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self = (LoginDialog*) g_type_create_instance (object_type);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = initial_account_information;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = geary_account_information_get_imap_remember_password (_tmp1_);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = _tmp2_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp3_) {
#line 230 "login-dialog.c"
		GearyAccountInformation* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp4_ = initial_account_information;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp5_ = geary_account_information_get_smtp_remember_password (_tmp4_);
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp6_ = _tmp5_;
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp0_ = _tmp6_;
#line 242 "login-dialog.c"
	} else {
#line 54 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp0_ = FALSE;
#line 246 "login-dialog.c"
	}
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp7_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp8_ = geary_account_information_get_real_name (_tmp7_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp9_ = _tmp8_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp10_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp11_ = geary_account_information_get_email (_tmp10_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp12_ = _tmp11_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp13_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp14_ = geary_account_information_get_imap_credentials (_tmp13_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp15_ = _tmp14_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp16_ = geary_credentials_get_user (_tmp15_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp17_ = _tmp16_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp18_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp19_ = geary_account_information_get_imap_credentials (_tmp18_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp20_ = _tmp19_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp21_ = geary_credentials_get_pass (_tmp20_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp22_ = _tmp21_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp23_ = _tmp0_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp24_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp25_ = geary_account_information_get_smtp_credentials (_tmp24_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp26_ = _tmp25_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp27_ = geary_credentials_get_user (_tmp26_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp28_ = _tmp27_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp29_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp30_ = geary_account_information_get_smtp_credentials (_tmp29_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp31_ = _tmp30_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp32_ = geary_credentials_get_pass (_tmp31_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp33_ = _tmp32_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp34_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp35_ = geary_account_information_get_service_provider (_tmp34_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp36_ = _tmp35_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp37_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp38_ = geary_account_information_get_default_imap_server_host (_tmp37_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp39_ = _tmp38_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp40_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp41_ = geary_account_information_get_default_imap_server_port (_tmp40_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp42_ = _tmp41_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp43_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp44_ = geary_account_information_get_default_imap_server_ssl (_tmp43_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp45_ = _tmp44_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp46_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp47_ = geary_account_information_get_default_imap_server_starttls (_tmp46_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp48_ = _tmp47_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp49_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp50_ = geary_account_information_get_default_smtp_server_host (_tmp49_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp51_ = _tmp50_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp52_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp53_ = geary_account_information_get_default_smtp_server_port (_tmp52_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp54_ = _tmp53_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp55_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp56_ = geary_account_information_get_default_smtp_server_ssl (_tmp55_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp57_ = _tmp56_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp58_ = initial_account_information;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp59_ = geary_account_information_get_default_smtp_server_starttls (_tmp58_);
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp60_ = _tmp59_;
#line 50 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self = (LoginDialog*) login_dialog_construct (object_type, _tmp9_, _tmp12_, _tmp17_, _tmp22_, _tmp23_, _tmp28_, _tmp33_, (gint) _tmp36_, _tmp39_, _tmp42_, _tmp45_, _tmp48_, _tmp51_, _tmp54_, _tmp57_, _tmp60_);
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return self;
#line 360 "login-dialog.c"
}


LoginDialog* login_dialog_new_from_account_information (GearyAccountInformation* initial_account_information) {
#line 49 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return login_dialog_construct_from_account_information (TYPE_LOGIN_DIALOG, initial_account_information);
#line 367 "login-dialog.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 374 "login-dialog.c"
}


static void _login_dialog_on_service_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_service_changed (self);
#line 381 "login-dialog.c"
}


static void _login_dialog_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 166 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_changed (self);
#line 388 "login-dialog.c"
}


static void _login_dialog_on_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 169 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_changed (self);
#line 395 "login-dialog.c"
}


static void _login_dialog_on_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 170 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_changed (self);
#line 402 "login-dialog.c"
}


static void _login_dialog_on_email_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 180 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_email_changed (self);
#line 409 "login-dialog.c"
}


static void _login_dialog_on_password_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 181 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_password_changed (self);
#line 416 "login-dialog.c"
}


static void _login_dialog_on_imap_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 183 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_imap_encryption_changed (self);
#line 423 "login-dialog.c"
}


static void _login_dialog_on_smtp_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 184 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_smtp_encryption_changed (self);
#line 430 "login-dialog.c"
}


static void _login_dialog_on_port_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self) {
#line 186 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_port_insert_text (self, _sender, new_text, new_text_length, position);
#line 437 "login-dialog.c"
}


LoginDialog* login_dialog_construct (GType object_type, const gchar* initial_real_name, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls) {
	LoginDialog* self = NULL;
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	GtkBuilder* _tmp2_ = NULL;
	GtkBuilder* builder;
	GtkBuilder* _tmp3_;
	GObject* _tmp4_ = NULL;
	GtkDialog* _tmp5_;
	GtkDialog* _tmp6_;
	GtkDialog* _tmp7_;
	GtkBuilder* _tmp8_;
	GObject* _tmp9_ = NULL;
	GtkLabel* _tmp10_;
	GtkLabel* label_welcome;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	GtkBuilder* _tmp16_;
	GObject* _tmp17_ = NULL;
	GtkEntry* _tmp18_;
	GtkBuilder* _tmp19_;
	GObject* _tmp20_ = NULL;
	GtkComboBoxText* _tmp21_;
	GtkBuilder* _tmp22_;
	GObject* _tmp23_ = NULL;
	GtkEntry* _tmp24_;
	GtkBuilder* _tmp25_;
	GObject* _tmp26_ = NULL;
	GtkLabel* _tmp27_;
	GtkBuilder* _tmp28_;
	GObject* _tmp29_ = NULL;
	GtkEntry* _tmp30_;
	GtkBuilder* _tmp31_;
	GObject* _tmp32_ = NULL;
	GtkCheckButton* _tmp33_;
	GtkBuilder* _tmp34_;
	GObject* _tmp35_ = NULL;
	GtkAlignment* _tmp36_;
	GtkBuilder* _tmp37_;
	GObject* _tmp38_ = NULL;
	GtkEntry* _tmp39_;
	GtkBuilder* _tmp40_;
	GObject* _tmp41_ = NULL;
	GtkEntry* _tmp42_;
	GtkBuilder* _tmp43_;
	GObject* _tmp44_ = NULL;
	GtkEntry* _tmp45_;
	GtkBuilder* _tmp46_;
	GObject* _tmp47_ = NULL;
	GtkEntry* _tmp48_;
	GtkBuilder* _tmp49_;
	GObject* _tmp50_ = NULL;
	GtkComboBox* _tmp51_;
	GtkBuilder* _tmp52_;
	GObject* _tmp53_ = NULL;
	GtkEntry* _tmp54_;
	GtkBuilder* _tmp55_;
	GObject* _tmp56_ = NULL;
	GtkEntry* _tmp57_;
	GtkBuilder* _tmp58_;
	GObject* _tmp59_ = NULL;
	GtkEntry* _tmp60_;
	GtkBuilder* _tmp61_;
	GObject* _tmp62_ = NULL;
	GtkEntry* _tmp63_;
	GtkBuilder* _tmp64_;
	GObject* _tmp65_ = NULL;
	GtkComboBox* _tmp66_;
	GtkComboBoxText* _tmp67_;
	gint _tmp68_ = 0;
	GearyServiceProvider* _tmp69_ = NULL;
	GtkComboBoxText* _tmp78_;
	gint _tmp79_ = 0;
	const gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	const gchar* _tmp84_;
	GtkEntry* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	const gchar* _tmp91_;
	GtkEntry* _tmp93_;
	const gchar* _tmp94_;
	gboolean _tmp95_ = FALSE;
	const gchar* _tmp96_;
	const gchar* _tmp97_;
	gboolean _tmp99_;
	gboolean use_imap_password;
	const gchar* _tmp100_ = NULL;
	gboolean _tmp101_;
	GtkEntry* _tmp103_;
	const gchar* _tmp104_;
	GtkCheckButton* _tmp105_;
	gboolean _tmp106_;
	const gchar* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	const gchar* _tmp110_;
	GtkEntry* _tmp112_;
	const gchar* _tmp113_;
	GtkEntry* _tmp114_;
	guint16 _tmp115_;
	gchar* _tmp116_ = NULL;
	gchar* _tmp117_;
	const gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	const gchar* _tmp121_;
	GtkEntry* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	gchar* _tmp126_;
	gchar* _tmp127_;
	const gchar* _tmp128_;
	GtkEntry* _tmp130_;
	const gchar* _tmp131_;
	gboolean _tmp132_;
	const gchar* _tmp137_;
	gchar* _tmp138_;
	gchar* _tmp139_;
	const gchar* _tmp140_;
	GtkEntry* _tmp142_;
	const gchar* _tmp143_;
	GtkEntry* _tmp144_;
	guint16 _tmp145_;
	gchar* _tmp146_ = NULL;
	gchar* _tmp147_;
	const gchar* _tmp148_;
	gchar* _tmp149_;
	gchar* _tmp150_;
	const gchar* _tmp151_;
	GtkEntry* _tmp153_;
	const gchar* _tmp154_;
	const gchar* _tmp155_;
	gchar* _tmp156_;
	gchar* _tmp157_;
	const gchar* _tmp158_;
	GtkEntry* _tmp160_;
	const gchar* _tmp161_;
	gboolean _tmp162_;
	GtkEntry* _tmp167_;
	const gchar* _tmp168_;
	const gchar* _tmp169_;
	gboolean _tmp170_ = FALSE;
	GtkEntry* _tmp173_;
	GtkEntry* _tmp174_;
	GtkEntry* _tmp175_;
	GtkCheckButton* _tmp176_;
	GtkComboBoxText* _tmp177_;
	GtkEntry* _tmp178_;
	GtkEntry* _tmp179_;
	GtkEntry* _tmp180_;
	GtkEntry* _tmp181_;
	GtkEntry* _tmp182_;
	GtkEntry* _tmp183_;
	GtkEntry* _tmp184_;
	GtkEntry* _tmp185_;
	GtkEntry* _tmp186_;
	GtkEntry* _tmp187_;
	GtkComboBox* _tmp188_;
	GtkComboBox* _tmp189_;
	GtkEntry* _tmp190_;
	GtkEntry* _tmp191_;
	GtkDialog* _tmp192_;
	GtkButton* _tmp193_;
	GtkButton* _tmp194_;
	GtkButton* _tmp195_;
	GtkButton* _tmp196_;
	GtkButton* _tmp197_;
	gboolean _tmp198_ = FALSE;
	GtkDialog* _tmp199_;
	GtkButton* _tmp200_;
	GtkDialog* _tmp201_;
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self = (LoginDialog*) g_type_create_instance (object_type);
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = geary_application_get_instance ();
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = _tmp0_;
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = geary_application_create_builder (_tmp1_, "login.glade");
#line 85 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	builder = _tmp2_;
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = builder;
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = gtk_builder_get_object (_tmp3_, "LoginDialog");
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GTK_TYPE_DIALOG) ? ((GtkDialog*) _tmp4_) : NULL);
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 87 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->dialog = _tmp5_;
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp6_ = self->priv->dialog;
#line 88 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_window_set_type_hint (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_WINDOW, GtkWindow), GDK_WINDOW_TYPE_HINT_DIALOG);
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp7_ = self->priv->dialog;
#line 89 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_dialog_set_default_response (_tmp7_, (gint) GTK_RESPONSE_OK);
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp8_ = builder;
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp9_ = gtk_builder_get_object (_tmp8_, "label-welcome");
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_LABEL, GtkLabel));
#line 91 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	label_welcome = _tmp10_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp11_ = label_welcome;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp12_ = _ ("Welcome to Geary.");
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp13_ = _ ("Enter your account information to get started.");
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp14_ = g_strdup_printf ("<span size=\"large\"><b>%s</b></span>\n%s", _tmp12_, _tmp13_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp15_ = _tmp14_;
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_label_set_markup (_tmp11_, _tmp15_);
#line 92 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp15_);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp16_ = builder;
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp17_ = gtk_builder_get_object (_tmp16_, "entry: real_name");
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp17_) : NULL);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_real_name);
#line 95 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_real_name = _tmp18_;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp19_ = builder;
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp20_ = gtk_builder_get_object (_tmp19_, "combo: service");
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, GTK_TYPE_COMBO_BOX_TEXT) ? ((GtkComboBoxText*) _tmp20_) : NULL);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_service);
#line 96 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->combo_service = _tmp21_;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp22_ = builder;
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp23_ = gtk_builder_get_object (_tmp22_, "entry: email");
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp23_) : NULL);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_email);
#line 97 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_email = _tmp24_;
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp25_ = builder;
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp26_ = gtk_builder_get_object (_tmp25_, "label: password");
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, GTK_TYPE_LABEL) ? ((GtkLabel*) _tmp26_) : NULL);
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->label_password);
#line 98 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->label_password = _tmp27_;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp28_ = builder;
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp29_ = gtk_builder_get_object (_tmp28_, "entry: password");
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp29_) : NULL);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 99 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_password = _tmp30_;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp31_ = builder;
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp32_ = gtk_builder_get_object (_tmp31_, "check: remember_password");
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp33_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, GTK_TYPE_CHECK_BUTTON) ? ((GtkCheckButton*) _tmp32_) : NULL);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 100 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->check_remember_password = _tmp33_;
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp34_ = builder;
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp35_ = gtk_builder_get_object (_tmp34_, "container: other_info");
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp35_, GTK_TYPE_ALIGNMENT) ? ((GtkAlignment*) _tmp35_) : NULL);
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->other_info);
#line 102 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->other_info = _tmp36_;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp37_ = builder;
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp38_ = gtk_builder_get_object (_tmp37_, "entry: imap host");
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp38_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp38_) : NULL);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_host);
#line 105 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_imap_host = _tmp39_;
#line 106 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp40_ = builder;
#line 106 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp41_ = gtk_builder_get_object (_tmp40_, "entry: imap port");
#line 106 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp41_) : NULL);
#line 106 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_port);
#line 106 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_imap_port = _tmp42_;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp43_ = builder;
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp44_ = gtk_builder_get_object (_tmp43_, "entry: imap username");
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp44_) : NULL);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_username);
#line 107 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_imap_username = _tmp45_;
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp46_ = builder;
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp47_ = gtk_builder_get_object (_tmp46_, "entry: imap password");
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp47_) : NULL);
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 108 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_imap_password = _tmp48_;
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp49_ = builder;
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp50_ = gtk_builder_get_object (_tmp49_, "combo: imap encryption");
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp51_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, GTK_TYPE_COMBO_BOX) ? ((GtkComboBox*) _tmp50_) : NULL);
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_imap_encryption);
#line 109 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->combo_imap_encryption = _tmp51_;
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp52_ = builder;
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp53_ = gtk_builder_get_object (_tmp52_, "entry: smtp host");
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp54_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp53_) : NULL);
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_host);
#line 112 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_smtp_host = _tmp54_;
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp55_ = builder;
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp56_ = gtk_builder_get_object (_tmp55_, "entry: smtp port");
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp57_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp56_) : NULL);
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_port);
#line 113 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_smtp_port = _tmp57_;
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp58_ = builder;
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp59_ = gtk_builder_get_object (_tmp58_, "entry: smtp username");
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp60_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp59_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp59_) : NULL);
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_username);
#line 114 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_smtp_username = _tmp60_;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp61_ = builder;
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp62_ = gtk_builder_get_object (_tmp61_, "entry: smtp password");
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp63_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp62_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp62_) : NULL);
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 115 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->entry_smtp_password = _tmp63_;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp64_ = builder;
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp65_ = gtk_builder_get_object (_tmp64_, "combo: smtp encryption");
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp66_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp65_, GTK_TYPE_COMBO_BOX) ? ((GtkComboBox*) _tmp65_) : NULL);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_smtp_encryption);
#line 116 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->combo_smtp_encryption = _tmp66_;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp67_ = self->priv->combo_service;
#line 118 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GTK_TYPE_COMBO_BOX, GtkComboBox), "changed", (GCallback) _login_dialog_on_service_changed_gtk_combo_box_changed, self);
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp69_ = geary_service_provider_get_providers (&_tmp68_);
#line 845 "login-dialog.c"
	{
		GearyServiceProvider* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		p_collection = _tmp69_;
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		p_collection_length1 = _tmp68_;
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		for (p_it = 0; p_it < _tmp68_; p_it = p_it + 1) {
#line 857 "login-dialog.c"
			GearyServiceProvider p = 0;
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			p = p_collection[p_it];
#line 861 "login-dialog.c"
			{
				GtkComboBoxText* _tmp70_;
				GearyServiceProvider _tmp71_;
				gchar* _tmp72_ = NULL;
				gchar* _tmp73_;
				GearyServiceProvider _tmp74_;
				gint _tmp75_;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp70_ = self->priv->combo_service;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp71_ = p;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp72_ = geary_service_provider_display_name (_tmp71_);
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp73_ = _tmp72_;
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				gtk_combo_box_text_append_text (_tmp70_, _tmp73_);
#line 121 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_g_free0 (_tmp73_);
#line 122 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp74_ = p;
#line 122 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp75_ = initial_service_provider;
#line 122 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				if (_tmp74_ == _tmp75_) {
#line 887 "login-dialog.c"
					GtkComboBoxText* _tmp76_;
					GearyServiceProvider _tmp77_;
#line 123 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
					_tmp76_ = self->priv->combo_service;
#line 123 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
					_tmp77_ = p;
#line 123 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
					gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, GTK_TYPE_COMBO_BOX, GtkComboBox), (gint) _tmp77_);
#line 896 "login-dialog.c"
				}
			}
		}
#line 120 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		p_collection = (g_free (p_collection), NULL);
#line 902 "login-dialog.c"
	}
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp78_ = self->priv->combo_service;
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp79_ = gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, GTK_TYPE_COMBO_BOX, GtkComboBox));
#line 126 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp79_ == (-1)) {
#line 910 "login-dialog.c"
		GtkComboBoxText* _tmp80_;
#line 127 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp80_ = self->priv->combo_service;
#line 127 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, GTK_TYPE_COMBO_BOX, GtkComboBox), 0);
#line 916 "login-dialog.c"
	}
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp81_ = initial_real_name;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp82_ = g_strdup (_tmp81_);
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp83_ = _tmp82_;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp84_ = _tmp83_;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp84_ == NULL) {
#line 928 "login-dialog.c"
		gchar* _tmp85_;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp85_ = g_strdup ("");
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp83_);
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp83_ = _tmp85_;
#line 936 "login-dialog.c"
	}
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp86_ = self->priv->entry_real_name;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp87_ = _tmp83_;
#line 130 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp86_, _tmp87_);
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp88_ = initial_email;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp89_ = g_strdup (_tmp88_);
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp90_ = _tmp89_;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp91_ = _tmp90_;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp91_ == NULL) {
#line 954 "login-dialog.c"
		gchar* _tmp92_;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp92_ = g_strdup ("");
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp90_);
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp90_ = _tmp92_;
#line 962 "login-dialog.c"
	}
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp93_ = self->priv->entry_email;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp94_ = _tmp90_;
#line 131 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp93_, _tmp94_);
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp96_ = initial_imap_password;
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp97_ = initial_smtp_password;
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (g_strcmp0 (_tmp96_, _tmp97_) == 0) {
#line 976 "login-dialog.c"
		const gchar* _tmp98_;
#line 133 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp98_ = initial_imap_password;
#line 133 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp95_ = _tmp98_ != NULL;
#line 982 "login-dialog.c"
	} else {
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp95_ = FALSE;
#line 986 "login-dialog.c"
	}
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp99_ = _tmp95_;
#line 132 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	use_imap_password = _tmp99_;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp101_ = use_imap_password;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp101_) {
#line 996 "login-dialog.c"
		const gchar* _tmp102_;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp102_ = initial_imap_password;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp100_ = _tmp102_;
#line 1002 "login-dialog.c"
	} else {
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp100_ = "";
#line 1006 "login-dialog.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp103_ = self->priv->entry_password;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp104_ = _tmp100_;
#line 134 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp103_, _tmp104_);
#line 135 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp105_ = self->priv->check_remember_password;
#line 135 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp106_ = initial_remember_password;
#line 135 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), _tmp106_);
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp107_ = initial_default_imap_host;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp108_ = g_strdup (_tmp107_);
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp109_ = _tmp108_;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp110_ = _tmp109_;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp110_ == NULL) {
#line 1030 "login-dialog.c"
		gchar* _tmp111_;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp111_ = g_strdup ("");
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp109_);
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp109_ = _tmp111_;
#line 1038 "login-dialog.c"
	}
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp112_ = self->priv->entry_imap_host;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp113_ = _tmp109_;
#line 138 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp112_, _tmp113_);
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp114_ = self->priv->entry_imap_port;
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp115_ = initial_default_imap_port;
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp116_ = g_strdup_printf ("%hu", _tmp115_);
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp117_ = _tmp116_;
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp114_, _tmp117_);
#line 139 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp117_);
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp118_ = initial_imap_username;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp119_ = g_strdup (_tmp118_);
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp120_ = _tmp119_;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp121_ = _tmp120_;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp121_ == NULL) {
#line 1068 "login-dialog.c"
		gchar* _tmp122_;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp122_ = g_strdup ("");
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp120_);
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp120_ = _tmp122_;
#line 1076 "login-dialog.c"
	}
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp123_ = self->priv->entry_imap_username;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp124_ = _tmp120_;
#line 140 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp123_, _tmp124_);
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp125_ = initial_imap_password;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp126_ = g_strdup (_tmp125_);
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp127_ = _tmp126_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp128_ = _tmp127_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp128_ == NULL) {
#line 1094 "login-dialog.c"
		gchar* _tmp129_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp129_ = g_strdup ("");
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp127_);
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp127_ = _tmp129_;
#line 1102 "login-dialog.c"
	}
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp130_ = self->priv->entry_imap_password;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp131_ = _tmp127_;
#line 141 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp130_, _tmp131_);
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp132_ = initial_default_imap_ssl;
#line 142 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp132_) {
#line 1114 "login-dialog.c"
		GtkComboBox* _tmp133_;
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp133_ = self->priv->combo_imap_encryption;
#line 143 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_combo_box_set_active (_tmp133_, (gint) LOGIN_DIALOG_ENCRYPTION_SSL);
#line 1120 "login-dialog.c"
	} else {
		gboolean _tmp134_;
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp134_ = initial_default_imap_starttls;
#line 144 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		if (_tmp134_) {
#line 1127 "login-dialog.c"
			GtkComboBox* _tmp135_;
#line 145 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp135_ = self->priv->combo_imap_encryption;
#line 145 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			gtk_combo_box_set_active (_tmp135_, (gint) LOGIN_DIALOG_ENCRYPTION_STARTTLS);
#line 1133 "login-dialog.c"
		} else {
			GtkComboBox* _tmp136_;
#line 147 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp136_ = self->priv->combo_imap_encryption;
#line 147 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			gtk_combo_box_set_active (_tmp136_, (gint) LOGIN_DIALOG_ENCRYPTION_NONE);
#line 1140 "login-dialog.c"
		}
	}
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp137_ = initial_default_smtp_host;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp138_ = g_strdup (_tmp137_);
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp139_ = _tmp138_;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp140_ = _tmp139_;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp140_ == NULL) {
#line 1153 "login-dialog.c"
		gchar* _tmp141_;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp141_ = g_strdup ("");
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp139_);
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp139_ = _tmp141_;
#line 1161 "login-dialog.c"
	}
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp142_ = self->priv->entry_smtp_host;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp143_ = _tmp139_;
#line 150 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp142_, _tmp143_);
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp144_ = self->priv->entry_smtp_port;
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp145_ = initial_default_smtp_port;
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp146_ = g_strdup_printf ("%hu", _tmp145_);
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp147_ = _tmp146_;
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp144_, _tmp147_);
#line 151 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp147_);
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp148_ = initial_smtp_username;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp149_ = g_strdup (_tmp148_);
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp150_ = _tmp149_;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp151_ = _tmp150_;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp151_ == NULL) {
#line 1191 "login-dialog.c"
		gchar* _tmp152_;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp152_ = g_strdup ("");
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp150_);
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp150_ = _tmp152_;
#line 1199 "login-dialog.c"
	}
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp153_ = self->priv->entry_smtp_username;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp154_ = _tmp150_;
#line 152 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp153_, _tmp154_);
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp155_ = initial_smtp_password;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp156_ = g_strdup (_tmp155_);
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp157_ = _tmp156_;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp158_ = _tmp157_;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp158_ == NULL) {
#line 1217 "login-dialog.c"
		gchar* _tmp159_;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp159_ = g_strdup ("");
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp157_);
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp157_ = _tmp159_;
#line 1225 "login-dialog.c"
	}
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp160_ = self->priv->entry_smtp_password;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp161_ = _tmp157_;
#line 153 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp160_, _tmp161_);
#line 154 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp162_ = initial_default_smtp_ssl;
#line 154 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp162_) {
#line 1237 "login-dialog.c"
		GtkComboBox* _tmp163_;
#line 155 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp163_ = self->priv->combo_smtp_encryption;
#line 155 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_combo_box_set_active (_tmp163_, (gint) LOGIN_DIALOG_ENCRYPTION_SSL);
#line 1243 "login-dialog.c"
	} else {
		gboolean _tmp164_;
#line 156 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp164_ = initial_default_smtp_starttls;
#line 156 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		if (_tmp164_) {
#line 1250 "login-dialog.c"
			GtkComboBox* _tmp165_;
#line 157 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp165_ = self->priv->combo_smtp_encryption;
#line 157 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			gtk_combo_box_set_active (_tmp165_, (gint) LOGIN_DIALOG_ENCRYPTION_STARTTLS);
#line 1256 "login-dialog.c"
		} else {
			GtkComboBox* _tmp166_;
#line 159 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp166_ = self->priv->combo_smtp_encryption;
#line 159 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			gtk_combo_box_set_active (_tmp166_, (gint) LOGIN_DIALOG_ENCRYPTION_NONE);
#line 1263 "login-dialog.c"
		}
	}
#line 161 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp167_ = self->priv->entry_real_name;
#line 161 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp168_ = gtk_entry_get_text (_tmp167_);
#line 161 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp169_ = _tmp168_;
#line 161 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp170_ = geary_string_is_empty (_tmp169_);
#line 161 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp170_) {
#line 1276 "login-dialog.c"
		GtkEntry* _tmp171_;
#line 162 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp171_ = self->priv->entry_real_name;
#line 162 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp171_, GTK_TYPE_WIDGET, GtkWidget));
#line 1282 "login-dialog.c"
	} else {
		GtkEntry* _tmp172_;
#line 164 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp172_ = self->priv->entry_email;
#line 164 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp172_, GTK_TYPE_WIDGET, GtkWidget));
#line 1289 "login-dialog.c"
	}
#line 166 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp173_ = self->priv->entry_email;
#line 166 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp173_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 167 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp174_ = self->priv->entry_password;
#line 167 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp174_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 168 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp175_ = self->priv->entry_real_name;
#line 168 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp175_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 169 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp176_ = self->priv->check_remember_password;
#line 169 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp176_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton), "toggled", (GCallback) _login_dialog_on_changed_gtk_toggle_button_toggled, self);
#line 170 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp177_ = self->priv->combo_service;
#line 170 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp177_, GTK_TYPE_COMBO_BOX, GtkComboBox), "changed", (GCallback) _login_dialog_on_changed_gtk_combo_box_changed, self);
#line 171 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp178_ = self->priv->entry_imap_host;
#line 171 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp178_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 172 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp179_ = self->priv->entry_imap_port;
#line 172 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp179_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 173 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp180_ = self->priv->entry_imap_username;
#line 173 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp180_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 174 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp181_ = self->priv->entry_imap_password;
#line 174 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp181_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 175 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp182_ = self->priv->entry_smtp_host;
#line 175 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp182_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 176 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp183_ = self->priv->entry_smtp_port;
#line 176 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp183_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 177 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp184_ = self->priv->entry_smtp_username;
#line 177 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp184_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 178 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp185_ = self->priv->entry_smtp_password;
#line 178 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp185_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_changed_gtk_editable_changed, self);
#line 180 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp186_ = self->priv->entry_email;
#line 180 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp186_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_email_changed_gtk_editable_changed, self);
#line 181 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp187_ = self->priv->entry_password;
#line 181 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp187_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _login_dialog_on_password_changed_gtk_editable_changed, self);
#line 183 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp188_ = self->priv->combo_imap_encryption;
#line 183 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (_tmp188_, "changed", (GCallback) _login_dialog_on_imap_encryption_changed_gtk_combo_box_changed, self);
#line 184 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp189_ = self->priv->combo_smtp_encryption;
#line 184 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (_tmp189_, "changed", (GCallback) _login_dialog_on_smtp_encryption_changed_gtk_combo_box_changed, self);
#line 186 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp190_ = self->priv->entry_imap_port;
#line 186 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp190_, GTK_TYPE_EDITABLE, GtkEditable), "insert-text", (GCallback) _login_dialog_on_port_insert_text_gtk_editable_insert_text, self);
#line 187 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp191_ = self->priv->entry_smtp_port;
#line 187 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp191_, GTK_TYPE_EDITABLE, GtkEditable), "insert-text", (GCallback) _login_dialog_on_port_insert_text_gtk_editable_insert_text, self);
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp192_ = self->priv->dialog;
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp193_ = (GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CANCEL);
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_object_ref_sink (_tmp193_);
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp194_ = _tmp193_;
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_dialog_add_action_widget (_tmp192_, G_TYPE_CHECK_INSTANCE_CAST (_tmp194_, GTK_TYPE_WIDGET, GtkWidget), (gint) GTK_RESPONSE_CANCEL);
#line 189 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (_tmp194_);
#line 190 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp195_ = (GtkButton*) gtk_button_new_from_stock (GTK_STOCK_OK);
#line 190 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_object_ref_sink (_tmp195_);
#line 190 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 190 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->ok_button = _tmp195_;
#line 191 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp196_ = self->priv->ok_button;
#line 191 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_set_can_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp196_, GTK_TYPE_WIDGET, GtkWidget), TRUE);
#line 192 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp197_ = self->priv->ok_button;
#line 192 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp198_ = login_dialog_is_complete (self);
#line 192 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp197_, GTK_TYPE_WIDGET, GtkWidget), _tmp198_);
#line 193 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp199_ = self->priv->dialog;
#line 193 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp200_ = self->priv->ok_button;
#line 193 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_dialog_add_action_widget (_tmp199_, G_TYPE_CHECK_INSTANCE_CAST (_tmp200_, GTK_TYPE_WIDGET, GtkWidget), (gint) GTK_RESPONSE_OK);
#line 194 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp201_ = self->priv->dialog;
#line 194 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_dialog_set_default_response (_tmp201_, (gint) GTK_RESPONSE_OK);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp157_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp150_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp139_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp127_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp120_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp109_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp90_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp83_);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (label_welcome);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (builder);
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return self;
#line 1429 "login-dialog.c"
}


LoginDialog* login_dialog_new (const gchar* initial_real_name, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls) {
#line 68 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return login_dialog_construct (TYPE_LOGIN_DIALOG, initial_real_name, initial_email, initial_imap_username, initial_imap_password, initial_remember_password, initial_smtp_username, initial_smtp_password, initial_service_provider, initial_default_imap_host, initial_default_imap_port, initial_default_imap_ssl, initial_default_imap_starttls, initial_default_smtp_host, initial_default_smtp_port, initial_default_smtp_ssl, initial_default_smtp_starttls);
#line 1436 "login-dialog.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
#line 1071 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1072 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1072 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1073 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1073 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1074 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	result = _result_;
#line 1074 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	return result;
#line 1459 "login-dialog.c"
}


gboolean login_dialog_show (LoginDialog* self) {
	gboolean result = FALSE;
	GtkDialog* _tmp0_;
	GtkDialog* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	GtkDialog* _tmp3_;
	gint _tmp4_ = 0;
	GtkResponseType response;
	GtkResponseType _tmp5_;
	GearyServiceProvider _tmp6_ = 0;
	gboolean use_extra_info;
	GtkEntry* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* email;
	gchar* _tmp11_ = NULL;
	gboolean _tmp12_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* imap_username;
	GtkEntry* _tmp21_ = NULL;
	gboolean _tmp22_;
	GtkEntry* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_ = NULL;
	gchar* imap_password;
	GtkCheckButton* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean imap_remember_password;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	GearyCredentials* _tmp34_;
	GearyCredentials* imap_credentials;
	gchar* _tmp35_ = NULL;
	gboolean _tmp36_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* smtp_username;
	GtkEntry* _tmp45_ = NULL;
	gboolean _tmp46_;
	GtkEntry* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_ = NULL;
	gchar* smtp_password;
	GtkCheckButton* _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	gboolean smtp_remember_password;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	GearyCredentials* _tmp58_;
	GearyCredentials* smtp_credentials;
	GearyAccountInformation* _tmp66_;
	GtkEntry* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_ = NULL;
	gchar* _tmp71_;
	GearyAccountInformation* _tmp72_;
	GearyCredentials* _tmp73_;
	GearyAccountInformation* _tmp74_;
	GearyCredentials* _tmp75_;
	GearyAccountInformation* _tmp76_;
	gboolean _tmp77_;
	GearyAccountInformation* _tmp78_;
	gboolean _tmp79_;
	GearyAccountInformation* _tmp80_;
	GearyServiceProvider _tmp81_ = 0;
	GearyAccountInformation* _tmp82_;
	GtkEntry* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_ = NULL;
	gchar* _tmp87_;
	GearyAccountInformation* _tmp88_;
	GtkEntry* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	gchar* _tmp92_ = NULL;
	gchar* _tmp93_;
	gint _tmp94_ = 0;
	GearyAccountInformation* _tmp95_;
	GtkComboBox* _tmp96_;
	gint _tmp97_;
	gint _tmp98_;
	GearyAccountInformation* _tmp99_;
	GtkComboBox* _tmp100_;
	gint _tmp101_;
	gint _tmp102_;
	GearyAccountInformation* _tmp103_;
	GtkEntry* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	gchar* _tmp107_ = NULL;
	gchar* _tmp108_;
	GearyAccountInformation* _tmp109_;
	GtkEntry* _tmp110_;
	const gchar* _tmp111_;
	const gchar* _tmp112_;
	gchar* _tmp113_ = NULL;
	gchar* _tmp114_;
	gint _tmp115_ = 0;
	GearyAccountInformation* _tmp116_;
	GtkComboBox* _tmp117_;
	gint _tmp118_;
	gint _tmp119_;
	GearyAccountInformation* _tmp120_;
	GtkComboBox* _tmp121_;
	gint _tmp122_;
	gint _tmp123_;
	GtkDialog* _tmp124_;
	GError * _inner_error_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), FALSE);
#line 199 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->dialog;
#line 199 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget));
#line 200 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = self->priv->dialog;
#line 200 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = gtk_dialog_get_action_area (_tmp1_);
#line 200 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_show_all (_tmp2_);
#line 201 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_service_changed (self);
#line 203 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = self->priv->dialog;
#line 203 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = gtk_dialog_run (_tmp3_);
#line 203 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	response = (GtkResponseType) _tmp4_;
#line 204 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp5_ = response;
#line 204 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp5_ != GTK_RESPONSE_OK) {
#line 205 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		result = FALSE;
#line 205 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return result;
#line 1607 "login-dialog.c"
	}
#line 207 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp6_ = login_dialog_get_service_provider (self);
#line 207 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	use_extra_info = _tmp6_ == GEARY_SERVICE_PROVIDER_OTHER;
#line 209 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp7_ = self->priv->entry_email;
#line 209 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp8_ = gtk_entry_get_text (_tmp7_);
#line 209 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp9_ = _tmp8_;
#line 209 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp10_ = string_strip (_tmp9_);
#line 209 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	email = _tmp10_;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp12_ = use_extra_info;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp12_) {
#line 1627 "login-dialog.c"
		GtkEntry* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp13_ = self->priv->entry_imap_username;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp14_ = gtk_entry_get_text (_tmp13_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp15_ = _tmp14_;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp11_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp11_ = _tmp16_;
#line 1644 "login-dialog.c"
	} else {
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp17_ = email;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp11_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp11_ = _tmp18_;
#line 1656 "login-dialog.c"
	}
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp19_ = _tmp11_;
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 210 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	imap_username = _tmp20_;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp22_ = use_extra_info;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp22_) {
#line 1668 "login-dialog.c"
		GtkEntry* _tmp23_;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp23_ = self->priv->entry_imap_password;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp21_ = _tmp23_;
#line 1674 "login-dialog.c"
	} else {
		GtkEntry* _tmp24_;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp24_ = self->priv->entry_password;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp21_ = _tmp24_;
#line 1681 "login-dialog.c"
	}
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp25_ = _tmp21_;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp26_ = gtk_entry_get_text (_tmp25_);
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp27_ = _tmp26_;
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp28_ = string_strip (_tmp27_);
#line 211 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	imap_password = _tmp28_;
#line 212 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp29_ = self->priv->check_remember_password;
#line 212 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp30_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton));
#line 212 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp31_ = _tmp30_;
#line 212 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	imap_remember_password = _tmp31_;
#line 213 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp32_ = imap_username;
#line 213 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp33_ = imap_password;
#line 213 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp34_ = geary_credentials_new (_tmp32_, _tmp33_);
#line 213 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	imap_credentials = _tmp34_;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp36_ = use_extra_info;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp36_) {
#line 1713 "login-dialog.c"
		GtkEntry* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp37_ = self->priv->entry_smtp_username;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp38_ = gtk_entry_get_text (_tmp37_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp39_ = _tmp38_;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp40_ = string_strip (_tmp39_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp35_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp35_ = _tmp40_;
#line 1730 "login-dialog.c"
	} else {
		const gchar* _tmp41_;
		gchar* _tmp42_;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp41_ = email;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp35_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp35_ = _tmp42_;
#line 1742 "login-dialog.c"
	}
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp43_ = _tmp35_;
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 215 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	smtp_username = _tmp44_;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp46_ = use_extra_info;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp46_) {
#line 1754 "login-dialog.c"
		GtkEntry* _tmp47_;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp47_ = self->priv->entry_smtp_password;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp45_ = _tmp47_;
#line 1760 "login-dialog.c"
	} else {
		GtkEntry* _tmp48_;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp48_ = self->priv->entry_password;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp45_ = _tmp48_;
#line 1767 "login-dialog.c"
	}
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp49_ = _tmp45_;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp50_ = gtk_entry_get_text (_tmp49_);
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp51_ = _tmp50_;
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp52_ = string_strip (_tmp51_);
#line 216 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	smtp_password = _tmp52_;
#line 217 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp53_ = self->priv->check_remember_password;
#line 217 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp54_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButton));
#line 217 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp55_ = _tmp54_;
#line 217 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	smtp_remember_password = _tmp55_;
#line 218 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp56_ = smtp_username;
#line 218 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp57_ = smtp_password;
#line 218 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp58_ = geary_credentials_new (_tmp56_, _tmp57_);
#line 218 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	smtp_credentials = _tmp58_;
#line 1795 "login-dialog.c"
	{
		const gchar* _tmp59_;
		GearyAccountInformation* _tmp60_ = NULL;
		GearyAccountInformation* _tmp61_;
		GearyAccountInformation* _tmp62_;
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp59_ = email;
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp60_ = geary_engine_get_account_for_email (_tmp59_, &_inner_error_);
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp61_ = _tmp60_;
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		if (_inner_error_ != NULL) {
#line 1809 "login-dialog.c"
			goto __catch37_g_error;
		}
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp62_ = _tmp61_;
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		login_dialog_set_account_information (self, _tmp62_);
#line 221 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_object_unref0 (_tmp62_);
#line 1818 "login-dialog.c"
	}
	goto __finally37;
	__catch37_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp63_;
		GError* _tmp64_;
		const gchar* _tmp65_;
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		err = _inner_error_;
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_inner_error_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp63_ = email;
#line 223 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp64_ = err;
#line 223 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp65_ = _tmp64_->message;
#line 223 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_debug ("login-dialog.vala:223: Unable to open account information for %s: %s", _tmp63_, _tmp65_);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		result = FALSE;
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_error_free0 (err);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_geary_credentials_unref0 (smtp_credentials);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (smtp_password);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (smtp_username);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp35_);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_geary_credentials_unref0 (imap_credentials);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (imap_password);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (imap_username);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp11_);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (email);
#line 225 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return result;
#line 1863 "login-dialog.c"
	}
	__finally37:
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_inner_error_ != NULL) {
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_geary_credentials_unref0 (smtp_credentials);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (smtp_password);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (smtp_username);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp35_);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_geary_credentials_unref0 (imap_credentials);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (imap_password);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (imap_username);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (_tmp11_);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_g_free0 (email);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_clear_error (&_inner_error_);
#line 220 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return FALSE;
#line 1892 "login-dialog.c"
	}
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp66_ = self->priv->_account_information;
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp67_ = self->priv->entry_real_name;
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp68_ = gtk_entry_get_text (_tmp67_);
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp69_ = _tmp68_;
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp70_ = string_strip (_tmp69_);
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp71_ = _tmp70_;
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_real_name (_tmp66_, _tmp71_);
#line 228 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp71_);
#line 229 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp72_ = self->priv->_account_information;
#line 229 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp73_ = imap_credentials;
#line 229 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_imap_credentials (_tmp72_, _tmp73_);
#line 230 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp74_ = self->priv->_account_information;
#line 230 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp75_ = smtp_credentials;
#line 230 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_smtp_credentials (_tmp74_, _tmp75_);
#line 231 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp76_ = self->priv->_account_information;
#line 231 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp77_ = imap_remember_password;
#line 231 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_imap_remember_password (_tmp76_, _tmp77_);
#line 232 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp78_ = self->priv->_account_information;
#line 232 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp79_ = smtp_remember_password;
#line 232 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_smtp_remember_password (_tmp78_, _tmp79_);
#line 233 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp80_ = self->priv->_account_information;
#line 233 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp81_ = login_dialog_get_service_provider (self);
#line 233 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_service_provider (_tmp80_, _tmp81_);
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp82_ = self->priv->_account_information;
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp83_ = self->priv->entry_imap_host;
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp84_ = gtk_entry_get_text (_tmp83_);
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp85_ = _tmp84_;
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp86_ = string_strip (_tmp85_);
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp87_ = _tmp86_;
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_imap_server_host (_tmp82_, _tmp87_);
#line 234 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp87_);
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp88_ = self->priv->_account_information;
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp89_ = self->priv->entry_imap_port;
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp90_ = gtk_entry_get_text (_tmp89_);
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp91_ = _tmp90_;
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp92_ = string_strip (_tmp91_);
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp93_ = _tmp92_;
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp94_ = atoi (_tmp93_);
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_imap_server_port (_tmp88_, (guint16) _tmp94_);
#line 235 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp93_);
#line 236 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp95_ = self->priv->_account_information;
#line 236 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp96_ = self->priv->combo_imap_encryption;
#line 236 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp97_ = gtk_combo_box_get_active (_tmp96_);
#line 236 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp98_ = _tmp97_;
#line 236 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_imap_server_ssl (_tmp95_, _tmp98_ == ((gint) LOGIN_DIALOG_ENCRYPTION_SSL));
#line 237 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp99_ = self->priv->_account_information;
#line 237 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp100_ = self->priv->combo_imap_encryption;
#line 237 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp101_ = gtk_combo_box_get_active (_tmp100_);
#line 237 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp102_ = _tmp101_;
#line 237 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_imap_server_starttls (_tmp99_, _tmp102_ == ((gint) LOGIN_DIALOG_ENCRYPTION_STARTTLS));
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp103_ = self->priv->_account_information;
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp104_ = self->priv->entry_smtp_host;
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp105_ = gtk_entry_get_text (_tmp104_);
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp106_ = _tmp105_;
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp107_ = string_strip (_tmp106_);
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp108_ = _tmp107_;
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_smtp_server_host (_tmp103_, _tmp108_);
#line 238 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp108_);
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp109_ = self->priv->_account_information;
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp110_ = self->priv->entry_smtp_port;
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp111_ = gtk_entry_get_text (_tmp110_);
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp112_ = _tmp111_;
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp113_ = string_strip (_tmp112_);
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp114_ = _tmp113_;
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp115_ = atoi (_tmp114_);
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_smtp_server_port (_tmp109_, (guint16) _tmp115_);
#line 239 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp114_);
#line 240 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp116_ = self->priv->_account_information;
#line 240 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp117_ = self->priv->combo_smtp_encryption;
#line 240 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp118_ = gtk_combo_box_get_active (_tmp117_);
#line 240 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp119_ = _tmp118_;
#line 240 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_smtp_server_ssl (_tmp116_, _tmp119_ == ((gint) LOGIN_DIALOG_ENCRYPTION_SSL));
#line 241 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp120_ = self->priv->_account_information;
#line 241 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp121_ = self->priv->combo_smtp_encryption;
#line 241 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp122_ = gtk_combo_box_get_active (_tmp121_);
#line 241 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp123_ = _tmp122_;
#line 241 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	geary_account_information_set_default_smtp_server_starttls (_tmp120_, _tmp123_ == ((gint) LOGIN_DIALOG_ENCRYPTION_STARTTLS));
#line 243 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_on_changed (self);
#line 245 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp124_ = self->priv->dialog;
#line 245 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp124_, GTK_TYPE_WIDGET, GtkWidget));
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	result = TRUE;
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_geary_credentials_unref0 (smtp_credentials);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (smtp_password);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (smtp_username);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp35_);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_geary_credentials_unref0 (imap_credentials);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (imap_password);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (imap_username);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp11_);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (email);
#line 246 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return result;
#line 2076 "login-dialog.c"
}


static void login_dialog_on_email_changed (LoginDialog* self) {
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 250 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 251 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->entry_imap_username;
#line 251 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = self->priv->entry_email;
#line 251 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 251 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = _tmp2_;
#line 251 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 252 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = self->priv->entry_smtp_username;
#line 252 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp5_ = self->priv->entry_email;
#line 252 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 252 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp7_ = _tmp6_;
#line 252 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp4_, _tmp7_);
#line 2111 "login-dialog.c"
}


static void login_dialog_on_password_changed (LoginDialog* self) {
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 256 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 257 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->entry_imap_password;
#line 257 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = self->priv->entry_password;
#line 257 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 257 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = _tmp2_;
#line 257 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 258 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = self->priv->entry_smtp_password;
#line 258 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp5_ = self->priv->entry_password;
#line 258 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 258 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp7_ = _tmp6_;
#line 258 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp4_, _tmp7_);
#line 2146 "login-dialog.c"
}


static void login_dialog_on_service_changed (LoginDialog* self) {
	GearyServiceProvider _tmp0_ = 0;
#line 261 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 262 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = login_dialog_get_service_provider (self);
#line 262 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp0_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 2158 "login-dialog.c"
		GtkLabel* _tmp1_;
		GtkEntry* _tmp2_;
		GtkCheckButton* _tmp3_;
		const gchar* _tmp4_ = NULL;
		GtkAlignment* _tmp5_;
#line 263 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp1_ = self->priv->label_password;
#line 263 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WIDGET, GtkWidget));
#line 264 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp2_ = self->priv->entry_password;
#line 264 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GTK_TYPE_WIDGET, GtkWidget));
#line 265 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp3_ = self->priv->check_remember_password;
#line 265 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp4_ = _ ("Re_member passwords");
#line 265 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GTK_TYPE_BUTTON, GtkButton), _tmp4_);
#line 266 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp5_ = self->priv->other_info;
#line 266 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GTK_TYPE_WIDGET, GtkWidget));
#line 2182 "login-dialog.c"
	} else {
		GtkLabel* _tmp6_;
		GtkEntry* _tmp7_;
		GtkCheckButton* _tmp8_;
		const gchar* _tmp9_ = NULL;
		GtkAlignment* _tmp10_;
		GtkDialog* _tmp11_;
#line 268 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp6_ = self->priv->label_password;
#line 268 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_WIDGET, GtkWidget));
#line 269 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp7_ = self->priv->entry_password;
#line 269 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GTK_TYPE_WIDGET, GtkWidget));
#line 270 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp8_ = self->priv->check_remember_password;
#line 270 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp9_ = _ ("Re_member password");
#line 270 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GTK_TYPE_BUTTON, GtkButton), _tmp9_);
#line 271 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp10_ = self->priv->other_info;
#line 271 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_WIDGET, GtkWidget));
#line 272 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp11_ = self->priv->dialog;
#line 272 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		gtk_window_resize (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GTK_TYPE_WINDOW, GtkWindow), 1, 1);
#line 2212 "login-dialog.c"
	}
}


static void login_dialog_on_changed (LoginDialog* self) {
	GtkButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 276 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 277 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->ok_button;
#line 277 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = login_dialog_is_complete (self);
#line 277 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WIDGET, GtkWidget), _tmp1_);
#line 2228 "login-dialog.c"
}


static gboolean uint64_try_parse (const gchar* str, guint64* _result_) {
	guint64 _vala_result = 0ULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	guint64 _tmp2_ = 0ULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 648 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 650 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 650 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_strtoull (_tmp0_, &_tmp1_, (guint) 0);
#line 650 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	endptr = _tmp1_;
#line 650 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_vala_result = _tmp2_;
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp3_ = endptr;
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp4_ = str;
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp5_ = str;
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp6_ = strlen (_tmp5_);
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp7_ = _tmp6_;
#line 651 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_tmp3_ == (((gchar*) _tmp4_) + _tmp7_)) {
#line 652 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		result = TRUE;
#line 652 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		if (_result_) {
#line 652 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2272 "login-dialog.c"
		}
#line 652 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return result;
#line 2276 "login-dialog.c"
	} else {
#line 654 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		result = FALSE;
#line 654 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		if (_result_) {
#line 654 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2284 "login-dialog.c"
		}
#line 654 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		return result;
#line 2288 "login-dialog.c"
	}
#line 648 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	if (_result_) {
#line 648 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
		*_result_ = _vala_result;
#line 2294 "login-dialog.c"
	}
}


static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_ = 0ULL;
#line 645 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 646 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 646 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
#line 646 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 646 "/usr/share/vala-0.18/vapi/glib-2.0.vapi"
	return result;
#line 2313 "login-dialog.c"
}


static void login_dialog_on_port_insert_text (LoginDialog* self, GtkEditable* e, const gchar* text, gint length, gint* position) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp8_;
#line 280 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 280 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (GTK_IS_EDITABLE (e));
#line 280 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (text != NULL);
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = text;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = uint64_try_parse (_tmp1_, NULL);
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (!_tmp2_) {
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp0_ = TRUE;
#line 2336 "login-dialog.c"
	} else {
		GtkEditable* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		guint64 _tmp6_ = 0ULL;
		guint16 _tmp7_;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp3_ = e;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GTK_TYPE_ENTRY, GtkEntry));
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp5_ = _tmp4_;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp6_ = uint64_parse (_tmp5_);
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp7_ = G_MAXUINT16;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp0_ = _tmp6_ > ((guint64) _tmp7_);
#line 2355 "login-dialog.c"
	}
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp8_ = _tmp0_;
#line 282 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp8_) {
#line 2361 "login-dialog.c"
		GtkEditable* _tmp9_;
#line 283 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp9_ = e;
#line 283 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_signal_stop_emission_by_name (_tmp9_, "insert-text");
#line 2367 "login-dialog.c"
	} else {
		GtkEditable* _tmp10_;
		GtkEntry* _tmp11_;
#line 285 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp10_ = e;
#line 285 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		_tmp11_ = self->priv->entry_imap_port;
#line 285 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		if (_tmp10_ == _tmp11_) {
#line 286 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			self->priv->edited_imap_port = TRUE;
#line 2379 "login-dialog.c"
		} else {
			GtkEditable* _tmp12_;
			GtkEntry* _tmp13_;
#line 287 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp12_ = e;
#line 287 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp13_ = self->priv->entry_smtp_port;
#line 287 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp12_ == _tmp13_) {
#line 288 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				self->priv->edited_smtp_port = TRUE;
#line 2391 "login-dialog.c"
			}
		}
	}
}


static void login_dialog_on_imap_encryption_changed (LoginDialog* self) {
	gboolean _tmp0_;
	GtkEntry* _tmp1_;
	guint16 _tmp2_ = 0U;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 292 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 293 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->edited_imap_port;
#line 293 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp0_) {
#line 294 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return;
#line 2412 "login-dialog.c"
	}
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = self->priv->entry_imap_port;
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = login_dialog_get_default_imap_port (self);
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = g_strdup_printf ("%hu", _tmp2_);
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = _tmp3_;
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp1_, _tmp4_);
#line 296 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp4_);
#line 297 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->edited_imap_port = FALSE;
#line 2428 "login-dialog.c"
}


static guint16 login_dialog_get_default_imap_port (LoginDialog* self) {
	guint16 result = 0U;
	GtkComboBox* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 300 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), 0U);
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->combo_imap_encryption;
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = _tmp1_;
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	switch (_tmp2_) {
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_SSL:
#line 2449 "login-dialog.c"
		{
#line 303 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			result = GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_PORT_SSL;
#line 303 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return result;
#line 2455 "login-dialog.c"
		}
		default:
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_NONE:
#line 301 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_STARTTLS:
#line 2462 "login-dialog.c"
		{
#line 308 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			result = GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_PORT;
#line 308 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return result;
#line 2468 "login-dialog.c"
		}
	}
}


static void login_dialog_on_smtp_encryption_changed (LoginDialog* self) {
	gboolean _tmp0_;
	GtkEntry* _tmp1_;
	guint16 _tmp2_ = 0U;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 312 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 313 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->edited_smtp_port;
#line 313 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (_tmp0_) {
#line 314 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return;
#line 2488 "login-dialog.c"
	}
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = self->priv->entry_smtp_port;
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = login_dialog_get_default_smtp_port (self);
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = g_strdup_printf ("%hu", _tmp2_);
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = _tmp3_;
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	gtk_entry_set_text (_tmp1_, _tmp4_);
#line 316 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_free0 (_tmp4_);
#line 317 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->edited_smtp_port = FALSE;
#line 2504 "login-dialog.c"
}


static guint16 login_dialog_get_default_smtp_port (LoginDialog* self) {
	guint16 result = 0U;
	GtkComboBox* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 320 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), 0U);
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->combo_smtp_encryption;
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = _tmp1_;
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	switch (_tmp2_) {
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_SSL:
#line 2525 "login-dialog.c"
		{
#line 323 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT_SSL;
#line 323 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return result;
#line 2531 "login-dialog.c"
		}
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_STARTTLS:
#line 2535 "login-dialog.c"
		{
#line 326 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT_STARTTLS;
#line 326 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return result;
#line 2541 "login-dialog.c"
		}
		default:
#line 321 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case LOGIN_DIALOG_ENCRYPTION_NONE:
#line 2546 "login-dialog.c"
		{
#line 330 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT;
#line 330 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return result;
#line 2552 "login-dialog.c"
		}
	}
}


static GearyServiceProvider login_dialog_get_service_provider (LoginDialog* self) {
	GearyServiceProvider result = 0;
	GtkComboBoxText* _tmp0_;
	gint _tmp1_ = 0;
#line 334 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), 0);
#line 335 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->combo_service;
#line 335 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_COMBO_BOX, GtkComboBox));
#line 335 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	result = (GearyServiceProvider) _tmp1_;
#line 335 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return result;
#line 2572 "login-dialog.c"
}


static gboolean login_dialog_is_valid_port (LoginDialog* self, const gchar* text) {
	gboolean result = FALSE;
	guint64 port = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_ = 0ULL;
	gboolean _tmp2_ = FALSE;
	guint64 _tmp3_;
	guint16 _tmp4_;
#line 338 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), FALSE);
#line 338 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 340 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = text;
#line 340 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp2_ = uint64_try_parse (_tmp0_, &_tmp1_);
#line 340 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	port = _tmp1_;
#line 340 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (!_tmp2_) {
#line 341 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		result = FALSE;
#line 341 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return result;
#line 2600 "login-dialog.c"
	}
#line 343 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp3_ = port;
#line 343 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp4_ = G_MAXUINT16;
#line 343 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	result = _tmp3_ <= ((guint64) _tmp4_);
#line 343 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return result;
#line 2610 "login-dialog.c"
}


static gboolean login_dialog_is_complete (LoginDialog* self) {
	gboolean result = FALSE;
	GearyServiceProvider _tmp0_ = 0;
#line 346 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), FALSE);
#line 347 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = login_dialog_get_service_provider (self);
#line 347 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	switch (_tmp0_) {
#line 347 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		case GEARY_SERVICE_PROVIDER_OTHER:
#line 2625 "login-dialog.c"
		{
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			GtkEntry* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp19_;
			gboolean _tmp24_;
			gboolean _tmp29_;
			gboolean _tmp34_;
			gboolean _tmp39_;
			gboolean _tmp44_;
			gboolean _tmp49_;
			gboolean _tmp54_;
			gboolean _tmp59_;
			gboolean _tmp64_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp11_ = self->priv->entry_email;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp12_ = gtk_entry_get_text (_tmp11_);
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp13_ = _tmp12_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp14_ = geary_string_is_empty_or_whitespace (_tmp13_);
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp14_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp10_ = TRUE;
#line 2663 "login-dialog.c"
			} else {
				GtkEntry* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gboolean _tmp18_ = FALSE;
#line 350 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp15_ = self->priv->entry_imap_host;
#line 350 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp16_ = gtk_entry_get_text (_tmp15_);
#line 350 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp17_ = _tmp16_;
#line 350 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp18_ = geary_string_is_empty_or_whitespace (_tmp17_);
#line 350 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp10_ = _tmp18_;
#line 2679 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp19_ = _tmp10_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp19_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp9_ = TRUE;
#line 2687 "login-dialog.c"
			} else {
				GtkEntry* _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gboolean _tmp23_ = FALSE;
#line 351 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp20_ = self->priv->entry_imap_port;
#line 351 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp21_ = gtk_entry_get_text (_tmp20_);
#line 351 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp22_ = _tmp21_;
#line 351 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp23_ = geary_string_is_empty_or_whitespace (_tmp22_);
#line 351 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp9_ = _tmp23_;
#line 2703 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp24_ = _tmp9_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp24_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp8_ = TRUE;
#line 2711 "login-dialog.c"
			} else {
				GtkEntry* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_ = FALSE;
#line 352 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp25_ = self->priv->entry_imap_username;
#line 352 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp26_ = gtk_entry_get_text (_tmp25_);
#line 352 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp27_ = _tmp26_;
#line 352 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp28_ = geary_string_is_empty_or_whitespace (_tmp27_);
#line 352 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp8_ = _tmp28_;
#line 2727 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp29_ = _tmp8_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp29_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp7_ = TRUE;
#line 2735 "login-dialog.c"
			} else {
				GtkEntry* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gboolean _tmp33_ = FALSE;
#line 353 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp30_ = self->priv->entry_imap_password;
#line 353 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp31_ = gtk_entry_get_text (_tmp30_);
#line 353 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp32_ = _tmp31_;
#line 353 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp33_ = geary_string_is_empty_or_whitespace (_tmp32_);
#line 353 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp7_ = _tmp33_;
#line 2751 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp34_ = _tmp7_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp34_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp6_ = TRUE;
#line 2759 "login-dialog.c"
			} else {
				GtkEntry* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				gboolean _tmp38_ = FALSE;
#line 354 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp35_ = self->priv->entry_smtp_host;
#line 354 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp36_ = gtk_entry_get_text (_tmp35_);
#line 354 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp37_ = _tmp36_;
#line 354 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp38_ = geary_string_is_empty_or_whitespace (_tmp37_);
#line 354 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp6_ = _tmp38_;
#line 2775 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp39_ = _tmp6_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp39_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp5_ = TRUE;
#line 2783 "login-dialog.c"
			} else {
				GtkEntry* _tmp40_;
				const gchar* _tmp41_;
				const gchar* _tmp42_;
				gboolean _tmp43_ = FALSE;
#line 355 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp40_ = self->priv->entry_smtp_port;
#line 355 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp41_ = gtk_entry_get_text (_tmp40_);
#line 355 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp42_ = _tmp41_;
#line 355 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp43_ = geary_string_is_empty_or_whitespace (_tmp42_);
#line 355 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp5_ = _tmp43_;
#line 2799 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp44_ = _tmp5_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp44_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp4_ = TRUE;
#line 2807 "login-dialog.c"
			} else {
				GtkEntry* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				gboolean _tmp48_ = FALSE;
#line 356 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp45_ = self->priv->entry_smtp_username;
#line 356 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp46_ = gtk_entry_get_text (_tmp45_);
#line 356 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp47_ = _tmp46_;
#line 356 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp48_ = geary_string_is_empty_or_whitespace (_tmp47_);
#line 356 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp4_ = _tmp48_;
#line 2823 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp49_ = _tmp4_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp49_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp3_ = TRUE;
#line 2831 "login-dialog.c"
			} else {
				GtkEntry* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				gboolean _tmp53_ = FALSE;
#line 357 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp50_ = self->priv->entry_smtp_password;
#line 357 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp51_ = gtk_entry_get_text (_tmp50_);
#line 357 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp52_ = _tmp51_;
#line 357 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp53_ = geary_string_is_empty_or_whitespace (_tmp52_);
#line 357 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp3_ = _tmp53_;
#line 2847 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp54_ = _tmp3_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp54_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp2_ = TRUE;
#line 2855 "login-dialog.c"
			} else {
				GtkEntry* _tmp55_;
				const gchar* _tmp56_;
				const gchar* _tmp57_;
				gboolean _tmp58_ = FALSE;
#line 358 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp55_ = self->priv->entry_imap_port;
#line 358 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp56_ = gtk_entry_get_text (_tmp55_);
#line 358 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp57_ = _tmp56_;
#line 358 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp58_ = login_dialog_is_valid_port (self, _tmp57_);
#line 358 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp2_ = !_tmp58_;
#line 2871 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp59_ = _tmp2_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp59_) {
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp1_ = TRUE;
#line 2879 "login-dialog.c"
			} else {
				GtkEntry* _tmp60_;
				const gchar* _tmp61_;
				const gchar* _tmp62_;
				gboolean _tmp63_ = FALSE;
#line 359 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp60_ = self->priv->entry_smtp_port;
#line 359 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp61_ = gtk_entry_get_text (_tmp60_);
#line 359 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp62_ = _tmp61_;
#line 359 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp63_ = login_dialog_is_valid_port (self, _tmp62_);
#line 359 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp1_ = !_tmp63_;
#line 2895 "login-dialog.c"
			}
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp64_ = _tmp1_;
#line 349 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp64_) {
#line 360 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				result = FALSE;
#line 360 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				return result;
#line 2905 "login-dialog.c"
			}
#line 361 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			break;
#line 2909 "login-dialog.c"
		}
		default:
		{
			gboolean _tmp65_ = FALSE;
			GtkEntry* _tmp66_;
			const gchar* _tmp67_;
			const gchar* _tmp68_;
			gboolean _tmp69_ = FALSE;
			gboolean _tmp74_;
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp66_ = self->priv->entry_email;
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp67_ = gtk_entry_get_text (_tmp66_);
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp68_ = _tmp67_;
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp69_ = geary_string_is_empty_or_whitespace (_tmp68_);
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp69_) {
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp65_ = TRUE;
#line 2931 "login-dialog.c"
			} else {
				GtkEntry* _tmp70_;
				const gchar* _tmp71_;
				const gchar* _tmp72_;
				gboolean _tmp73_ = FALSE;
#line 366 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp70_ = self->priv->entry_password;
#line 366 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp71_ = gtk_entry_get_text (_tmp70_);
#line 366 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp72_ = _tmp71_;
#line 366 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp73_ = geary_string_is_empty_or_whitespace (_tmp72_);
#line 366 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				_tmp65_ = _tmp73_;
#line 2947 "login-dialog.c"
			}
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			_tmp74_ = _tmp65_;
#line 365 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			if (_tmp74_) {
#line 367 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				result = FALSE;
#line 367 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
				return result;
#line 2957 "login-dialog.c"
			}
#line 368 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			break;
#line 2961 "login-dialog.c"
		}
	}
#line 371 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	result = TRUE;
#line 371 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return result;
#line 2968 "login-dialog.c"
}


GearyAccountInformation* login_dialog_get_account_information (LoginDialog* self) {
	GearyAccountInformation* result;
	GearyAccountInformation* _tmp0_;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (IS_LOGIN_DIALOG (self), NULL);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = self->priv->_account_information;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return result;
#line 2983 "login-dialog.c"
}


static void login_dialog_set_account_information (LoginDialog* self, GearyAccountInformation* value) {
	GearyAccountInformation* _tmp0_;
	GearyAccountInformation* _tmp1_;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (IS_LOGIN_DIALOG (self));
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp0_ = value;
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->_account_information);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->_account_information = _tmp1_;
#line 3000 "login-dialog.c"
}


static void value_login_dialog_init (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	value->data[0].v_pointer = NULL;
#line 3007 "login-dialog.c"
}


static void value_login_dialog_free_value (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		login_dialog_unref (value->data[0].v_pointer);
#line 3016 "login-dialog.c"
	}
}


static void value_login_dialog_copy_value (const GValue* src_value, GValue* dest_value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		dest_value->data[0].v_pointer = login_dialog_ref (src_value->data[0].v_pointer);
#line 3026 "login-dialog.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3030 "login-dialog.c"
	}
}


static gpointer value_login_dialog_peek_pointer (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return value->data[0].v_pointer;
#line 3038 "login-dialog.c"
}


static gchar* value_login_dialog_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (collect_values[0].v_pointer) {
#line 3045 "login-dialog.c"
		LoginDialog* object;
		object = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3052 "login-dialog.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3056 "login-dialog.c"
		}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = login_dialog_ref (object);
#line 3060 "login-dialog.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 3064 "login-dialog.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return NULL;
#line 3068 "login-dialog.c"
}


static gchar* value_login_dialog_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	LoginDialog** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (!object_p) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3079 "login-dialog.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (!value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		*object_p = NULL;
#line 3085 "login-dialog.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		*object_p = value->data[0].v_pointer;
#line 3089 "login-dialog.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		*object_p = login_dialog_ref (value->data[0].v_pointer);
#line 3093 "login-dialog.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return NULL;
#line 3097 "login-dialog.c"
}


GParamSpec* param_spec_login_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecLoginDialog* spec;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LOGIN_DIALOG), NULL);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return G_PARAM_SPEC (spec);
#line 3111 "login-dialog.c"
}


gpointer value_get_login_dialog (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOGIN_DIALOG), NULL);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return value->data[0].v_pointer;
#line 3120 "login-dialog.c"
}


void value_set_login_dialog (GValue* value, gpointer v_object) {
	LoginDialog* old;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOGIN_DIALOG));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LOGIN_DIALOG));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		login_dialog_ref (value->data[0].v_pointer);
#line 3140 "login-dialog.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 3144 "login-dialog.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		login_dialog_unref (old);
#line 3150 "login-dialog.c"
	}
}


void value_take_login_dialog (GValue* value, gpointer v_object) {
	LoginDialog* old;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LOGIN_DIALOG));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LOGIN_DIALOG));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = v_object;
#line 3169 "login-dialog.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		value->data[0].v_pointer = NULL;
#line 3173 "login-dialog.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		login_dialog_unref (old);
#line 3179 "login-dialog.c"
	}
}


static void login_dialog_class_init (LoginDialogClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	login_dialog_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	LOGIN_DIALOG_CLASS (klass)->finalize = login_dialog_finalize;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_type_class_add_private (klass, sizeof (LoginDialogPrivate));
#line 3191 "login-dialog.c"
}


static void login_dialog_instance_init (LoginDialog * self) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv = LOGIN_DIALOG_GET_PRIVATE (self);
#line 42 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->edited_imap_port = FALSE;
#line 43 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->priv->edited_smtp_port = FALSE;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self->ref_count = 1;
#line 3204 "login-dialog.c"
}


static void login_dialog_finalize (LoginDialog* obj) {
	LoginDialog * self;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOGIN_DIALOG, LoginDialog);
#line 16 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->dialog);
#line 17 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_email);
#line 18 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->label_password);
#line 19 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 20 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_real_name);
#line 21 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_service);
#line 22 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 24 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->other_info);
#line 27 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_host);
#line 28 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_port);
#line 29 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_username);
#line 30 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 31 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_imap_encryption);
#line 34 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_host);
#line 35 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_port);
#line 36 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_username);
#line 37 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 38 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->combo_smtp_encryption);
#line 40 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->ok_button);
#line 45 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	_g_object_unref0 (self->priv->_account_information);
#line 3252 "login-dialog.c"
}


GType login_dialog_get_type (void) {
	static volatile gsize login_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&login_dialog_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_login_dialog_init, value_login_dialog_free_value, value_login_dialog_copy_value, value_login_dialog_peek_pointer, "p", value_login_dialog_collect_value, "p", value_login_dialog_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LoginDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LoginDialog), 0, (GInstanceInitFunc) login_dialog_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType login_dialog_type_id;
		login_dialog_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LoginDialog", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&login_dialog_type_id__volatile, login_dialog_type_id);
	}
	return login_dialog_type_id__volatile;
}


gpointer login_dialog_ref (gpointer instance) {
	LoginDialog* self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	return instance;
#line 3277 "login-dialog.c"
}


void login_dialog_unref (gpointer instance) {
	LoginDialog* self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		LOGIN_DIALOG_GET_CLASS (self)->finalize (self);
#line 8 "/builddir/build/BUILD/geary-0.2.2/src/client/dialogs/login-dialog.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3290 "login-dialog.c"
	}
}



